unit modif_1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  Menus, Buttons,pivotgauss,Unit10,Unit3,Unit_liste_reactions,Unit8,Unit2,Unit5,UnitScaleFont,
  LCLType,charencstreams,
  Unit6;


   const nombre_atomes_classification=103;
       constante_gaz_parfaits=8.314;

  type

comparaison_entre_formules_brutes=(egal,inf,sup,parmi);

atome=object
symbole:string[2];
nom:string;
numero_atomique:integer;
end;

nature_composant=(inconnu,debase,aqueux,gaz,solide,organique);
genre_organique=(acide,aminoacide,amid_amin,alcool,alc,benzene,complexe,aldehyd_cetone,non_defini_o);
sous_type=(complexe_i,acide_i,cation_simple,anion_simple,molecule,ion,non_defini);

composeur=object
coefficient:extended;
element:string;
nature:nature_composant;
indice_dans_sa_base:longint;
end;

composeur_atomique=object
coefficient:extended;
numero_atomique:integer;
end;



 array_periodique=array of atome;
 array_composeurs_atomiques=array of composeur_atomique;
   array_composeurs=array of composeur;

tableau_composeurs_atomiques=object
ensemble_composeurs:array_composeurs_atomiques;
function nombre_atomes(numero_atomique:integer):extended;
end;


element_base=object
identifiant,synonyme,representant_de:string;
masse_molaire,rayon,mu0_25:extended;
charge:integer;
conductivite:extended;
nombre_composants:integer;
composition_atomique:array_composeurs_atomiques;
st:sous_type;
end;



element_mineral=object
identifiant,synonyme:string;
masse_molaire,masse_volumique:extended;
logk_25,enthalpie,mu0_25:extended;
enthalpie_connue,identifie:boolean;
formule:string;
nombre_composants:integer;
composition:array_composeurs;
nombre_composants_atomiques:integer;
composition_atomique:array_composeurs_atomiques;
end;

element_gazeux=object
identifiant,synonyme:string;
masse_molaire:extended;
logk_25,enthalpie,mu0_25:extended;
enthalpie_connue,identifie:boolean;
formule:string;
nombre_composants:integer;
composition:array_composeurs;
nombre_composants_atomiques:integer;
composition_atomique:array_composeurs_atomiques;
end;

element_aqueux=object
identifiant,synonyme:string;
masse_molaire,rayon:extended;
logk_25,enthalpie,mu0_25:extended;
enthalpie_connue,identifie:boolean;
formule:string;
conductivite:extended;
nombre_composants,charge:integer;
composition:array_composeurs;
nombre_composants_atomiques:integer;
composition_atomique:array_composeurs_atomiques;
st:sous_type;
end;

element_organique=object
identifiant,synonyme:string;
genre:genre_organique;
masse_molaire,rayon:extended;
logk_25,enthalpie,mu0_25:extended;
enthalpie_connue,identifie:boolean;
formule:string;
conductivite:extended;
nombre_composants,charge:integer;
composition:array_composeurs;
nombre_composants_atomiques:integer;
composition_atomique:array_composeurs_atomiques;
end;

array_base=array of element_base;
array_mineraux=array of element_mineral;
array_gazeux=array of element_gazeux;
array_aqueux=array of element_aqueux;
 array_organiques=array of element_organique;

type

  { TForm1 }

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButtonSauveBase: TSpeedButton;
    SpeedButtonAjoutElement: TSpeedButton;
    SpeedButtonModifElement: TSpeedButton;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButtonAjoutElementClick(Sender: TObject);
    procedure SpeedButtonModifElementClick(Sender: TObject);
    procedure SpeedButtonSauveBaseClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
repertoire_executable:string;
  Form1: TForm1; 
 nom_base:string;
  version:integer;
  date:string;
  liste_lignes_base,liste_identifiants:tstringlist;
  var tableau_elements_base:array_base;
tableau_elements_mineraux:array_mineraux;
tableau_elements_gazeux:array_gazeux;
tableau_elements_aqueux:array_aqueux;
tableau_elements_organiques:array_organiques;
tableau_periodique:array_periodique;
mode_creation,equation_modifiee:boolean;
 {et des tableaux destines uniquement a l'affichage:}
tableau_anions_simples,tableau_cations_simples,
tableau_complexes,tableau_ab,tableau_ions,tableau_molecules:array_aqueux;
nb_anions_simples,nb_cations_simples,
nb_complexes,nb_ab,nb_ions,nb_molecules:longint;
identifiant_element_a_modifier,identifiant_element_a_supprimer:string;
nombre_elements_base:longint;
  nombre_elements_mineraux:longint;
  nombre_elements_gazeux:longint;
  nombre_elements_aqueux:longint;
   nombre_elements_organiques,nombre_elements_organiques_acide,
   nombre_elements_organiques_aminoacide,
   nombre_elements_organiques_alc,nombre_elements_organiques_alcool,
   nombre_elements_organiques_benzene,nombre_elements_organiques_complexe,
   nombre_elements_organiques_amid_amin,nombre_elements_organiques_aldehyd_cetone:longint;
   blocage_gaz,blocage_redox,blocage_solide,blocage_organique:boolean;
  var newcompo:array_composeurs_atomiques;
  new_composition:array_composeurs;
   new_nombre_composants:integer;
   new_masse_molaire:extended;
   var elements_base_presents:array of boolean;
   var elements_gazeux_presents:array of boolean;
   var elements_aqueux_presents:array of boolean;
   var elements_solides_presents:array of boolean;
   var elements_organiques_presents:array of boolean;

   function Supprime_Espece(id:string):boolean;
   function Donne_Representant(atome:string):string;
   function indice_element_base(s:string):longint;
function indice_element_gazeux(s:string):longint;
function indice_element_aqueux(s:string):longint;
function indice_element_mineral(s:string):longint;
function indice_element_organique(s:string):longint;
procedure trouve_tous_les_elements(liste:tstrings;exclus:tstringlist);
function Donne_Numero_Atomique(s:string):integer;
procedure ajoute_xfois_composeur_atomique_a_composition_atomique(x:extended;
var compo:array_composeurs_atomiques; com:composeur_atomique);
procedure ajoute_xfois_composition_atomique_a_composition_atomique
(x:extended; var somme:array_composeurs_atomiques; terme:array_composeurs_atomiques);
 function FormuleBruteExacteDeCompositionAtomique(var formulebrute:widestring;
  compo:array_composeurs_atomiques):boolean;



 {dit si un element est present dans un cmposeur atomique}
 function IsAtomePresent(numeroatomique:integer; compo:array_composeurs_atomiques):boolean;

 {donne la composition atomique a partir de la formule brute}
function CompositionAtomiqueDeFormuleBruteExacte(formulebrute:string; var compo:array_composeurs_atomiques):boolean;


  {dit si 2 compositions aotrmiques sont identiques}
  function IsCompositionAtomiqueEqualTo(compo1,compo2:array_composeurs_atomiques):boolean;
  function IsCompositionAtomiqueInfTo(compo1,compo2:array_composeurs_atomiques):boolean;
  function IsCompositionAtomiqueSupTo(compo1,compo2:array_composeurs_atomiques):boolean;
  function IsCompositionAtomiqueParmi(compo1,compo2:array_composeurs_atomiques):boolean;

{trie le comoseur par ordr de numero atomique}
procedure TrieArrayComposeurAtomique(var compo:array_composeurs_atomiques);

{fournit la liste des identifiants des reactifs de formule brute proposee}
function ReactifsDeFormuleBrute(formulebrute:string; var liste:tstringlist; exclus_gaz:boolean;
type_comparaison:comparaison_entre_formules_brutes):boolean;


{dit si un element est de base, aqueux, gazeux, minral ou organique}
function DonneNatureReactif(identifiant:string; var indice:longint):nature_composant;

{renvoie la matrice des coefficients des nombres d'atomes par elements
pour un ensemble de forumles brutes}
procedure DonneMatriceCoefficients(formules_brutes:tableaustring;
var a:matricereelle; nombre_especes:integer; var nombre_atomes:integer);

procedure lecture_base;
procedure QuickSort_base(debut, fin: integer);
procedure QuickSort_aqueux(debut, fin: integer);
procedure QuickSort_organiques(debut, fin: integer);
procedure QuickSort_mineraux(debut, fin: integer);
procedure reecrit_liste_lignes_base_dapres_tableaux;
implementation


procedure QuickSort_base(debut, fin: integer);
var pivot, gauche, droite: integer;    a,b:string;
temp:element_base;
  begin
  pivot := debut;
  gauche := debut;
  droite := fin;
    repeat
      a:=tableau_elements_base[gauche].identifiant;
    b:=tableau_elements_base[droite].identifiant;
    if a[1]='(' then a:=copy(a,2,length(a)-1);
    if b[1]='(' then b:=copy(b,2,length(b)-1);
      if ansiuppercase(a) >= ansiuppercase(b) then
    begin
      temp := tableau_elements_base[gauche];
      tableau_elements_base[gauche] := tableau_elements_base[droite];
      tableau_elements_base[droite] := temp;
      pivot := gauche + droite - pivot;
    end;
        if pivot = gauche then dec(droite) else inc(gauche);
  until gauche = droite;
  if debut < gauche - 1 then QuickSort_base(debut, gauche - 1);
  if fin > droite + 1 then QuickSort_base(droite + 1, fin);
  end;

  procedure QuickSort_aqueux(debut, fin: integer);
var pivot, gauche, droite: integer;  a,b:string;
temp:element_aqueux;
  begin

  pivot := debut;
  gauche := debut;
  droite := fin;
    repeat
      a:=tableau_elements_aqueux[gauche].identifiant;
    b:=tableau_elements_aqueux[droite].identifiant;
    if a[1]='(' then a:=copy(a,2,length(a)-1);
    if b[1]='(' then b:=copy(b,2,length(b)-1);
      if ansiuppercase(a) >= ansiuppercase(b) then
    begin
      temp := tableau_elements_aqueux[gauche];
      tableau_elements_aqueux[gauche] := tableau_elements_aqueux[droite];
      tableau_elements_aqueux[droite] := temp;
      pivot := gauche + droite - pivot;
    end;
        if pivot = gauche then dec(droite) else inc(gauche);
  until gauche = droite;
  if debut < gauche - 1 then QuickSort_aqueux(debut, gauche - 1);
  if fin > droite + 1 then QuickSort_aqueux(droite + 1, fin);
  end;

  procedure QuickSort_organiques(debut, fin: integer);
var pivot, gauche, droite: integer;  a,b:string;
temp:element_organique;
  begin
  pivot := debut;
  gauche := debut;
  droite := fin;
    repeat
   a:=tableau_elements_organiques[gauche].identifiant;
    b:=tableau_elements_organiques[droite].identifiant;
    if a[1]='(' then a:=copy(a,2,length(a)-1);
    if b[1]='(' then b:=copy(b,2,length(b)-1);
      if ansiuppercase(a) >= ansiuppercase(b) then    begin
      temp := tableau_elements_organiques[gauche];
      tableau_elements_organiques[gauche] := tableau_elements_organiques[droite];
      tableau_elements_organiques[droite] := temp;
      pivot := gauche + droite - pivot;
    end;
        if pivot = gauche then dec(droite) else inc(gauche);
  until gauche = droite;
  if debut < gauche - 1 then QuickSort_organiques(debut, gauche - 1);
  if fin > droite + 1 then QuickSort_organiques(droite + 1, fin);
  end;

  procedure QuickSort_mineraux(debut, fin: integer);
var pivot, gauche, droite: integer; a,b:string;
temp:element_mineral;
  begin

  pivot := debut;
  gauche := debut;
  droite := fin;
    repeat
    a:=tableau_elements_mineraux[gauche].identifiant;
    b:=tableau_elements_mineraux[droite].identifiant;
    if a[1]='(' then a:=copy(a,2,length(a)-1);
    if b[1]='(' then b:=copy(b,2,length(b)-1);
      if ansiuppercase(a) >= ansiuppercase(b) then
    begin
      temp := tableau_elements_mineraux[gauche];
      tableau_elements_mineraux[gauche] := tableau_elements_mineraux[droite];
      tableau_elements_mineraux[droite] := temp;
      pivot := gauche + droite - pivot;
    end;
        if pivot = gauche then dec(droite) else inc(gauche);
  until gauche = droite;
  if debut < gauche - 1 then QuickSort_mineraux(debut, gauche - 1);
  if fin > droite + 1 then QuickSort_mineraux(droite + 1, fin);
  end;

 function Supprime_Espece(id:string):boolean;
 var i,j,k,popo_debut,popo_fin:integer;
 begin
{suppression dans la liste liste_lignes_base}
 i:=0;
repeat
inc(i);
until ((i=liste_lignes_base.Count) or ((liste_lignes_base[i]=id) and
 (liste_lignes_base[i-1]='<Identifiant>')));
 if i=liste_lignes_base.Count then begin
 result:=false;
 exit;
 end;
 popo_debut:=i-2;
  repeat inc(i); until liste_lignes_base[i]='</Element>';
  popo_fin:=i;

  for i:=popo_debut to popo_fin do
   liste_lignes_base.Delete(popo_debut);

   k:=indice_element_base(id);
   if k<>0 then begin
   for i:=k to nombre_elements_base-1 do
   tableau_elements_base[i-1]:=tableau_elements_base[i];
   dec(nombre_elements_base);
   setlength(tableau_elements_base,nombre_elements_base);
      end;

      k:=indice_element_aqueux(id);
   if k<>0 then begin
   for i:=k to nombre_elements_aqueux-1 do
   tableau_elements_aqueux[i-1]:=tableau_elements_aqueux[i];
   dec(nombre_elements_aqueux);
   setlength(tableau_elements_aqueux,nombre_elements_aqueux);
      end;

     { k:=indice_element_gazeux(id);
   if k<>0 then begin
   for i:=k to nombre_elements_gazeux-1 do
   tableau_elements_gazeux[i-1]:=tableau_elements_gazeux[i];
   dec(nombre_elements_gazeux);
   setlength(tableau_elements_gazeux,nombre_elements_gazeux);
      end; }

      k:=indice_element_organique(id);
   if k<>0 then begin
   for i:=k to nombre_elements_organiques-1 do
   tableau_elements_organiques[i-1]:=tableau_elements_organiques[i];
   dec(nombre_elements_organiques);
   setlength(tableau_elements_organiques,nombre_elements_organiques);
      end;

       k:=indice_element_mineral(id);
   if k<>0 then begin
   for i:=k to nombre_elements_mineraux-1 do
   tableau_elements_mineraux[i-1]:=tableau_elements_mineraux[i];
   dec(nombre_elements_mineraux);
   setlength(tableau_elements_mineraux,nombre_elements_mineraux);
      end;



  result:=true;
 end;




function Donne_Representant(atome:string):string;
var i:integer; trouve:boolean;
begin
i:=0;
repeat
inc(i);
trouve:=(tableau_elements_base[i-1].identifiant<>'H2O') and
(tableau_elements_base[i-1].representant_de=atome);
until (i=nombre_elements_base) or (trouve);
 if trouve then result:=tableau_elements_base[i-1].identifiant else
 result:='';
end;





{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var i:integer;   toto:TCharEncStream;
begin
opendialog1.InitialDir:=extractfilepath(application.ExeName);
if not(opendialog1.Execute) then application.terminate;
nom_base:=opendialog1.FileName;
if nom_base=''  then application.terminate;
decimalseparator:='.';
setlength(tableau_elements_base,87);
setlength(tableau_elements_mineraux,1140);
setlength(tableau_elements_gazeux,119);
setlength(tableau_elements_aqueux,1333);
setlength(tableau_elements_organiques,638);
setlength(tableau_cations_simples,0);
setlength(tableau_anions_simples,0);
setlength(tableau_complexes,0);
setlength(tableau_ions,0);
setlength(tableau_molecules,0);
setlength(tableau_ab,0);
setlength(tableau_periodique,nombre_atomes_classification);
 lecture_base;


 liste_lignes_base:=tstringlist.Create;
 toto:=TCharEncStream.create;

 try
       toto.LoadFromFile(utf8tosys(nom_base));
      except
    application.MessageBox(pchar('Impossible de charger '+nom_base),
    'Hélas...',mb_ok);
    exit;
  end;


      liste_lignes_base.Text:=toto.UTF8Text;
      toto.Free;


 liste_identifiants:=tstringlist.Create;
 for i:=1 to nombre_elements_base do
  liste_identifiants.Add(tableau_elements_base[i-1].identifiant);
 for i:=1 to nombre_elements_aqueux do
  liste_identifiants.Add(tableau_elements_aqueux[i-1].identifiant);
  for i:=1 to nombre_elements_mineraux do
  liste_identifiants.Add(tableau_elements_mineraux[i-1].identifiant);
  for i:=1 to nombre_elements_organiques do
  liste_identifiants.Add(tableau_elements_organiques[i-1].identifiant);


end;

procedure TForm1.FormShow(Sender: TObject);
begin
  scalefont(self);
end;

procedure TForm1.MenuItem1Click(Sender: TObject);
begin
form10:=tform10.Create(self);
with form10
do begin
if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
end;
form10.ShowModal;
end;

procedure TForm1.MenuItem2Click(Sender: TObject);
begin

application.MessageBox(pchar('Version '+inttostr(version)+ ' du '+
date),'Version chargée',mb_ok);
end;


procedure TForm1.SpeedButton1Click(Sender: TObject);
var id,s,s1:string; i,j,k,iii,popo_debut,popo_fin:integer;
intervient,bad_syntax:boolean;
begin
choix_element:=tchoix_element.create(self);
with choix_element
do begin
if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
caption:='Espèce intervenant dans les réactions de formation:';
end;
case choix_element.ShowModal of
mrcancel: exit;
mrok: begin
if  Unit3.id3='' then exit else
id:=Unit3.id3;
end;
end;
form_liste_reactions:=tform_liste_reactions.create(self);
with form_liste_reactions do begin
if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
label1.Caption:='L''espèce '+id+' intervient dans les réactions de formation suivantes:';
stringgrid1.FixedCols:=1;
stringgrid1.ColCount:=3;

stringgrid1.Cells[0,0]:='Espèce formée';
stringgrid1.ColWidths[0]:=stringgrid1.Canvas.TextWidth('Espèce formée')+20;
stringgrid1.Cells[1,0]:='Réaction de formation';
stringgrid1.ColWidths[1]:=stringgrid1.Canvas.TextWidth('Réaction de formation')+20;
stringgrid1.Cells[2,0]:='log K=';
stringgrid1.ColWidths[2]:=stringgrid1.Canvas.TextWidth('log K=')+20;
stringgrid1.RowCount:=2;
end;
for i:=1 to nombre_elements_aqueux do begin
intervient:=(id=tableau_elements_aqueux[i-1].identifiant);
for j:=1 to tableau_elements_aqueux[i-1].nombre_composants do
if tableau_elements_aqueux[i-1].composition[j-1].element=id then
intervient:=true;
if intervient then begin
s1:='';
s:=tableau_elements_aqueux[i-1].identifiant;
for j:=1 to tableau_elements_aqueux[i-1].nombre_composants do begin
if tableau_elements_aqueux[i-1].composition[j-1].coefficient<0 then
begin
s:=s+' + ';
if tableau_elements_aqueux[i-1].composition[j-1].coefficient=-1 then
s:=s+tableau_elements_aqueux[i-1].composition[j-1].element else
s:=s+floattostr(abs(tableau_elements_aqueux[i-1].composition[j-1].coefficient))+
 tableau_elements_aqueux[i-1].composition[j-1].element;
 end;
 if tableau_elements_aqueux[i-1].composition[j-1].coefficient>0 then
 begin
 if s1<>'' then s1:=s1+' + ';
if tableau_elements_aqueux[i-1].composition[j-1].coefficient=1 then
s1:=s1+tableau_elements_aqueux[i-1].composition[j-1].element else
s1:=s1+floattostr(abs(tableau_elements_aqueux[i-1].composition[j-1].coefficient))+
 tableau_elements_aqueux[i-1].composition[j-1].element;
 end;
 end;
s:=s1+' = '+s;
 if form_liste_reactions.stringgrid1.Cells[0,1]<>'' then
 form_liste_reactions.stringgrid1.RowCount:=form_liste_reactions.stringgrid1.RowCount+1;
 form_liste_reactions.stringgrid1.Cells[0,form_liste_reactions.stringgrid1.RowCount-1]:=
 tableau_elements_aqueux[i-1].identifiant;
 if  form_liste_reactions.stringgrid1.Canvas.TextWidth(tableau_elements_aqueux[i-1].identifiant)+20
 >form_liste_reactions.stringgrid1.ColWidths[0] then
 form_liste_reactions.stringgrid1.ColWidths[0]:=
 form_liste_reactions.stringgrid1.Canvas.TextWidth(tableau_elements_aqueux[i-1].identifiant)+20;
 form_liste_reactions.stringgrid1.Cells[1,form_liste_reactions.stringgrid1.RowCount-1]:=
 s;
 if  form_liste_reactions.stringgrid1.Canvas.TextWidth(s)+20
 >form_liste_reactions.stringgrid1.ColWidths[1] then
 form_liste_reactions.stringgrid1.ColWidths[1]:=
 form_liste_reactions.stringgrid1.Canvas.TextWidth(s)+20;
 form_liste_reactions.stringgrid1.Cells[2,form_liste_reactions.stringgrid1.RowCount-1]:=
 floattostr(tableau_elements_aqueux[i-1].logk_25);
 if  form_liste_reactions.stringgrid1.Canvas.TextWidth(floattostr(tableau_elements_aqueux[i-1].logk_25))+20
 >form_liste_reactions.stringgrid1.ColWidths[2] then
 form_liste_reactions.stringgrid1.ColWidths[2]:=
 form_liste_reactions.stringgrid1.Canvas.TextWidth(floattostr(tableau_elements_aqueux[i-1].logk_25))+20;
end;
end;

for i:=1 to nombre_elements_mineraux do begin
intervient:=(id=tableau_elements_mineraux[i-1].identifiant);
for j:=1 to tableau_elements_mineraux[i-1].nombre_composants do
if tableau_elements_mineraux[i-1].composition[j-1].element=id then
intervient:=true;
if intervient then begin
s1:='';
s:=tableau_elements_mineraux[i-1].identifiant;
for j:=1 to tableau_elements_mineraux[i-1].nombre_composants do begin
if tableau_elements_mineraux[i-1].composition[j-1].coefficient<0 then
begin
s:=s+' + ';
if tableau_elements_mineraux[i-1].composition[j-1].coefficient=-1 then
s:=s+tableau_elements_mineraux[i-1].composition[j-1].element else
s:=s+floattostr(abs(tableau_elements_mineraux[i-1].composition[j-1].coefficient))+
 tableau_elements_mineraux[i-1].composition[j-1].element;
 end;
 if tableau_elements_mineraux[i-1].composition[j-1].coefficient>0 then
 begin
 if s1<>'' then s1:=s1+' + ';
if tableau_elements_mineraux[i-1].composition[j-1].coefficient=1 then
s1:=s1+tableau_elements_mineraux[i-1].composition[j-1].element else
s1:=s1+floattostr(abs(tableau_elements_mineraux[i-1].composition[j-1].coefficient))+
 tableau_elements_mineraux[i-1].composition[j-1].element;
 end;
 end;
s:=s1+' = '+s;
 if form_liste_reactions.stringgrid1.Cells[0,1]<>'' then
 form_liste_reactions.stringgrid1.RowCount:=form_liste_reactions.stringgrid1.RowCount+1;
 form_liste_reactions.stringgrid1.Cells[0,form_liste_reactions.stringgrid1.RowCount-1]:=
 tableau_elements_mineraux[i-1].identifiant;
 if  form_liste_reactions.stringgrid1.Canvas.TextWidth(tableau_elements_mineraux[i-1].identifiant)+20
 >form_liste_reactions.stringgrid1.ColWidths[0] then
 form_liste_reactions.stringgrid1.ColWidths[0]:=
 form_liste_reactions.stringgrid1.Canvas.TextWidth(tableau_elements_mineraux[i-1].identifiant)+20;
 form_liste_reactions.stringgrid1.Cells[1,form_liste_reactions.stringgrid1.RowCount-1]:=
 s;
 if  form_liste_reactions.stringgrid1.Canvas.TextWidth(s)+20
 >form_liste_reactions.stringgrid1.ColWidths[1] then
 form_liste_reactions.stringgrid1.ColWidths[1]:=
 form_liste_reactions.stringgrid1.Canvas.TextWidth(s)+20;
 form_liste_reactions.stringgrid1.Cells[2,form_liste_reactions.stringgrid1.RowCount-1]:=
 floattostr(tableau_elements_mineraux[i-1].logk_25);
 if  form_liste_reactions.stringgrid1.Canvas.TextWidth(floattostr(tableau_elements_mineraux[i-1].logk_25))+20
 >form_liste_reactions.stringgrid1.ColWidths[2] then
 form_liste_reactions.stringgrid1.ColWidths[2]:=
 form_liste_reactions.stringgrid1.Canvas.TextWidth(floattostr(tableau_elements_mineraux[i-1].logk_25))+20;
end;
end;

for i:=1 to nombre_elements_organiques do begin
intervient:=(id=tableau_elements_organiques[i-1].identifiant);
for j:=1 to tableau_elements_organiques[i-1].nombre_composants do
if tableau_elements_organiques[i-1].composition[j-1].element=id then
intervient:=true;
if intervient then begin
s1:='';
s:=tableau_elements_organiques[i-1].identifiant;
for j:=1 to tableau_elements_organiques[i-1].nombre_composants do begin
if tableau_elements_organiques[i-1].composition[j-1].coefficient<0 then
begin
s:=s+' + ';
if tableau_elements_organiques[i-1].composition[j-1].coefficient=-1 then
s:=s+tableau_elements_organiques[i-1].composition[j-1].element else
s:=s+floattostr(abs(tableau_elements_organiques[i-1].composition[j-1].coefficient))+
 tableau_elements_organiques[i-1].composition[j-1].element;
 end;
 if tableau_elements_organiques[i-1].composition[j-1].coefficient>0 then
 begin
 if s1<>'' then s1:=s1+' + ';
if tableau_elements_organiques[i-1].composition[j-1].coefficient=1 then
s1:=s1+tableau_elements_organiques[i-1].composition[j-1].element else
s1:=s1+floattostr(abs(tableau_elements_organiques[i-1].composition[j-1].coefficient))+
 tableau_elements_organiques[i-1].composition[j-1].element;
 end;
 end;
s:=s1+' = '+s;
 if form_liste_reactions.stringgrid1.Cells[0,1]<>'' then
 form_liste_reactions.stringgrid1.RowCount:=form_liste_reactions.stringgrid1.RowCount+1;
 form_liste_reactions.stringgrid1.Cells[0,form_liste_reactions.stringgrid1.RowCount-1]:=
 tableau_elements_organiques[i-1].identifiant;
 if  form_liste_reactions.stringgrid1.Canvas.TextWidth(tableau_elements_organiques[i-1].identifiant)+20
 >form_liste_reactions.stringgrid1.ColWidths[0] then
 form_liste_reactions.stringgrid1.ColWidths[0]:=
 form_liste_reactions.stringgrid1.Canvas.TextWidth(tableau_elements_organiques[i-1].identifiant)+20;
 form_liste_reactions.stringgrid1.Cells[1,form_liste_reactions.stringgrid1.RowCount-1]:=
 s;
 if  form_liste_reactions.stringgrid1.Canvas.TextWidth(s)+20
 >form_liste_reactions.stringgrid1.ColWidths[1] then
 form_liste_reactions.stringgrid1.ColWidths[1]:=
 form_liste_reactions.stringgrid1.Canvas.TextWidth(s)+20;
 form_liste_reactions.stringgrid1.Cells[2,form_liste_reactions.stringgrid1.RowCount-1]:=
 floattostr(tableau_elements_organiques[i-1].logk_25);
 if  form_liste_reactions.stringgrid1.Canvas.TextWidth(floattostr(tableau_elements_organiques[i-1].logk_25))+20
 >form_liste_reactions.stringgrid1.ColWidths[2] then
 form_liste_reactions.stringgrid1.ColWidths[2]:=
 form_liste_reactions.stringgrid1.Canvas.TextWidth(floattostr(tableau_elements_organiques[i-1].logk_25))+20;
end;
end;

if ((form_liste_reactions.stringgrid1.RowCount=1) or
((form_liste_reactions.stringgrid1.RowCount=1) and (form_liste_reactions.stringgrid1.Cells[0,1]=''))) then exit;
if form_liste_reactions.ShowModal=mrcancel then exit;

{les logk ont ete modifies: il faut valider les modif}
for iii:=1 to form_liste_reactions.stringgrid1.RowCount-1 do begin
bad_syntax:=false;
try
strtofloat(form_liste_reactions.stringgrid1.Cells[2,iii]);
except
bad_syntax:=true;
end;
if not(bad_syntax) then begin
screen.Cursor:=crhourglass;
if indice_element_aqueux(form_liste_reactions.stringgrid1.Cells[0,iii])<>0 then
tableau_elements_aqueux[indice_element_aqueux(form_liste_reactions.stringgrid1.Cells[0,iii])-1].logk_25:=
strtofloat(form_liste_reactions.stringgrid1.Cells[2,iii]) else
if indice_element_mineral(form_liste_reactions.stringgrid1.Cells[0,iii])<>0 then
tableau_elements_mineraux[indice_element_mineral(form_liste_reactions.stringgrid1.Cells[0,iii])-1].logk_25:=
strtofloat(form_liste_reactions.stringgrid1.Cells[2,iii]) else
if indice_element_organique(form_liste_reactions.stringgrid1.Cells[0,iii])<>0 then
tableau_elements_organiques[indice_element_organique(form_liste_reactions.stringgrid1.Cells[0,iii])-1].logk_25:=
strtofloat(form_liste_reactions.stringgrid1.Cells[2,iii]);
i:=0;
repeat
inc(i);
until ((liste_lignes_base[i]=form_liste_reactions.stringgrid1.Cells[0,iii]) and
 (liste_lignes_base[i-1]='<Identifiant>'));
 popo_debut:=i;
 i:=popo_debut;
 repeat
inc(i);
until  pos('</Element>',liste_lignes_base[i])<>0;
popo_fin:=i;
 i:=popo_debut;
 repeat
 inc(i);
 until
  liste_lignes_base[i]='<Log K>';
  repeat
  inc(i,2); until liste_lignes_base[i]='25';
   liste_lignes_base[i-1]:=form_liste_reactions.stringgrid1.Cells[2,iii];
end;
screen.Cursor:=crdefault;
end;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
var liste_elements_a_supprimer,liste_elements_a_supprimer_affichable:tstringlist;
 i,j,k,res:integer; trouve:boolean;
begin
choix_element:=tchoix_element.create(self);
with choix_element
do begin
if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
end;
res:=choix_element.ShowModal;
if res=mrcancel then exit;
if Unit3.id3='' then exit;
identifiant_element_a_supprimer:=Unit3.id3;
liste_elements_a_supprimer:=tstringlist.Create;
liste_elements_a_supprimer.Add(identifiant_element_a_supprimer);
liste_elements_a_supprimer_affichable:=tstringlist.Create;
liste_elements_a_supprimer_affichable.Add(identifiant_element_a_supprimer);

{recherche de toutes les especes qui seront egalement supprimees}
repeat
trouve:=false;
for i:=1 to nombre_elements_aqueux do
for j:=1 to tableau_elements_aqueux[i-1].nombre_composants do
if  liste_elements_a_supprimer.IndexOf(tableau_elements_aqueux[i-1].composition[j-1].element)<>-1
then
if  liste_elements_a_supprimer.IndexOf(tableau_elements_aqueux[i-1].identifiant)=-1 then
begin
liste_elements_a_supprimer.Add(tableau_elements_aqueux[i-1].identifiant);
liste_elements_a_supprimer_affichable.Add(tableau_elements_aqueux[i-1].identifiant);
trouve:=true;
end;

for i:=1 to nombre_elements_mineraux do
for j:=1 to tableau_elements_mineraux[i-1].nombre_composants do
if  liste_elements_a_supprimer.IndexOf(tableau_elements_mineraux[i-1].composition[j-1].element)<>-1
then
if  liste_elements_a_supprimer.IndexOf(tableau_elements_mineraux[i-1].identifiant)=-1 then
begin
liste_elements_a_supprimer.Add(tableau_elements_mineraux[i-1].identifiant);
liste_elements_a_supprimer_affichable.Add(tableau_elements_mineraux[i-1].identifiant);
trouve:=true;
end;

for i:=1 to nombre_elements_organiques do
for j:=1 to tableau_elements_organiques[i-1].nombre_composants do
if  liste_elements_a_supprimer.IndexOf(tableau_elements_organiques[i-1].composition[j-1].element)<>-1
then
if  liste_elements_a_supprimer.IndexOf(tableau_elements_organiques[i-1].identifiant)=-1 then
begin
liste_elements_a_supprimer.Add(tableau_elements_organiques[i-1].identifiant);
liste_elements_a_supprimer_affichable.Add(tableau_elements_organiques[i-1].identifiant);
trouve:=true;
end;

for i:=1 to nombre_elements_gazeux do
for j:=1 to tableau_elements_gazeux[i-1].nombre_composants do
if  liste_elements_a_supprimer.IndexOf(tableau_elements_gazeux[i-1].composition[j-1].element)<>-1
then
if  liste_elements_a_supprimer.IndexOf(tableau_elements_gazeux[i-1].identifiant)=-1 then
begin
liste_elements_a_supprimer.Add(tableau_elements_gazeux[i-1].identifiant);
liste_elements_a_supprimer_affichable.Add(tableau_elements_gazeux[i-1].identifiant);
trouve:=true;
end;

until not(trouve);

form8:=tform8.create(self);
with form8
do begin
if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
end;
form8.ListBox1.Clear;
for i:=1 to liste_elements_a_supprimer_affichable.Count do
form8.ListBox1.Items.Add(liste_elements_a_supprimer_affichable[i-1]);
if form8.ShowModal=mrcancel then exit;


for i:=1 to liste_elements_a_supprimer.Count do begin
screen.Cursor:=crhourglass;
supprime_espece(liste_elements_a_supprimer[i-1]);
k:=liste_identifiants.IndexOf(liste_elements_a_supprimer[i-1]);
if k<>-1 then liste_identifiants.Delete(k);
screen.Cursor:=crdefault;
end;



liste_elements_a_supprimer_affichable.Free;
liste_elements_a_supprimer.Free;

end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
var i:integer;

begin
screen.Cursor:=crhourglass;
quicksort_base(0,nombre_elements_base-1);
quicksort_aqueux(0,nombre_elements_aqueux-1);
 quicksort_mineraux(0,nombre_elements_mineraux-1);
quicksort_organiques(0,nombre_elements_organiques-1);
reecrit_liste_lignes_base_dapres_tableaux;
   liste_identifiants.Clear;
for i:=1 to nombre_elements_base do
  liste_identifiants.Add(tableau_elements_base[i-1].identifiant);
 for i:=1 to nombre_elements_aqueux do
  liste_identifiants.Add(tableau_elements_aqueux[i-1].identifiant);
  for i:=1 to nombre_elements_mineraux do
  liste_identifiants.Add(tableau_elements_mineraux[i-1].identifiant);
  for i:=1 to nombre_elements_organiques do
  liste_identifiants.Add(tableau_elements_organiques[i-1].identifiant);
screen.Cursor:=crdefault;
end;





procedure TForm1.SpeedButtonAjoutElementClick(Sender: TObject);
 label 111,222,1023,1024,1029;
 var  s,s1:string; i,res:integer; lili:tstringlist;
 erreur_num:boolean;
 begin
 mode_creation:=true;
modif_element:=tmodif_element.create(self);
with modif_element
do begin
if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
end;
modif_element.Show;
modif_element.Enabled:=false;
111: form5:=tform5.create(self);
with form5
do begin
if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
end;
{saisie indeitifiant}
form5.Label1.Caption:=
'Veuillez saisir l''identifiant de la nouvelle espéce:';
form5.Label2.Caption:='(il doit repérer de façon unique l''espéce)';
form5.Edit1.Text:='';
if form5.ShowModal=mrcancel then begin
modif_element.Close;
exit;
end;
if   liste_identifiants.IndexOf(form5.Edit1.Text)>=0 then begin
application.MessageBox('Identifiant déjà utilisé, il faut en changer !','Attention !',
mb_ok);
goto 111;
end;
modif_element.Edit_identifiant.Text:=
form5.Edit1.Text;
  {fin saisie identifiant}

{saisie synonyme}
form5.Label1.Caption:=
'Vous pouvez saisir un synonyme la nouvelle espéce:';
form5.Label2.Caption:='(c''est facultatif)';
form5.Edit1.Text:='';
form5.Edit1.TabOrder:=0;
if form5.ShowModal=mrcancel then modif_element.Edit_synonyme.Text:='' else
modif_element.Edit_synonyme.Text:=
form5.Edit1.Text;
{fin saisie synonyme}

{saisie formule}
form5.Label1.Caption:=
'Vous pouvez saisir une formule pour la nouvelle espéce:';
form5.Label2.Caption:='(c''est facultatif)';
form5.Edit1.Text:='';
if form5.ShowModal=mrcancel then modif_element.Edit_formule.Text:='' else
modif_element.Edit_formule.Text:=
form5.Edit1.Text;
{fin saisie formule}

{saisie formule brute}
222: form5.Label1.Caption:=
'Formule brute de la nouvelle espéce:';
form5.Label2.Caption:='(exemples: Ag2SO4  HCO3[-]   NH4[+]  CO3[2-] )';
form5.Edit1.Text:='';
if form5.ShowModal=mrcancel then begin
modif_element.Close;
exit;
end;
if not(CompositionAtomiqueDeFormuleBruteExacte(form5.Edit1.Text,
   newcompo)) then begin
 application.MessageBox('Mauvaise syntaxe, regardez les exemples !','Attention !',
mb_ok);
goto 222;
end;


s:='';  s1:='';
for i:=1 to  high(newcompo)+1 do begin
if newcompo[i-1].numero_atomique<>-1 then begin
s:=s+tableau_periodique[newcompo[i-1].numero_atomique-1].symbole;
if  newcompo[i-1].coefficient<>1 then
s:=s+floattostr(newcompo[i-1].coefficient);
if i<high(newcompo)+1 then s:=s+'';
end else begin
modif_element.SpinEdit1.Value:=round(newcompo[i-1].coefficient);
if  newcompo[i-1].coefficient>0 then
s1:=floattostr(newcompo[i-1].coefficient)+'[+]' else
s1:=floattostr(abs(newcompo[i-1].coefficient))+'[-]';
end; end;
modif_element.Edit_centesimale.Text:=s+s1;

lili:=tstringlist.Create;
if ReactifsDeFormuleBrute(form5.Edit1.Text,lili,true,egal) then
if lili.Count>0 then begin
s:='';
for i:=1 to lili.Count do
s:=s+' '+lili[i-1]+' ';
lili.Free;
if application.MessageBox(pchar('Les espèces suivantes ont déjà cette formule brute:'+s),
'Information',mb_okcancel)=idcancel then begin
modif_element.Close;
exit; end;
 end;
{fin saisie formule brute}

{type generique}
form5.Label1.Caption:='Choisissez la nature de cette espéce:';
form5.Label2.Caption:='';
form5.edit1.visible:=false;
form5.ListBox1.Items.Clear;
form5.ListBox1.Items.Add('Non solide, non organique');
form5.ListBox1.Items.Add('Non solide, organique');
if modif_element.SpinEdit1.Value=0 then
form5.ListBox1.Items.Add('Solide');
form5.ListBox1.Itemindex:=0;
form5.ListBox1.Visible:=true;
repeat
until form5.ShowModal=mrok;
case form5.ListBox1.ItemIndex of
0: modif_element.ListBox_type.ItemIndex:=0;
1: modif_element.ListBox_type.ItemIndex:=2;
2: modif_element.ListBox_type.ItemIndex:=1;
end;
{type generique}

{si solide, on rajoute (s) a l'identifiant}
if modif_element.ListBox_type.ItemIndex=1 then
if pos('(s)',modif_element.Edit_identifiant.Text)=0 then
if application.MessageBox('S''agissant d''un solide, il est commode de rajouter (s) à l''identifiant.'+
' Dois-je le faire maintenant ?','Attention...',mb_yesno)=idyes then
 modif_element.Edit_identifiant.Text:=modif_element.Edit_identifiant.Text+'(s)';

{sous type non organique}
if  modif_element.ListBox_type.ItemIndex=0 then begin
form5.Label1.Caption:='Sous-type de cette espéce:';
form5.Label2.Caption:='';
form5.edit1.visible:=false;
form5.ListBox1.Items.Clear;
form5.ListBox1.Items.Add('(Aucun)');
form5.ListBox1.Items.Add('Complexe');
form5.ListBox1.Items.Add('Acide/Base');
form5.ListBox1.Items.Add('Cation simple');
form5.ListBox1.Items.Add('Anion simple');
form5.ListBox1.Items.Add('Molécule ou atome');
form5.ListBox1.Items.Add('Ion');
form5.ListBox1.Itemindex:=0;
repeat until form5.ShowModal=mrok;
modif_element.ListBox_soustypenonorganique.ItemIndex:=
form5.ListBox1.ItemIndex;
end else
modif_element.ListBox_soustypenonorganique.ItemIndex:=0;
{du sous type non organique}

{sous type organique}
if  modif_element.ListBox_type.ItemIndex=2 then begin
form5.Label1.Caption:='Sous-type de cette espéce:';
form5.Label2.Caption:='';
form5.edit1.visible:=false;
form5.ListBox1.Items.Clear;
form5.ListBox1.Items.Add('(Aucun)');
form5.ListBox1.Items.Add('Acide carboxylique ou base associée');
form5.ListBox1.Items.Add('Aminoacide');
form5.ListBox1.Items.Add('Amide, amine');
form5.ListBox1.Items.Add('Alcool');
form5.ListBox1.Items.Add('Aromatique');
form5.ListBox1.Items.Add('Aldéhyde ou cétone');
form5.ListBox1.Items.Add('Alcane, alcéne, alcyne');
form5.ListBox1.Items.Add('Complexe à ligand organique');
form5.ListBox1.Itemindex:=0;
repeat until form5.ShowModal=mrok;
modif_element.ListBox_soustypeorganique.ItemIndex:=
form5.ListBox1.ItemIndex;
end else
modif_element.ListBox_soustypeorganique.ItemIndex:=0;
{du sous type organique}

{dans le cas d'une charge non nulle, saisie de la conductivite et du rayon}
if modif_element.SpinEdit1.Value<>0 then begin
form5.ListBox1.Enabled:=false;
form5.ListBox1.Visible:=false;
form5.Edit1.Enabled:=true;
form5.Edit1.Visible:=true;
form5.Edit1.Text:='0';
form5.Label1.Caption:='Conductivité molaire ionique à dilution infinie:';
form5.Label2.Caption:='( en 0,1mS.m²/mol )';
1023:     erreur_num:=false;
if form5.ShowModal=mrcancel then
modif_element.Edit_conductivite.Text:='0' else
try
strtofloat(form5.Edit1.Text);
except
application.MessageBox('Syntaxe erronée pour la conductivité !',
'Attention ',mb_ok);
erreur_num:=true;
end;
if erreur_num then goto 1023;
modif_element.Edit_conductivite.Text:=
form5.Edit1.Text;

 form5.Label1.Caption:='Diamètre effectif de l''ion solvaté:';
  form5.Label2.Caption:=' (en 0,1nm)';
 form5.Edit1.Text:='0';
1024:     erreur_num:=false;
if form5.ShowModal=mrcancel then
modif_element.Edit_rayon.Text:='0' else
try
strtofloat(form5.Edit1.Text);
except
application.MessageBox('Syntaxe erronée pour le diamètre !',
'Attention ',mb_ok);
erreur_num:=true;
end;
if erreur_num then goto 1024;
modif_element.Edit_rayon.Text:=
form5.Edit1.Text;
                             end else
begin
modif_element.Edit_rayon.Text:='0';
modif_element.Edit_conductivite.Text:='0';
end;
{conductivite et rayon}

{reaction de formation}
form6:=tform6.create(self);
repeat
res:=form6.ShowModal;
until ((res=mrok) or (res=mrcancel));
if res=mrcancel then begin
modif_element.Close;
exit;
end;
modif_element.Edit_reactionformation.Text:=form6.Edit1.Text;
modif_element.Edit_massemolaire.Text:=floattostr(new_masse_molaire);
 {reaction de formation}

 {log k}
  form5.Label1.Caption:='A 25°C, log K=';
  form5.Label2.Caption:='';
  form5.Edit1.Enabled:=true;
  form5.Edit1.Visible:=true;
  form5.ListBox1.Enabled:=false;
  form5.ListBox1.Visible:=false;
 form5.Edit1.Text:='';
1029:     erreur_num:=false;
if form5.ShowModal=mrcancel then
modif_element.Edit_logk.Text:='0' else
try
strtofloat(form5.Edit1.Text);
except
application.MessageBox('Syntaxe erronée pour log K !',
'Attention ',mb_ok);
erreur_num:=true;
end;
if erreur_num then goto 1029;
modif_element.Edit_logk.Text:=
form5.Edit1.Text;
{log k}

modif_element.Edit_identifiant.Enabled:=false;
modif_element.Edit_centesimale.Enabled:=false;
modif_element.Edit_reactionformation.Enabled:=false;
modif_element.SpinEdit1.Enabled:=false;
modif_element.Edit_massemolaire.Enabled:=false;
modif_element.ListBox_type.Enabled:=false;
if modif_element.ListBox_type.ItemIndex<>2 then
modif_element.ListBox_soustypeorganique.Enabled:=false;
if modif_element.ListBox_type.ItemIndex<>0 then
modif_element.ListBox_soustypenonorganique.Enabled:=false;
if modif_element.SpinEdit1.Value=0 then begin
modif_element.Edit_conductivite.Enabled:=false;
modif_element.Edit_rayon.Enabled:=false;
end;
modif_element.Enabled:=true;
 modif_element.Hide;
if modif_element.ShowModal=mrcancel then exit;

liste_lignes_base.Delete(liste_lignes_base.Count-1);
liste_lignes_base.Add('<Element>');
liste_lignes_base.Add('<Identifiant>');
liste_lignes_base.Add(modif_element.Edit_identifiant.Text);
liste_lignes_base.Add('</Identifiant>');
liste_lignes_base.Add('<Typegenerique>');
case  modif_element.ListBox_type.ItemIndex of
0:liste_lignes_base.Add('aqueux');
1: liste_lignes_base.Add('mineral');
2: liste_lignes_base.Add('organique');
3: liste_lignes_base.Add('de_base');
end;
liste_lignes_base.Add('</Typegenerique>');

if modif_element.Edit_synonyme.Text<>'' then begin
liste_lignes_base.Add('<Synonyme>');
liste_lignes_base.Add(modif_element.Edit_synonyme.Text);
liste_lignes_base.Add('</Synonyme>');
end;

if modif_element.ListBox_type.ItemIndex=0 then
if modif_element.ListBox_soustypenonorganique.ItemIndex<>0 then
begin
liste_lignes_base.Add('<Soustype>');
case modif_element.ListBox_soustypenonorganique.ItemIndex of
1: liste_lignes_base.Add('complexe');
2: liste_lignes_base.Add('acide');
3: liste_lignes_base.Add('cation_simple');
4: liste_lignes_base.Add('anion_simple');
5: liste_lignes_base.Add('molecule');
6: liste_lignes_base.Add('ion');
end;
liste_lignes_base.Add('</Soustype>');
end;

if modif_element.ListBox_type.ItemIndex=2 then
if modif_element.ListBox_soustypeorganique.ItemIndex<>0 then
begin
liste_lignes_base.Add('<Genre>');
case modif_element.ListBox_soustypeorganique.ItemIndex of
1: liste_lignes_base.Add('acide');
2: liste_lignes_base.Add('aminoacide');
3: liste_lignes_base.Add('amid_amin');
4: liste_lignes_base.Add('alcool');
5: liste_lignes_base.Add('benzene');
6: liste_lignes_base.Add('aldehyd_cetone');
7: liste_lignes_base.Add('alc');
8: liste_lignes_base.Add('complexe');
end;
liste_lignes_base.Add('</Genre>');
end;

if modif_element.SpinEdit1.Value<>0 then begin
liste_lignes_base.Add('<Charge>');
liste_lignes_base.Add(inttostr(modif_element.SpinEdit1.Value));
liste_lignes_base.Add('</Charge>');
end;

if modif_element.SpinEdit1.Value<>0 then begin
liste_lignes_base.Add('<Conductivite>');
liste_lignes_base.Add(modif_element.Edit_conductivite.Text);
liste_lignes_base.Add('</Conductivite>');
end;

if modif_element.Edit_formule.Text<>'' then begin
liste_lignes_base.Add('<Formulebrute>');
liste_lignes_base.Add(modif_element.Edit_formule.Text);
liste_lignes_base.Add('</Formulebrute>');
end;

if ((modif_element.Edit_rayon.Text<>'') and
(modif_element.Edit_rayon.Text<>'0')) then begin
liste_lignes_base.Add('<Rayon>');
liste_lignes_base.Add(modif_element.Edit_rayon.Text);
liste_lignes_base.Add('</Rayon>');
end;

liste_lignes_base.Add('<Composition>');
for i:=1 to new_nombre_composants do begin
liste_lignes_base.Add(floattostr(new_composition[i-1].coefficient));
liste_lignes_base.Add(new_composition[i-1].element);
end;
liste_lignes_base.Add('</Composition>');
  liste_lignes_base.Add('<Thermo>');
   liste_lignes_base.Add('<Log K>');
   liste_lignes_base.Add(modif_element.Edit_logk.Text);
    liste_lignes_base.Add('25');
    liste_lignes_base.Add('</Log K>');
      liste_lignes_base.Add('</Thermo>');
      liste_lignes_base.Add('</Element>');
liste_lignes_base.Add('</Base>');

 if modif_element.ListBox_type.ItemIndex=0 then begin
inc(nombre_elements_aqueux);
setlength(tableau_elements_aqueux,nombre_elements_aqueux);
tableau_elements_aqueux[nombre_elements_aqueux-1].identifiant:=
modif_element.Edit_identifiant.Text;
tableau_elements_aqueux[nombre_elements_aqueux-1].synonyme:=
modif_element.Edit_synonyme.Text;
tableau_elements_aqueux[nombre_elements_aqueux-1].masse_molaire:=
strtofloat(modif_element.Edit_massemolaire.Text);
if modif_element.Edit_rayon.Text<>'' then
tableau_elements_aqueux[nombre_elements_aqueux-1].rayon:=
strtofloat(modif_element.Edit_rayon.Text) else
tableau_elements_aqueux[nombre_elements_aqueux-1].rayon:=0;
tableau_elements_aqueux[nombre_elements_aqueux-1].logk_25:=
strtofloat(modif_element.Edit_logk.Text);
tableau_elements_aqueux[nombre_elements_aqueux-1].enthalpie:=0;
tableau_elements_aqueux[nombre_elements_aqueux-1].mu0_25:=0;
tableau_elements_aqueux[nombre_elements_aqueux-1].enthalpie_connue:=true;
tableau_elements_aqueux[nombre_elements_aqueux-1].identifie:=true;
tableau_elements_aqueux[nombre_elements_aqueux-1].formule:=
modif_element.Edit_formule.Text;
if modif_element.Edit_conductivite.Text<>'' then
tableau_elements_aqueux[nombre_elements_aqueux-1].conductivite:=
strtofloat(modif_element.Edit_conductivite.Text) else
tableau_elements_aqueux[nombre_elements_aqueux-1].conductivite:=0;
tableau_elements_aqueux[nombre_elements_aqueux-1].nombre_composants:=
new_nombre_composants;
setlength(tableau_elements_aqueux[nombre_elements_aqueux-1].composition,
new_nombre_composants);
for i:=1 to new_nombre_composants do begin
tableau_elements_aqueux[nombre_elements_aqueux-1].composition[i-1].coefficient:=
new_composition[i-1].coefficient;
tableau_elements_aqueux[nombre_elements_aqueux-1].composition[i-1].element:=
new_composition[i-1].element;
tableau_elements_aqueux[nombre_elements_aqueux-1].composition[i-1].indice_dans_sa_base:=
new_composition[i-1].indice_dans_sa_base;
tableau_elements_aqueux[nombre_elements_aqueux-1].composition[i-1].nature:=
new_composition[i-1].nature;
end;
tableau_elements_aqueux[nombre_elements_aqueux-1].nombre_composants_atomiques:=
high(newcompo)+1;
setlength(tableau_elements_aqueux[nombre_elements_aqueux-1].composition_atomique,
high(newcompo)+1);
for i:=1 to high(newcompo)+1 do begin
 tableau_elements_aqueux[nombre_elements_aqueux-1].composition_atomique[i-1].coefficient:=
 newcompo[i-1].coefficient;
 tableau_elements_aqueux[nombre_elements_aqueux-1].composition_atomique[i-1].numero_atomique:=
 newcompo[i-1].numero_atomique;
 end;
tableau_elements_aqueux[nombre_elements_aqueux-1].charge:=
modif_element.SpinEdit1.Value;
case modif_element.ListBox_soustypenonorganique.ItemIndex of
0: tableau_elements_aqueux[nombre_elements_aqueux-1].st:=non_defini;
1: tableau_elements_aqueux[nombre_elements_aqueux-1].st:=complexe_i;
2: tableau_elements_aqueux[nombre_elements_aqueux-1].st:=acide_i;
3: tableau_elements_aqueux[nombre_elements_aqueux-1].st:=cation_simple;
4: tableau_elements_aqueux[nombre_elements_aqueux-1].st:=anion_simple;
5: tableau_elements_aqueux[nombre_elements_aqueux-1].st:=molecule;
6: tableau_elements_aqueux[nombre_elements_aqueux-1].st:=ion;
 end;
     end;



     if modif_element.ListBox_type.ItemIndex=1 then begin
inc(nombre_elements_mineraux);
setlength(tableau_elements_mineraux,nombre_elements_mineraux);
tableau_elements_mineraux[nombre_elements_mineraux-1].identifiant:=
modif_element.Edit_identifiant.Text;
tableau_elements_mineraux[nombre_elements_mineraux-1].synonyme:=
modif_element.Edit_synonyme.Text;
tableau_elements_mineraux[nombre_elements_mineraux-1].masse_molaire:=
strtofloat(modif_element.Edit_massemolaire.Text);
tableau_elements_mineraux[nombre_elements_mineraux-1].logk_25:=
strtofloat(modif_element.Edit_logk.Text);
tableau_elements_mineraux[nombre_elements_mineraux-1].enthalpie:=0;
tableau_elements_mineraux[nombre_elements_mineraux-1].mu0_25:=0;
tableau_elements_mineraux[nombre_elements_mineraux-1].enthalpie_connue:=true;
tableau_elements_mineraux[nombre_elements_mineraux-1].identifie:=true;
tableau_elements_mineraux[nombre_elements_mineraux-1].formule:=
modif_element.Edit_formule.Text;
tableau_elements_mineraux[nombre_elements_mineraux-1].nombre_composants:=
new_nombre_composants;
setlength(tableau_elements_mineraux[nombre_elements_mineraux-1].composition,
new_nombre_composants);
for i:=1 to new_nombre_composants do begin
tableau_elements_mineraux[nombre_elements_mineraux-1].composition[i-1].coefficient:=
new_composition[i-1].coefficient;
tableau_elements_mineraux[nombre_elements_mineraux-1].composition[i-1].element:=
new_composition[i-1].element;
tableau_elements_mineraux[nombre_elements_mineraux-1].composition[i-1].indice_dans_sa_base:=
new_composition[i-1].indice_dans_sa_base;
tableau_elements_mineraux[nombre_elements_mineraux-1].composition[i-1].nature:=
new_composition[i-1].nature;
end;
tableau_elements_mineraux[nombre_elements_mineraux-1].nombre_composants_atomiques:=
high(newcompo)+1;
setlength(tableau_elements_mineraux[nombre_elements_mineraux-1].composition_atomique,
high(newcompo)+1);
for i:=1 to high(newcompo)+1 do begin
 tableau_elements_mineraux[nombre_elements_mineraux-1].composition_atomique[i-1].coefficient:=
 newcompo[i-1].coefficient;
 tableau_elements_mineraux[nombre_elements_mineraux-1].composition_atomique[i-1].numero_atomique:=
 newcompo[i-1].numero_atomique;
 end;
     end;



     if modif_element.ListBox_type.ItemIndex=2 then begin
inc(nombre_elements_organiques);
setlength(tableau_elements_organiques,nombre_elements_organiques);
tableau_elements_organiques[nombre_elements_organiques-1].identifiant:=
modif_element.Edit_identifiant.Text;
tableau_elements_organiques[nombre_elements_organiques-1].synonyme:=
modif_element.Edit_synonyme.Text;
tableau_elements_organiques[nombre_elements_organiques-1].masse_molaire:=
strtofloat(modif_element.Edit_massemolaire.Text);
if modif_element.Edit_rayon.Text<>'' then
tableau_elements_organiques[nombre_elements_organiques-1].rayon:=
strtofloat(modif_element.Edit_rayon.Text) else
tableau_elements_organiques[nombre_elements_organiques-1].rayon:=0;
tableau_elements_organiques[nombre_elements_organiques-1].logk_25:=
strtofloat(modif_element.Edit_logk.Text);
tableau_elements_organiques[nombre_elements_organiques-1].enthalpie:=0;
tableau_elements_organiques[nombre_elements_organiques-1].mu0_25:=0;
tableau_elements_organiques[nombre_elements_organiques-1].enthalpie_connue:=true;
tableau_elements_organiques[nombre_elements_organiques-1].identifie:=true;
tableau_elements_organiques[nombre_elements_organiques-1].formule:=
modif_element.Edit_formule.Text;
if modif_element.Edit_conductivite.Text<>'' then
tableau_elements_organiques[nombre_elements_organiques-1].conductivite:=
strtofloat(modif_element.Edit_conductivite.Text) else
tableau_elements_organiques[nombre_elements_organiques-1].conductivite:=0;
tableau_elements_organiques[nombre_elements_organiques-1].nombre_composants:=
new_nombre_composants;
setlength(tableau_elements_organiques[nombre_elements_organiques-1].composition,
new_nombre_composants);
for i:=1 to new_nombre_composants do begin
tableau_elements_organiques[nombre_elements_organiques-1].composition[i-1].coefficient:=
new_composition[i-1].coefficient;
tableau_elements_organiques[nombre_elements_organiques-1].composition[i-1].element:=
new_composition[i-1].element;
tableau_elements_organiques[nombre_elements_organiques-1].composition[i-1].indice_dans_sa_base:=
new_composition[i-1].indice_dans_sa_base;
tableau_elements_organiques[nombre_elements_organiques-1].composition[i-1].nature:=
new_composition[i-1].nature;
end;
tableau_elements_organiques[nombre_elements_organiques-1].nombre_composants_atomiques:=
high(newcompo)+1;
setlength(tableau_elements_organiques[nombre_elements_organiques-1].composition_atomique,
high(newcompo)+1);
for i:=1 to high(newcompo)+1 do begin
 tableau_elements_organiques[nombre_elements_organiques-1].composition_atomique[i-1].coefficient:=
 newcompo[i-1].coefficient;
 tableau_elements_organiques[nombre_elements_organiques-1].composition_atomique[i-1].numero_atomique:=
 newcompo[i-1].numero_atomique;
 end;
tableau_elements_organiques[nombre_elements_organiques-1].charge:=
modif_element.SpinEdit1.Value;
case modif_element.ListBox_soustypeorganique.ItemIndex of
0: tableau_elements_organiques[nombre_elements_organiques-1].genre:=non_defini_o;
1: tableau_elements_organiques[nombre_elements_organiques-1].genre:=acide;
2: tableau_elements_organiques[nombre_elements_organiques-1].genre:=aminoacide;
3: tableau_elements_organiques[nombre_elements_organiques-1].genre:=amid_amin;
4: tableau_elements_organiques[nombre_elements_organiques-1].genre:=alcool;
5: tableau_elements_organiques[nombre_elements_organiques-1].genre:=benzene;
6: tableau_elements_organiques[nombre_elements_organiques-1].genre:=aldehyd_cetone;
7: tableau_elements_organiques[nombre_elements_organiques-1].genre:=alc;
8: tableau_elements_organiques[nombre_elements_organiques-1].genre:=complexe;
 end;
     end;




 {mise a jour de la liste des identifiants}
 liste_identifiants.Add(modif_element.edit_identifiant.text);
end;


procedure TForm1.SpeedButtonModifElementClick(Sender: TObject);
var iii,jjj,kkk,k,i,j,popo_debut,popo_fin,popo:integer; s,s1:string;
label 999,888,666,555,889;
begin
mode_creation:=false;
equation_modifiee:=false;
choix_element:=tchoix_element.create(self);
with choix_element
do begin
if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
end;
case choix_element.ShowModal of
mrcancel: exit;
mrok: begin
if  Unit3.id3='' then exit else
identifiant_element_a_modifier:=Unit3.id3;

end;
end;

modif_element:=tmodif_element.create(self);
with modif_element
do begin
if screen.width>width then left:=(screen.width-width) div 2 else left:=0;
if screen.height>height then top:=(screen.height-height) div 2 else top:=0;
end;
modif_element.Edit_identifiant.Text:=identifiant_element_a_modifier;
 modif_element.Edit_identifiant.Enabled:=true;

k:=indice_element_base(identifiant_element_a_modifier);
if k<>0 then begin
modif_element.ListBox_type.ItemIndex:=3;
modif_element.ListBox_type.Enabled:=false;
modif_element.ListBox_soustypeorganique.ItemIndex:=0;
modif_element.ListBox_soustypeorganique.Enabled:=false;
modif_element.Edit_synonyme.Text:=tableau_elements_base[k-1].synonyme;
modif_element.Edit_massemolaire.Text:=floattostr(
tableau_elements_base[k-1].masse_molaire);
modif_element.Edit_massemolaire.Enabled:=false;
modif_element.Edit_formule.Text:=tableau_elements_base[k-1].identifiant;
modif_element.Edit_formule.Enabled:=false;
modif_element.SpinEdit1.Value:=tableau_elements_base[k-1].charge;
modif_element.SpinEdit1.Enabled:=false;
if tableau_elements_base[k-1].charge=0 then  begin
modif_element.Edit_conductivite.Enabled:=false;
modif_element.Edit_conductivite.Text:='';
modif_element.Edit_rayon.Text:='';
modif_element.Edit_rayon.Enabled:=false;
end else begin
modif_element.Edit_rayon.Text:=
floattostr(tableau_elements_base[k-1].rayon);
modif_element.Edit_conductivite.Text:=
floattostr(tableau_elements_base[k-1].conductivite);
end;
case  tableau_elements_base[k-1].st of
complexe_i:modif_element.ListBox_soustypenonorganique.ItemIndex:=1;
acide_i:modif_element.ListBox_soustypenonorganique.ItemIndex:=2;
cation_simple:modif_element.ListBox_soustypenonorganique.ItemIndex:=3;
anion_simple:modif_element.ListBox_soustypenonorganique.ItemIndex:=4;
molecule: modif_element.ListBox_soustypenonorganique.ItemIndex:=5;
ion:modif_element.ListBox_soustypenonorganique.ItemIndex:=6;
non_defini: modif_element.ListBox_soustypenonorganique.ItemIndex:=0;
end;
s:='';  s1:='';
for i:=1 to  tableau_elements_base[k-1].nombre_composants do begin
if tableau_elements_base[k-1].
composition_atomique[i-1].numero_atomique<>-1 then begin
s:=s+tableau_periodique[tableau_elements_base[k-1].
composition_atomique[i-1].numero_atomique-1].symbole;
if  tableau_elements_base[k-1].
composition_atomique[i-1].coefficient<>1 then
s:=s+floattostr(tableau_elements_base[k-1].
composition_atomique[i-1].coefficient);
if i<tableau_elements_base[k-1].nombre_composants then s:=s+' , ';
end else
if  tableau_elements_base[k-1].
composition_atomique[i-1].coefficient>0 then
s1:=' et '+floattostr(tableau_elements_base[k-1].
composition_atomique[i-1].coefficient)+'[+]' else
s1:=' et '+floattostr(abs(tableau_elements_base[k-1].
composition_atomique[i-1].coefficient))+'[-]';
end;
modif_element.Edit_centesimale.Text:=s+s1;
modif_element.Edit_centesimale.Enabled:=false;

modif_element.Edit_reactionformation.text:='Non pertinent: brique constitutive du socle de la base.';
modif_element.Edit_logk.text:='Idem';
modif_element.Edit_reactionformation.Enabled:=false;
modif_element.Edit_logk.Enabled:=false;
end;



k:=indice_element_aqueux(identifiant_element_a_modifier);
if k<>0 then begin
modif_element.ListBox_type.ItemIndex:=0;
modif_element.ListBox_type.Enabled:=false;
modif_element.ListBox_soustypeorganique.ItemIndex:=0;
modif_element.ListBox_soustypeorganique.Enabled:=false;
modif_element.Edit_synonyme.Text:=tableau_elements_aqueux[k-1].synonyme;
modif_element.Edit_massemolaire.Text:=floattostr(
tableau_elements_aqueux[k-1].masse_molaire);
modif_element.Edit_massemolaire.Enabled:=false;
modif_element.Edit_formule.Text:=tableau_elements_aqueux[k-1].formule;
modif_element.SpinEdit1.Value:=tableau_elements_aqueux[k-1].charge;
modif_element.SpinEdit1.Enabled:=false;
if tableau_elements_aqueux[k-1].charge=0 then  begin
modif_element.Edit_conductivite.Enabled:=false;
modif_element.Edit_conductivite.Text:='';
modif_element.Edit_rayon.Text:='';
modif_element.Edit_rayon.Enabled:=false;
end else begin
modif_element.Edit_rayon.Text:=
floattostr(tableau_elements_aqueux[k-1].rayon);
modif_element.Edit_conductivite.Text:=
floattostr(tableau_elements_aqueux[k-1].conductivite);
end;
case  tableau_elements_aqueux[k-1].st of
complexe_i:modif_element.ListBox_soustypenonorganique.ItemIndex:=1;
acide_i:modif_element.ListBox_soustypenonorganique.ItemIndex:=2;
cation_simple:modif_element.ListBox_soustypenonorganique.ItemIndex:=3;
anion_simple:modif_element.ListBox_soustypenonorganique.ItemIndex:=4;
molecule: modif_element.ListBox_soustypenonorganique.ItemIndex:=5;
ion:modif_element.ListBox_soustypenonorganique.ItemIndex:=6;
non_defini: modif_element.ListBox_soustypenonorganique.ItemIndex:=0;
end;
s:='';  s1:='';
for i:=1 to  tableau_elements_aqueux[k-1].nombre_composants_atomiques do begin
if tableau_elements_aqueux[k-1].
composition_atomique[i-1].numero_atomique<>-1 then begin
s:=s+tableau_periodique[tableau_elements_aqueux[k-1].
composition_atomique[i-1].numero_atomique-1].symbole;
if  tableau_elements_aqueux[k-1].
composition_atomique[i-1].coefficient<>1 then
s:=s+floattostr(tableau_elements_aqueux[k-1].
composition_atomique[i-1].coefficient);
if i<tableau_elements_aqueux[k-1].nombre_composants_atomiques then s:=s+' , ';
end else
if  tableau_elements_aqueux[k-1].
composition_atomique[i-1].coefficient>0 then
s1:=' et '+floattostr(tableau_elements_aqueux[k-1].
composition_atomique[i-1].coefficient)+'[+]' else
s1:=' et '+floattostr(abs(tableau_elements_aqueux[k-1].
composition_atomique[i-1].coefficient))+'[-]';
end;
modif_element.Edit_centesimale.Text:=s+s1;
modif_element.Edit_centesimale.Enabled:=false;

s1:='';
s:=tableau_elements_aqueux[k-1].identifiant;
for i:=1 to tableau_elements_aqueux[k-1].nombre_composants do begin
if tableau_elements_aqueux[k-1].composition[i-1].coefficient<0 then
begin
s:=s+' + ';
if tableau_elements_aqueux[k-1].composition[i-1].coefficient=-1 then
s:=s+tableau_elements_aqueux[k-1].composition[i-1].element else
s:=s+floattostr(abs(tableau_elements_aqueux[k-1].composition[i-1].coefficient))+
 tableau_elements_aqueux[k-1].composition[i-1].element;
 end;
 if tableau_elements_aqueux[k-1].composition[i-1].coefficient>0 then
 begin
 if s1<>'' then s1:=s1+' + ';
if tableau_elements_aqueux[k-1].composition[i-1].coefficient=1 then
s1:=s1+tableau_elements_aqueux[k-1].composition[i-1].element else
s1:=s1+floattostr(abs(tableau_elements_aqueux[k-1].composition[i-1].coefficient))+
 tableau_elements_aqueux[k-1].composition[i-1].element;
 end;
 end;
modif_element.Edit_reactionformation.text:=s1+' = '+s;
modif_element.Edit_logk.text:=floattostr(tableau_elements_aqueux[k-1].logk_25);
modif_element.Edit_reactionformation.Enabled:=true;
modif_element.Edit_logk.Enabled:=true;
end;



k:=indice_element_mineral(identifiant_element_a_modifier);
if k<>0 then begin
modif_element.ListBox_type.ItemIndex:=1;
modif_element.ListBox_type.Enabled:=false;
modif_element.ListBox_soustypeorganique.ItemIndex:=0;
modif_element.ListBox_soustypeorganique.Enabled:=false;
modif_element.Edit_synonyme.Text:=tableau_elements_mineraux[k-1].synonyme;
modif_element.Edit_formule.text:=tableau_elements_mineraux[k-1].formule;
modif_element.Edit_massemolaire.Text:=floattostr(
tableau_elements_mineraux[k-1].masse_molaire);
modif_element.Edit_massemolaire.Enabled:=false;
modif_element.SpinEdit1.Value:=0;
modif_element.SpinEdit1.Enabled:=false;
modif_element.Edit_conductivite.Text:='';
modif_element.Edit_conductivite.Enabled:=false;
modif_element.Edit_rayon.Text:='';
modif_element.Edit_rayon.Enabled:=false;
 modif_element.ListBox_soustypenonorganique.ItemIndex:=0;
 modif_element.ListBox_soustypenonorganique.Enabled:=false;

s:='';  s1:='';
for i:=1 to  tableau_elements_mineraux[k-1].nombre_composants_atomiques do begin
if tableau_elements_mineraux[k-1].
composition_atomique[i-1].numero_atomique<>-1 then begin
s:=s+tableau_periodique[tableau_elements_mineraux[k-1].
composition_atomique[i-1].numero_atomique-1].symbole;
if  tableau_elements_mineraux[k-1].
composition_atomique[i-1].coefficient<>1 then
s:=s+floattostr(tableau_elements_mineraux[k-1].
composition_atomique[i-1].coefficient);
if i<tableau_elements_mineraux[k-1].nombre_composants_atomiques then s:=s+' , ';
end else
if  tableau_elements_mineraux[k-1].
composition_atomique[i-1].coefficient>0 then
s1:=' et '+floattostr(tableau_elements_mineraux[k-1].
composition_atomique[i-1].coefficient)+'[+]' else
s1:=' et '+floattostr(abs(tableau_elements_mineraux[k-1].
composition_atomique[i-1].coefficient))+'[-]';
end;
modif_element.Edit_centesimale.Text:=s+s1;
modif_element.Edit_centesimale.Enabled:=false;

s1:='';
s:=tableau_elements_mineraux[k-1].identifiant;
for i:=1 to tableau_elements_mineraux[k-1].nombre_composants do begin
if tableau_elements_mineraux[k-1].composition[i-1].coefficient<0 then
begin
s:=s+' + ';
if tableau_elements_mineraux[k-1].composition[i-1].coefficient=-1 then
s:=s+tableau_elements_mineraux[k-1].composition[i-1].element else
s:=s+floattostr(abs(tableau_elements_mineraux[k-1].composition[i-1].coefficient))+
 tableau_elements_mineraux[k-1].composition[i-1].element;
 end;
 if tableau_elements_mineraux[k-1].composition[i-1].coefficient>0 then
 begin
 if s1<>'' then s1:=s1+' + ';
if tableau_elements_mineraux[k-1].composition[i-1].coefficient=1 then
s1:=s1+tableau_elements_mineraux[k-1].composition[i-1].element else
s1:=s1+floattostr(abs(tableau_elements_mineraux[k-1].composition[i-1].coefficient))+
 tableau_elements_mineraux[k-1].composition[i-1].element;
 end;
 end;
modif_element.Edit_reactionformation.text:=s1+' = '+s;
modif_element.Edit_logk.text:=floattostr(tableau_elements_mineraux[k-1].logk_25);
modif_element.Edit_reactionformation.Enabled:=true;
modif_element.Edit_logk.Enabled:=true;
end;




k:=indice_element_organique(identifiant_element_a_modifier);
if k<>0 then begin
modif_element.ListBox_type.ItemIndex:=2;
modif_element.ListBox_type.Enabled:=false;
modif_element.Edit_synonyme.Text:=tableau_elements_organiques[k-1].synonyme;
modif_element.Edit_formule.Text:=tableau_elements_organiques[k-1].formule;
modif_element.Edit_massemolaire.Text:=floattostr(
tableau_elements_organiques[k-1].masse_molaire);
modif_element.Edit_massemolaire.Enabled:=false;
modif_element.SpinEdit1.Value:=tableau_elements_organiques[k-1].charge;
modif_element.SpinEdit1.Enabled:=false;
if tableau_elements_organiques[k-1].charge=0 then  begin
modif_element.Edit_conductivite.Enabled:=false;
modif_element.Edit_conductivite.Text:='';
modif_element.Edit_rayon.Text:='';
modif_element.Edit_rayon.Enabled:=false;
end else begin
modif_element.Edit_rayon.Text:=
floattostr(tableau_elements_organiques[k-1].rayon);
modif_element.Edit_conductivite.Text:=
floattostr(tableau_elements_organiques[k-1].conductivite);
end;


modif_element.ListBox_soustypenonorganique.ItemIndex:=0;
modif_element.ListBox_soustypenonorganique.Enabled:=false;
case  tableau_elements_organiques[k-1].genre of
non_defini_o:modif_element.ListBox_soustypeorganique.ItemIndex:=0;
acide:modif_element.ListBox_soustypeorganique.ItemIndex:=1;
aminoacide:modif_element.ListBox_soustypeorganique.ItemIndex:=2;
amid_amin:modif_element.ListBox_soustypeorganique.ItemIndex:=3;
alcool:modif_element.ListBox_soustypeorganique.ItemIndex:=4;
alc:modif_element.ListBox_soustypeorganique.ItemIndex:=7;
benzene:modif_element.ListBox_soustypeorganique.ItemIndex:=5;
complexe:modif_element.ListBox_soustypeorganique.ItemIndex:=8;
aldehyd_cetone:modif_element.ListBox_soustypeorganique.ItemIndex:=6;
else
modif_element.ListBox_soustypeorganique.ItemIndex:=0;
 end;

modif_element.ListBox_soustypeorganique.Enabled:=true;
s:='';  s1:='';
for i:=1 to  tableau_elements_organiques[k-1].nombre_composants_atomiques do begin
if tableau_elements_organiques[k-1].
composition_atomique[i-1].numero_atomique<>-1 then begin
s:=s+tableau_periodique[tableau_elements_organiques[k-1].
composition_atomique[i-1].numero_atomique-1].symbole;
if  tableau_elements_organiques[k-1].
composition_atomique[i-1].coefficient<>1 then
s:=s+floattostr(tableau_elements_organiques[k-1].
composition_atomique[i-1].coefficient);
if i<tableau_elements_organiques[k-1].nombre_composants_atomiques then s:=s+' , ';
end else
if  tableau_elements_organiques[k-1].
composition_atomique[i-1].coefficient>0 then
s1:=' et '+floattostr(tableau_elements_organiques[k-1].
composition_atomique[i-1].coefficient)+'[+]' else
s1:=' et '+floattostr(abs(tableau_elements_organiques[k-1].
composition_atomique[i-1].coefficient))+'[-]';
end;
modif_element.Edit_centesimale.Text:=s+s1;
modif_element.Edit_centesimale.Enabled:=false;

s1:='';
s:=tableau_elements_organiques[k-1].identifiant;
for i:=1 to tableau_elements_organiques[k-1].nombre_composants do begin
if tableau_elements_organiques[k-1].composition[i-1].coefficient<0 then
begin
s:=s+' + ';
if tableau_elements_organiques[k-1].composition[i-1].coefficient=-1 then
s:=s+tableau_elements_organiques[k-1].composition[i-1].element else
s:=s+floattostr(abs(tableau_elements_organiques[k-1].composition[i-1].coefficient))+
 tableau_elements_organiques[k-1].composition[i-1].element;
 end;
 if tableau_elements_organiques[k-1].composition[i-1].coefficient>0 then
 begin
 if s1<>'' then s1:=s1+' + ';
if tableau_elements_organiques[k-1].composition[i-1].coefficient=1 then
s1:=s1+tableau_elements_organiques[k-1].composition[i-1].element else
s1:=s1+floattostr(abs(tableau_elements_organiques[k-1].composition[i-1].coefficient))+
 tableau_elements_organiques[k-1].composition[i-1].element;
 end;
 end;
modif_element.Edit_reactionformation.text:=s1+' = '+s;
modif_element.Edit_logk.text:=floattostr(tableau_elements_organiques[k-1].logk_25);
modif_element.Edit_reactionformation.Enabled:=true;
modif_element.Edit_logk.Enabled:=true;
end;

if modif_element.ShowModal=mrok then begin
{enregistrement des modifications}
i:=0;
repeat
inc(i);
until ((liste_lignes_base[i]=identifiant_element_a_modifier) and
 (liste_lignes_base[i-1]='<Identifiant>'));
 popo_debut:=i;
 i:=popo_debut;
 repeat
inc(i);
until  pos('</Element>',liste_lignes_base[i])<>0;
popo_fin:=i;

{cas ou on tente de changer l'identifiant}
  if modif_element.Edit_identifiant.Text<>identifiant_element_a_modifier then begin
  k:=indice_element_base(modif_element.Edit_identifiant.Text)+
  indice_element_aqueux(modif_element.Edit_identifiant.Text)
  +indice_element_organique(modif_element.Edit_identifiant.Text)+
  indice_element_mineral(modif_element.Edit_identifiant.Text);
  if k<>0 then begin
  application.MessageBox('Ce nouvel identifiant est déjà utilisé dans la base...','Hélas !',
  mb_ok);
  modif_element.Edit_identifiant.Text:=identifiant_element_a_modifier;
  end else
  begin {le nouvel idenitifant est utilisable}
  liste_lignes_base[popo_debut]:=modif_element.Edit_identifiant.Text;
  k:=indice_element_base(identifiant_element_a_modifier);
  if k<>0 then tableau_elements_base[k-1].identifiant:=modif_element.Edit_identifiant.Text else
  begin
   k:=indice_element_aqueux(identifiant_element_a_modifier);
  if k<>0 then tableau_elements_aqueux[k-1].identifiant:=modif_element.Edit_identifiant.Text else
   begin
  k:=indice_element_organique(identifiant_element_a_modifier);
  if k<>0 then tableau_elements_organiques[k-1].identifiant:=modif_element.Edit_identifiant.Text else
   begin
 k:=indice_element_mineral(identifiant_element_a_modifier);
  if k<>0 then tableau_elements_mineraux[k-1].identifiant:=modif_element.Edit_identifiant.Text;
  end;  end;  end;

  for kkk:=1 to nombre_elements_aqueux do
  for iii:=1 to tableau_elements_aqueux[kkk-1].nombre_composants do
  if  tableau_elements_aqueux[kkk-1].composition[iii-1].element=identifiant_element_a_modifier
  then tableau_elements_aqueux[kkk-1].composition[iii-1].element:=
  modif_element.Edit_identifiant.Text;

   for kkk:=1 to nombre_elements_organiques do
  for iii:=1 to tableau_elements_organiques[kkk-1].nombre_composants do
  if  tableau_elements_organiques[kkk-1].composition[iii-1].element=identifiant_element_a_modifier
  then tableau_elements_organiques[kkk-1].composition[iii-1].element:=
  modif_element.Edit_identifiant.Text;

  for kkk:=1 to nombre_elements_mineraux do
  for iii:=1 to tableau_elements_mineraux[kkk-1].nombre_composants do
  if  tableau_elements_mineraux[kkk-1].composition[iii-1].element=identifiant_element_a_modifier
  then tableau_elements_mineraux[kkk-1].composition[iii-1].element:=
  modif_element.Edit_identifiant.Text;

  while liste_lignes_base.IndexOf(identifiant_element_a_modifier)>=0 do
  liste_lignes_base[liste_lignes_base.IndexOf(identifiant_element_a_modifier)]:=
    modif_element.Edit_identifiant.Text;
  liste_identifiants[liste_identifiants.IndexOf(identifiant_element_a_modifier)]:=
   modif_element.Edit_identifiant.Text;
     identifiant_element_a_modifier:=modif_element.Edit_identifiant.Text;
  end; {du cas ou le noluvel identifiant est utilisable}
  end;
 {cas ou il y a un synonyme dans l'editeur}
 if modif_element.Edit_synonyme.Text<>'' then begin

 k:=indice_element_base(modif_element.Edit_identifiant.Text);
 if k<>0 then tableau_elements_base[k-1].synonyme:=
 modif_element.Edit_synonyme.Text else begin
 k:=indice_element_mineral(modif_element.Edit_identifiant.Text);
 if k<>0 then tableau_elements_mineraux[k-1].synonyme:=
 modif_element.Edit_synonyme.Text else begin
 k:=indice_element_aqueux(modif_element.Edit_identifiant.Text);
 if k<>0 then tableau_elements_aqueux[k-1].synonyme:=
 modif_element.Edit_synonyme.Text else begin
 k:=indice_element_organique(modif_element.Edit_identifiant.Text);
 if k<>0 then tableau_elements_organiques[k-1].synonyme:=
 modif_element.Edit_synonyme.Text;
 end; end; end;

i:=popo_debut;
repeat
inc(i);
until  ((liste_lignes_base[i]='<Synonyme>') or (i=popo_fin));
{si il y avait deja un synonyme dans la base, on le remplace}
 if i<popo_fin then begin
 liste_lignes_base[i+1]:=modif_element.Edit_synonyme.Text;
 end
 {du remplacement du synonyme}
 else
 {il n'existait pas de synonyme dans la base, on le cree}
 begin
 k:=popo_debut;
 repeat
 inc(k);
 until  liste_lignes_base[k]='</Typegenerique>';
 liste_lignes_base.Insert(k+1,'<Synonyme>');
 liste_lignes_base.Insert(k+2,modif_element.Edit_synonyme.Text);
  liste_lignes_base.Insert(k+3,'</Synonyme>');
 end;{du cas ou il faut rajouter le synonyme dans la base}
 end;  {du cas synonyme}

 {au cas ou, on recalcule popo_fin}
  i:=popo_debut;
 repeat
inc(i);
until  pos('</Element>',liste_lignes_base[i])<>0;
popo_fin:=i;

 {cas ou il y a quelque chose a formule}
 if modif_element.Edit_formule.Enabled and
 (modif_element.Edit_formule.Text<>'') then begin


 k:=indice_element_mineral(modif_element.Edit_identifiant.Text);
 if k<>0 then tableau_elements_mineraux[k-1].formule:=
 modif_element.Edit_formule.Text else begin
 k:=indice_element_aqueux(modif_element.Edit_identifiant.Text);
 if k<>0 then tableau_elements_aqueux[k-1].formule:=
 modif_element.Edit_formule.Text else begin
 k:=indice_element_organique(modif_element.Edit_identifiant.Text);
 if k<>0 then tableau_elements_organiques[k-1].formule:=
 modif_element.Edit_formule.Text;
 end; end;


i:=popo_debut;
repeat
inc(i);
until  ((liste_lignes_base[i]='<Formulebrute>') or (i=popo_fin));
{si il y avait deja une formule dans la base, on le remplace}
 if i<popo_fin then begin
 liste_lignes_base[i+1]:=modif_element.Edit_formule.Text;
 end
 {du remplacement de la formule}
 else
 {il n'existait pas de formule dans la base, on la cree}
 {elle est apres conductivite si conductivite existe,
 apres charge si charge existe,
 apres soutype si soustype existe,
 apres synonyme si synonyme existe,
 apres type generique sinon}
 begin
 k:=popo_debut;
 repeat
 inc(k);
 until  ((liste_lignes_base[k]='</Conductivite>') or (k=popo_fin));
  if k<popo_fin then   goto 999;

  k:=popo_debut;
 repeat
 inc(k);
 until  ((liste_lignes_base[k]='</Charge>') or (k=popo_fin));
  if k<popo_fin then   goto 999;

   k:=popo_debut;
 repeat
 inc(k);
 until  ((liste_lignes_base[k]='</Soustype>') or (k=popo_fin));
  if k<popo_fin then   goto 999;

   k:=popo_debut;
 repeat
 inc(k);
 until  ((liste_lignes_base[k]='</Synonyme>') or (k=popo_fin));
  if k<popo_fin then   goto 999;

  k:=popo_debut;
 repeat
 inc(k);
 until  ((liste_lignes_base[k]='</Typegenerique>') or (k=popo_fin));
  if k<popo_fin then   goto 999;


999: liste_lignes_base.Insert(k+1,'<Formulebrute>');
 liste_lignes_base.Insert(k+2,modif_element.Edit_formule.Text);
  liste_lignes_base.Insert(k+3,'</Formulebrute>');

 end;{du cas ou il faut rajouter la formule dans la base}

      end; {du cas formule}

{au cas ou, on recalcule popo_fin}
  i:=popo_debut;
 repeat
inc(i);
until  pos('</Element>',liste_lignes_base[i])<>0;
popo_fin:=i;


{modif conductivite}
 if modif_element.Edit_conductivite.Enabled then if
 modif_element.Edit_conductivite.Text<>'' then begin


 k:=indice_element_base(modif_element.Edit_identifiant.Text);
 if k<>0 then tableau_elements_base[k-1].conductivite:=
 strtofloat(modif_element.Edit_conductivite.Text) else begin
 k:=indice_element_aqueux(modif_element.Edit_identifiant.Text);
 if k<>0 then tableau_elements_aqueux[k-1].conductivite:=
 strtofloat(modif_element.Edit_conductivite.Text) else begin
 k:=indice_element_organique(modif_element.Edit_identifiant.Text);
 if k<>0 then tableau_elements_organiques[k-1].conductivite:=
 strtofloat(modif_element.Edit_conductivite.Text);
 end; end;


 i:=popo_debut;
repeat
inc(i);
until  ((liste_lignes_base[i]='<Conductivite>') or (i=popo_fin));
{si il y avait deja une conducitivte dans la base, on le remplace}
 if i<popo_fin then begin
 liste_lignes_base[i+1]:=modif_element.Edit_conductivite.Text;
 end
 {du remplacement de la conductivite}
 else
 {il n'existait pas de conductivite dans la base, on le cree}
 begin
 k:=popo_debut;
 repeat
 inc(k);
 until  ((liste_lignes_base[k]='</Charge>') or (k=popo_fin));
 if k<popo_fin then goto 888;

  k:=popo_debut;
 repeat
 inc(k);
 until  ((liste_lignes_base[k]='</Soustype>') or (k=popo_fin));
 if k<popo_fin then goto 888;

 k:=popo_debut;
 repeat
 inc(k);
 until  ((liste_lignes_base[k]='</Synonyme>') or (k=popo_fin));
 if k<popo_fin then goto 888;


  k:=popo_debut;
 repeat
 inc(k);
 until  ((liste_lignes_base[k]='</Typegenerique>') or (k=popo_fin));
 if k<popo_fin then goto 888;

 888: liste_lignes_base.Insert(k+1,'<Conductivite>');
 liste_lignes_base.Insert(k+2,modif_element.Edit_Conductivite.Text);
  liste_lignes_base.Insert(k+3,'</Conductivite>');
 end;{du cas ou il faut rajouter la Conductivite dans la base}


 end; {modification conductivite}


 {au cas ou, on recalcule popo_fin}
  i:=popo_debut;
 repeat
inc(i);
until  pos('</Element>',liste_lignes_base[i])<>0;
popo_fin:=i;



 {modif log k}
 if  indice_element_base(identifiant_element_a_modifier)=0 then
 if modif_element.edit_logk.Text<>'' then
 begin


 k:=indice_element_mineral(modif_element.Edit_identifiant.Text);
 if k<>0 then tableau_elements_mineraux[k-1].logk_25:=
 strtofloat(modif_element.Edit_logk.Text) else begin
 k:=indice_element_aqueux(modif_element.Edit_identifiant.Text);
 if k<>0 then tableau_elements_aqueux[k-1].logk_25:=
 strtofloat(modif_element.Edit_logk.Text) else begin
 k:=indice_element_organique(modif_element.Edit_identifiant.Text);
 if k<>0 then tableau_elements_organiques[k-1].logk_25:=
 strtofloat(modif_element.Edit_logk.Text);
 end; end;


 i:=popo_debut;
 repeat
 inc(i);
 until
  liste_lignes_base[i]='<Log K>';
  repeat
  inc(i,2); until liste_lignes_base[i]='25';
   liste_lignes_base[i-1]:=modif_element.Edit_logk.Text;

 end; {modif log k}

  {au cas ou, on recalcule popo_fin}
  i:=popo_debut;
 repeat
inc(i);
until  pos('</Element>',liste_lignes_base[i])<>0;
popo_fin:=i;


 {modif rayon}
 if  modif_element.Edit_rayon.Enabled then
 if modif_element.edit_rayon.Text<>'' then
 begin

 k:=indice_element_base(modif_element.Edit_identifiant.Text);
 if k<>0 then tableau_elements_base[k-1].rayon:=
 strtofloat(modif_element.Edit_rayon.Text) else begin
 k:=indice_element_aqueux(modif_element.Edit_identifiant.Text);
 if k<>0 then tableau_elements_aqueux[k-1].rayon:=
 strtofloat(modif_element.Edit_rayon.Text) else begin
 k:=indice_element_organique(modif_element.Edit_identifiant.Text);
 if k<>0 then tableau_elements_organiques[k-1].rayon:=
 strtofloat(modif_element.Edit_rayon.Text);
 end; end;


 i:=popo_debut;
 repeat
 inc(i);
 until
  ((liste_lignes_base[i]='<Rayon>') or (i=popo_fin));

 {si il y avait deja un rayon dans la base, on le remplace}
 if i<popo_fin then begin
  liste_lignes_base[i+1]:=modif_element.Edit_rayon.Text;
 end
 {du remplacement du rayon}
 else
 {il n'existait pas de rayon dans la base, on le cree}
begin
 k:=popo_debut;
 repeat
 inc(k);
 until  ((liste_lignes_base[k]='</Representant de l''element>') or (k=popo_fin));
 if k<popo_fin then goto 889;



 k:=popo_debut;
 repeat
 inc(k);
 until  ((liste_lignes_base[k]='</Conductivite>') or (k=popo_fin));
 if k<popo_fin then goto 889;

  k:=popo_debut;
 repeat
 inc(k);
 until  ((liste_lignes_base[k]='</Charge>') or (k=popo_fin));
 if k<popo_fin then goto 889;



 889: liste_lignes_base.Insert(k+1,'<Rayon>');
 liste_lignes_base.Insert(k+2,modif_element.Edit_rayon.Text);
  liste_lignes_base.Insert(k+3,'</Rayon>');
 end;{du cas ou il faut rajouter le rayon dans la base}


 end; {modif rayon}


 {au cas ou, on recalcule popo_fin}
  i:=popo_debut;
 repeat
inc(i);
until  pos('</Element>',liste_lignes_base[i])<>0;
popo_fin:=i;


  {modif sous type non orga, si <>0}

  if indice_element_aqueux(identifiant_element_a_modifier)<>0 then
 case modif_element.ListBox_soustypenonorganique.ItemIndex of
  0:tableau_elements_aqueux[indice_element_aqueux(identifiant_element_a_modifier)-1].st:=non_defini;
  1:tableau_elements_aqueux[indice_element_aqueux(identifiant_element_a_modifier)-1].st:=complexe_i;
2:tableau_elements_aqueux[indice_element_aqueux(identifiant_element_a_modifier)-1].st:=acide_i;
3:tableau_elements_aqueux[indice_element_aqueux(identifiant_element_a_modifier)-1].st:=cation_simple;
4:tableau_elements_aqueux[indice_element_aqueux(identifiant_element_a_modifier)-1].st:=anion_simple;
5:tableau_elements_aqueux[indice_element_aqueux(identifiant_element_a_modifier)-1].st:=molecule;
6:tableau_elements_aqueux[indice_element_aqueux(identifiant_element_a_modifier)-1].st:=ion;
  end;

  if indice_element_base(identifiant_element_a_modifier)<>0 then
 case modif_element.ListBox_soustypenonorganique.ItemIndex of
  0:tableau_elements_base[indice_element_base(identifiant_element_a_modifier)-1].st:=non_defini;
  1:tableau_elements_base[indice_element_base(identifiant_element_a_modifier)-1].st:=complexe_i;
2:tableau_elements_base[indice_element_base(identifiant_element_a_modifier)-1].st:=acide_i;
3:tableau_elements_base[indice_element_base(identifiant_element_a_modifier)-1].st:=cation_simple;
4:tableau_elements_base[indice_element_base(identifiant_element_a_modifier)-1].st:=anion_simple;
5:tableau_elements_base[indice_element_base(identifiant_element_a_modifier)-1].st:=molecule;
6:tableau_elements_base[indice_element_base(identifiant_element_a_modifier)-1].st:=ion;
  end;


 if   ((indice_element_aqueux(identifiant_element_a_modifier)<>0) or
  (indice_element_base(identifiant_element_a_modifier)<>0)) then

  if modif_element.ListBox_soustypenonorganique.ItemIndex<>0 then
  begin

  i:=popo_debut;
  repeat
  inc(i);
  until   ((liste_lignes_base[i]='<Soustype>') or (i=popo_fin));
  if i<popo_fin then
  case modif_element.ListBox_soustypenonorganique.ItemIndex of
  1:liste_lignes_base[i+1]:='complexe';
2:liste_lignes_base[i+1]:='acide';
3:liste_lignes_base[i+1]:='cation_simple';
4:liste_lignes_base[i+1]:='anion_simple';
5:liste_lignes_base[i+1]:='molecule';
6:liste_lignes_base[i+1]:='ion';
  end
  else
  begin
  k:=popo_debut;
  repeat
  inc(k);
  until ((liste_lignes_base[k]='</Synonyme>') or (k=popo_fin));
  if k<popo_fin then goto 666;

  k:=popo_debut;
  repeat
  inc(k);
  until ((liste_lignes_base[k]='</Typegenerique>') or (k=popo_fin));
  if k<popo_fin then goto 666;

  666:  liste_lignes_base.Insert(k+1,'<Soustype>');
  case modif_element.ListBox_soustypenonorganique.ItemIndex of
  1:liste_lignes_base.Insert(k+2,'complexe');
2:liste_lignes_base.Insert(k+2,'acide');
3:liste_lignes_base.Insert(k+2,'cation_simple');
4:liste_lignes_base.Insert(k+2,'anion_simple');
5:liste_lignes_base.Insert(k+2,'molecule');
6:liste_lignes_base.Insert(k+2,'ion');

  end;

  liste_lignes_base.Insert(k+3,'</Soustype>');

  end;
 end; {modif sous type non orga}

 {au cas ou, on recalcule popo_fin}
  i:=popo_debut;
 repeat
inc(i);
until  pos('</Element>',liste_lignes_base[i])<>0;
popo_fin:=i;


 {modif sous type non orga, si =0}
 if   ((indice_element_aqueux(identifiant_element_a_modifier)<>0) or
  (indice_element_base(identifiant_element_a_modifier)<>0)) then

  if modif_element.ListBox_soustypenonorganique.ItemIndex=0 then
  begin
   i:=popo_debut;
  repeat
  inc(i);
  until   ((liste_lignes_base[i]='<Soustype>') or (i=popo_fin));
  if i<popo_fin then   begin
   liste_lignes_base.Delete(i);
   liste_lignes_base.Delete(i);
   liste_lignes_base.Delete(i);
   end;

  end; {fin modif sous type non orga, si =0}

{au cas ou, on recalcule popo_fin}
  i:=popo_debut;
 repeat
inc(i);
until  pos('</Element>',liste_lignes_base[i])<>0;
popo_fin:=i;

   {modif sous type  orga, si <>0}


    if indice_element_organique(identifiant_element_a_modifier)<>0 then
 case modif_element.ListBox_soustypeorganique.ItemIndex of
  0:tableau_elements_organiques[indice_element_organique(identifiant_element_a_modifier)-1].genre:=
  non_defini_o;
  1:tableau_elements_organiques[indice_element_organique(identifiant_element_a_modifier)-1].genre:=
  acide;
2:tableau_elements_organiques[indice_element_organique(identifiant_element_a_modifier)-1].genre:=
aminoacide;
3:tableau_elements_organiques[indice_element_organique(identifiant_element_a_modifier)-1].genre:=
amid_amin;
4:tableau_elements_organiques[indice_element_organique(identifiant_element_a_modifier)-1].genre:=
alcool;
5:tableau_elements_organiques[indice_element_organique(identifiant_element_a_modifier)-1].genre:=
benzene;
6:tableau_elements_organiques[indice_element_organique(identifiant_element_a_modifier)-1].genre:=
aldehyd_cetone;
7:tableau_elements_organiques[indice_element_organique(identifiant_element_a_modifier)-1].genre:=
alc;
8:tableau_elements_organiques[indice_element_organique(identifiant_element_a_modifier)-1].genre:=
complexe;
  end;


 if   ((indice_element_organique(identifiant_element_a_modifier)<>0)) then

  if modif_element.ListBox_soustypeorganique.ItemIndex<>0 then
 begin
  i:=popo_debut;
  repeat
  inc(i);
  until   ((liste_lignes_base[i]='<Genre>') or (i=popo_fin));
  if i<popo_fin then
  case modif_element.ListBox_soustypeorganique.ItemIndex of
  1:liste_lignes_base[i+1]:='acide';
2:liste_lignes_base[i+1]:='aminoacide';
3:liste_lignes_base[i+1]:='amid_amin';
4:liste_lignes_base[i+1]:='alcool';
5:liste_lignes_base[i+1]:='benzene';
6:liste_lignes_base[i+1]:='aldehyd_cetone';
8:liste_lignes_base[i+1]:='complexe';
7:liste_lignes_base[i+1]:='alc';
  end
  else
  begin
  k:=popo_debut;
  repeat
  inc(k);
  until ((liste_lignes_base[k]='</Synonyme>') or (k=popo_fin));
  if k<popo_fin then goto 555;

  k:=popo_debut;
  repeat
  inc(k);
  until ((liste_lignes_base[k]='</Typegenerique>') or (k=popo_fin));
  if k<popo_fin then goto 555;

  555:  liste_lignes_base.Insert(k+1,'<Genre>');
  case modif_element.ListBox_soustypeorganique.ItemIndex of
  1:liste_lignes_base.Insert(k+2,'acide');
2:liste_lignes_base.Insert(k+2,'aminoacide');
3:liste_lignes_base.Insert(k+2,'amid_amin');
4:liste_lignes_base.Insert(k+2,'alcool');
5:liste_lignes_base.Insert(k+2,'benzene');
6:liste_lignes_base.Insert(k+2,'aldehyd_cetone');
8:liste_lignes_base.Insert(k+2,'complexe');
7:liste_lignes_base.Insert(k+2,'alc');
  end;

  liste_lignes_base.Insert(k+3,'</Genre>');

  end;
 end; {modif sous type  orga}

{au cas ou, on recalcule popo_fin}
  i:=popo_debut;
 repeat
inc(i);
until  pos('</Element>',liste_lignes_base[i])<>0;
popo_fin:=i;


 {modif sous type orga, si =0}
 if   ((indice_element_organique(identifiant_element_a_modifier)<>0)) then

  if modif_element.ListBox_soustypeorganique.ItemIndex=0 then
  begin
   i:=popo_debut;
  repeat
  inc(i);
  until   ((liste_lignes_base[i]='<Genre>') or (i=popo_fin));
  if i<popo_fin then   begin
   liste_lignes_base.Delete(i);
   liste_lignes_base.Delete(i);
   liste_lignes_base.Delete(i);
   end;

  end; {fin modif sous type orga, si =0}

  {au cas ou, on recalcule popo_fin}
  i:=popo_debut;
 repeat
inc(i);
until  pos('</Element>',liste_lignes_base[i])<>0;
popo_fin:=i;

{modif reaction de formation}
if equation_modifiee then begin
k:=indice_element_aqueux(identifiant_element_a_modifier);
if k<>0 then begin
tableau_elements_aqueux[k-1].nombre_composants:=new_nombre_composants;
setlength(tableau_elements_aqueux[k-1].composition,
new_nombre_composants);
for i:=1 to new_nombre_composants do begin
tableau_elements_aqueux[k-1].composition[i-1].coefficient:=
new_composition[i-1].coefficient;
tableau_elements_aqueux[k-1].composition[i-1].element:=
new_composition[i-1].element;
tableau_elements_aqueux[k-1].composition[i-1].indice_dans_sa_base:=
new_composition[i-1].indice_dans_sa_base;
tableau_elements_aqueux[k-1].composition[i-1].nature:=
new_composition[i-1].nature;
end; end;

k:=indice_element_mineral(identifiant_element_a_modifier);
if k<>0 then begin
tableau_elements_mineraux[k-1].nombre_composants:=new_nombre_composants;
setlength(tableau_elements_mineraux[k-1].composition,
new_nombre_composants);
for i:=1 to new_nombre_composants do begin
tableau_elements_mineraux[k-1].composition[i-1].coefficient:=
new_composition[i-1].coefficient;
tableau_elements_mineraux[k-1].composition[i-1].element:=
new_composition[i-1].element;
tableau_elements_mineraux[k-1].composition[i-1].indice_dans_sa_base:=
new_composition[i-1].indice_dans_sa_base;
tableau_elements_mineraux[k-1].composition[i-1].nature:=
new_composition[i-1].nature;
end; end;

k:=indice_element_organique(identifiant_element_a_modifier);
if k<>0 then begin
tableau_elements_organiques[k-1].nombre_composants:=new_nombre_composants;
setlength(tableau_elements_organiques[k-1].composition,
new_nombre_composants);
for i:=1 to new_nombre_composants do begin
tableau_elements_organiques[k-1].composition[i-1].coefficient:=
new_composition[i-1].coefficient;
tableau_elements_organiques[k-1].composition[i-1].element:=
new_composition[i-1].element;
tableau_elements_organiques[k-1].composition[i-1].indice_dans_sa_base:=
new_composition[i-1].indice_dans_sa_base;
tableau_elements_organiques[k-1].composition[i-1].nature:=
new_composition[i-1].nature;
end; end;

i:=popo_debut;
 repeat
inc(i);
until  pos('<Composition>',liste_lignes_base[i])<>0;
j:=i;
repeat
inc(j);
until  pos('</Composition>',liste_lignes_base[j])<>0;
for k:=1 to j-i-1 do  liste_lignes_base.Delete(i+1);
for j:=1 to new_nombre_composants do begin
liste_lignes_base.insert(i+2*j-1,floattostr(new_composition[j-1].coefficient));
liste_lignes_base.insert(i+2*j,new_composition[j-1].element);
end;
end;
{fin modif equation de reaction}
{fin enregistrement modifs}
 end;



end;

procedure TForm1.SpeedButtonSauveBaseClick(Sender: TObject);
var i:integer;

begin

if not(savedialog1.Execute) then exit;
if savedialog1.FileName='' then exit;
if fileexistsutf8(savedialog1.FileName) then
if application.MessageBox('Voulez-vous écraser la base existante ?',
'Attention',mb_okcancel)=idcancel then exit;

i:=liste_lignes_base.IndexOf('<Version>');
inc(version);
liste_lignes_base[i+1]:=inttostr(version);
i:=liste_lignes_base.IndexOf('<Date>');
date:= DateTimeToStr(Now);
liste_lignes_base[i+1]:=date;
try
liste_lignes_base.SaveToFile(savedialog1.FileName);
except
application.MessageBox('Sauvegarde impossible','Hélas',mb_ok);
end;



end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var i:integer;  el:boolean;
begin

liste_lignes_base.Free;
liste_identifiants.Free;
finalize(tableau_elements_base);
finalize(tableau_elements_mineraux);
finalize(tableau_elements_gazeux);
finalize(tableau_elements_aqueux);
finalize(tableau_elements_organiques);
finalize(tableau_cations_simples);
finalize(tableau_anions_simples);
finalize(tableau_complexes);
finalize(tableau_ions);
finalize(tableau_molecules);
finalize(tableau_ab);
 finalize(tableau_periodique);


end;

function tableau_composeurs_atomiques.nombre_atomes(numero_atomique:integer):extended;
var i:integer;
begin
if length(self.ensemble_composeurs)=0 then begin
result:=0;
exit;
end;

for i:=1 to length(self.ensemble_composeurs) do
if  ensemble_composeurs[i-1].numero_atomique=numero_atomique then begin
result:=ensemble_composeurs[i-1].coefficient;
exit;
end;
result:=0;
end;

procedure DonneMatriceCoefficients(formules_brutes:tableaustring;
var a:matricereelle; nombre_especes:integer; var nombre_atomes:integer);
var tableau_comp:array of tableau_composeurs_atomiques;
i,j,k:integer;
elements_la:tableaubooleen;
liste_elements:tableauentier;
label 512,513;

begin
setlength(elements_la,nombre_atomes_classification+1);
for i:=0 to nombre_atomes_classification do
elements_la[i]:=false;
{o correspondra a la charge}
setlength(tableau_comp,nombre_especes);
 nombre_atomes:=0;
for i:=1 to nombre_especes do  begin
CompositionAtomiqueDeFormuleBruteExacte(formules_brutes[i-1],
   tableau_comp[i-1].ensemble_composeurs);
TrieArrayComposeurAtomique(tableau_comp[i-1].ensemble_composeurs);
end;

 for i:=1 to nombre_atomes_classification do
  begin
 for j:=1 to nombre_especes do
 if  tableau_comp[j-1].nombre_atomes(i)<>0 then
    begin
    elements_la[i]:=true;
    inc(nombre_atomes);
    setlength(liste_elements,nombre_atomes);
    liste_elements[nombre_atomes-1]:=i;
    goto 512;
    end;
 512: end;

 for j:=1 to nombre_especes do
 if  tableau_comp[j-1].nombre_atomes(-1)<>0 then
    begin
    elements_la[0]:=true;
    inc(nombre_atomes);
     setlength(liste_elements,nombre_atomes);
    liste_elements[nombre_atomes-1]:=-1;
    goto 513;
    end;
 513:
  if nombre_atomes=0 then begin
  setlength(a,0,nombre_especes);
  exit
  end;

  setlength(a,nombre_atomes,nombre_especes);
   for i:=1 to nombre_especes do
   for j:=1 to nombre_atomes do
   a[j-1,i-1]:=tableau_comp[i-1].nombre_atomes(liste_elements[j-1]);




finalize(tableau_comp);
finalize(liste_elements);
finalize(elements_la);
end;

function DonneNatureReactif(identifiant:string; var indice:longint):nature_composant;
var k:longint;
begin
k:=indice_element_base(identifiant);
if k<>0 then begin
 indice:=k;
  DonneNatureReactif:=debase;
  exit;
  end;
 k:=indice_element_aqueux(identifiant);
if k<>0 then begin
 indice:=k;
  DonneNatureReactif:=aqueux;
  exit;
  end;
{k:=indice_element_gazeux(identifiant);
if k<>0 then begin
 indice:=k;
  DonneNatureReactif:=gaz;
  exit;
  end;  }
k:=indice_element_mineral(identifiant);
if k<>0 then begin
 indice:=k;
  DonneNatureReactif:=solide;
  exit;
  end;
 k:=indice_element_organique(identifiant);
if k<>0 then begin
 indice:=k;
  DonneNatureReactif:=organique;
  exit;
  end;
  DonneNatureReactif:=inconnu;
  indice:=0;
  end;



function ReactifsDeFormuleBrute(formulebrute:string; var liste:tstringlist; exclus_gaz:boolean;
type_comparaison:comparaison_entre_formules_brutes):boolean;
var compo:array_composeurs_atomiques;   i:integer;
begin
setlength(compo,0);  liste.Clear;
 result:=CompositionAtomiqueDeFormuleBruteExacte(formulebrute,compo);
case type_comparaison of

egal: begin
 for i:=1 to   nombre_elements_base do
 if   IsCompositionAtomiqueEqualTo(compo,tableau_elements_base[i-1].composition_atomique) then
liste.Add(tableau_elements_base[i-1].identifiant);
 for i:=1 to   nombre_elements_mineraux do
 if   IsCompositionAtomiqueEqualTo(compo,tableau_elements_mineraux[i-1].composition_atomique) then
liste.Add(tableau_elements_mineraux[i-1].identifiant);
 for i:=1 to   nombre_elements_aqueux do
 if   IsCompositionAtomiqueEqualTo(compo,tableau_elements_aqueux[i-1].composition_atomique) then
liste.Add(tableau_elements_aqueux[i-1].identifiant);
if not(exclus_gaz) then for i:=1 to   nombre_elements_gazeux do
 if   IsCompositionAtomiqueEqualTo(compo,tableau_elements_gazeux[i-1].composition_atomique) then
liste.Add(tableau_elements_gazeux[i-1].identifiant);
for i:=1 to   nombre_elements_organiques do
 if   IsCompositionAtomiqueEqualTo(compo,tableau_elements_organiques[i-1].composition_atomique) then
liste.Add(tableau_elements_organiques[i-1].identifiant);
end;

sup: begin
 for i:=1 to   nombre_elements_base do
 if   IsCompositionAtomiqueInfTo(compo,tableau_elements_base[i-1].composition_atomique) then
liste.Add(tableau_elements_base[i-1].identifiant);
 for i:=1 to   nombre_elements_mineraux do
 if   IsCompositionAtomiqueInfTo(compo,tableau_elements_mineraux[i-1].composition_atomique) then
liste.Add(tableau_elements_mineraux[i-1].identifiant);
 for i:=1 to   nombre_elements_aqueux do
 if   IsCompositionAtomiqueInfTo(compo,tableau_elements_aqueux[i-1].composition_atomique) then
liste.Add(tableau_elements_aqueux[i-1].identifiant);
if not(exclus_gaz) then for i:=1 to   nombre_elements_gazeux do
 if   IsCompositionAtomiqueInfTo(compo,tableau_elements_gazeux[i-1].composition_atomique) then
liste.Add(tableau_elements_gazeux[i-1].identifiant);
for i:=1 to   nombre_elements_organiques do
 if   IsCompositionAtomiqueInfTo(compo,tableau_elements_organiques[i-1].composition_atomique) then
liste.Add(tableau_elements_organiques[i-1].identifiant);
end;

inf: begin
 for i:=1 to   nombre_elements_base do
 if   IsCompositionAtomiqueSupTo(compo,tableau_elements_base[i-1].composition_atomique) then
liste.Add(tableau_elements_base[i-1].identifiant);
 for i:=1 to   nombre_elements_mineraux do
 if   IsCompositionAtomiqueSupTo(compo,tableau_elements_mineraux[i-1].composition_atomique) then
liste.Add(tableau_elements_mineraux[i-1].identifiant);
 for i:=1 to   nombre_elements_aqueux do
 if   IsCompositionAtomiqueSupTo(compo,tableau_elements_aqueux[i-1].composition_atomique) then
liste.Add(tableau_elements_aqueux[i-1].identifiant);
if not(exclus_gaz) then for i:=1 to   nombre_elements_gazeux do
 if   IsCompositionAtomiqueSupTo(compo,tableau_elements_gazeux[i-1].composition_atomique) then
liste.Add(tableau_elements_gazeux[i-1].identifiant);
for i:=1 to   nombre_elements_organiques do
 if   IsCompositionAtomiqueSupTo(compo,tableau_elements_organiques[i-1].composition_atomique) then
liste.Add(tableau_elements_organiques[i-1].identifiant);
end;

parmi: begin
 for i:=1 to   nombre_elements_base do
 if   IsCompositionAtomiqueParmi(compo,tableau_elements_base[i-1].composition_atomique) then
liste.Add(tableau_elements_base[i-1].identifiant);
 for i:=1 to   nombre_elements_mineraux do
 if   IsCompositionAtomiqueParmi(compo,tableau_elements_mineraux[i-1].composition_atomique) then
liste.Add(tableau_elements_mineraux[i-1].identifiant);
 for i:=1 to   nombre_elements_aqueux do
 if   IsCompositionAtomiqueParmi(compo,tableau_elements_aqueux[i-1].composition_atomique) then
liste.Add(tableau_elements_aqueux[i-1].identifiant);
if not(exclus_gaz) then for i:=1 to   nombre_elements_gazeux do
 if   IsCompositionAtomiqueParmi(compo,tableau_elements_gazeux[i-1].composition_atomique) then
liste.Add(tableau_elements_gazeux[i-1].identifiant);
for i:=1 to   nombre_elements_organiques do
 if   IsCompositionAtomiqueParmi(compo,tableau_elements_organiques[i-1].composition_atomique) then
liste.Add(tableau_elements_organiques[i-1].identifiant);
end;
end;



 finalize(compo);
 end;


procedure TrieArrayComposeurAtomique(var compo:array_composeurs_atomiques);
var templiste:tstringlist;  i:integer;  tt:string;
begin
if length(compo)=0 then exit;
templiste:=TStringList.Create;
templiste.Sorted:=false;
try
for i:=1 to length(compo) do  begin
tt:=inttostr(compo[i-1].numero_atomique);
if tt='-1' then tt:='000' else
if length(tt)=1 then tt:='00'+tt else
if length(tt)=2 then tt:='0'+tt;
templiste.Add(tt+floattostr(compo[i-1].coefficient));
 end;
 templiste.sort;
 for i:=1 to length(compo) do begin
 if (copy(templiste[i-1],1,3)='000') then compo[i-1].numero_atomique:=-1 else
 compo[i-1].numero_atomique:=strtoint(copy(templiste[i-1],1,3));
 compo[i-1].coefficient:=strtofloat(copy(templiste[i-1],4,length(templiste[i-1])-3));
 end;
finally
  templiste.Free;
  end;
end;


function IsCompositionAtomiqueEqualTo(compo1,compo2:array_composeurs_atomiques):boolean;
var i:integer;
begin
if length(compo1)<>length(compo2) then begin
 IsCompositionAtomiqueEqualTo:=false;
 exit;
 end;
 for i:=1 to length(compo1) do
 if ((compo1[i-1].numero_atomique<>compo2[i-1].numero_atomique) or
  (compo1[i-1].coefficient<>compo2[i-1].coefficient)) then begin
   IsCompositionAtomiqueEqualTo:=false;
 exit;
 end;
  IsCompositionAtomiqueEqualTo:=true;
end;

function IsCompositionAtomiqueInfTo(compo1,compo2:array_composeurs_atomiques):boolean;
var i:integer; coco1,coco2:array_composeurs_atomiques;
begin
if ((length(compo1)=0) or (length(compo2)=0)) then begin
   IsCompositionAtomiqueInfTo:=false;
 exit;
 end;

if compo1[0].numero_atomique=-1 then begin
setlength(coco1,length(compo1)-1);
for i:=1 to length(coco1) do
coco1[i-1]:=compo1[i];
end else begin
setlength(coco1,length(compo1));
for i:=1 to length(coco1) do
coco1[i-1]:=compo1[i-1];  end;

if compo2[0].numero_atomique=-1 then begin
setlength(coco2,length(compo2)-1);
for i:=1 to length(coco2) do
coco2[i-1]:=compo2[i];
end else begin
setlength(coco2,length(compo2));
for i:=1 to length(coco2) do
coco2[i-1]:=compo2[i-1];  end;

 if length(coco1)<>length(coco2) then begin
   IsCompositionAtomiqueInfTo:=false;
   finalize(coco1); finalize(coco2);
 exit;
 end;

 for i:=1 to length(coco1) do
 if ((coco1[i-1].numero_atomique<>coco2[i-1].numero_atomique) or
((coco1[i-1].numero_atomique=coco2[i-1].numero_atomique)  and
  (coco1[i-1].coefficient>coco2[i-1].coefficient))) then begin
   IsCompositionAtomiqueInfTo:=false;
   finalize(coco1); finalize(coco2);
 exit;
 end;
 finalize(coco1); finalize(coco2);
  IsCompositionAtomiqueInfTo:=true;
end;

function IsCompositionAtomiqueSupTo(compo1,compo2:array_composeurs_atomiques):boolean;
var i:integer; coco1,coco2:array_composeurs_atomiques;
begin
if ((length(compo1)=0) or (length(compo2)=0)) then begin
   IsCompositionAtomiqueSupTo:=false;
 exit;
 end;

if compo1[0].numero_atomique=-1 then begin
setlength(coco1,length(compo1)-1);
for i:=1 to length(coco1) do
coco1[i-1]:=compo1[i];
end else begin
setlength(coco1,length(compo1));
for i:=1 to length(coco1) do
coco1[i-1]:=compo1[i-1];  end;

if compo2[0].numero_atomique=-1 then begin
setlength(coco2,length(compo2)-1);
for i:=1 to length(coco2) do
coco2[i-1]:=compo2[i];
end else begin
setlength(coco2,length(compo2));
for i:=1 to length(coco2) do
coco2[i-1]:=compo2[i-1];   end;

 if length(coco1)<>length(coco2) then begin
 finalize(coco1); finalize(coco2);
   IsCompositionAtomiqueSupTo:=false;
 exit;
 end;

 for i:=1 to length(coco1) do
 if ((coco1[i-1].numero_atomique<>coco2[i-1].numero_atomique) or
((coco1[i-1].numero_atomique=coco2[i-1].numero_atomique)  and
  (coco1[i-1].coefficient<coco2[i-1].coefficient))) then begin
   IsCompositionAtomiqueSupTo:=false;
   finalize(coco1); finalize(coco2);
 exit;
 end;
 finalize(coco1); finalize(coco2);
  IsCompositionAtomiqueSupTo:=true;
end;

function IsCompositionAtomiqueParmi(compo1,compo2:array_composeurs_atomiques):boolean;
var i:integer; coco1,coco2:array_composeurs_atomiques;
begin
if ((length(compo1)=0) or (length(compo2)=0)) then begin
   IsCompositionAtomiqueParmi:=false;
 exit;
 end;

if compo1[0].numero_atomique=-1 then begin
setlength(coco1,length(compo1)-1);
for i:=1 to length(coco1) do
coco1[i-1]:=compo1[i];
end else begin
setlength(coco1,length(compo1));
for i:=1 to length(coco1) do
coco1[i-1]:=compo1[i-1];  end;

if compo2[0].numero_atomique=-1 then begin
setlength(coco2,length(compo2)-1);
for i:=1 to length(coco2) do
coco2[i-1]:=compo2[i];
end else begin
setlength(coco2,length(compo2));
for i:=1 to length(coco2) do
coco2[i-1]:=compo2[i-1];  end;

 if length(coco1)<>length(coco2) then begin
 finalize(coco1); finalize(coco2);
   IsCompositionAtomiqueParmi:=false;
 exit;
 end;

 for i:=1 to length(coco1) do
 if ((coco1[i-1].numero_atomique<>coco2[i-1].numero_atomique)) then begin
 finalize(coco1); finalize(coco2);
   IsCompositionAtomiqueParmi:=false;
 exit;
 end;
 finalize(coco1); finalize(coco2);
  IsCompositionAtomiqueParmi:=true;
end;

 function IsAtomePresent(numeroatomique:integer; compo:array_composeurs_atomiques):boolean;
 var i:integer; bibi:boolean;
 begin
 bibi:=false;
 for i:=1 to length(compo) do bibi:=bibi or (compo[i-1].numero_atomique=numeroatomique);
 result:=bibi;
 end;


  function FormuleBruteExacteDeCompositionAtomique(var formulebrute:widestring;
  compo:array_composeurs_atomiques):boolean;
   var i,j:integer; s,t:string;
   begin
  s:=''; t:='';
  for i:=1 to high(compo)+1 do begin
  if compo[i-1].numero_atomique<>-1 then
  begin
  s:=s+tableau_periodique[compo[i-1].numero_atomique-1].symbole;
  if compo[i-1].coefficient<>1 then s:=s+floattostr(compo[i-1].coefficient);
  end else begin
  if compo[i-1].coefficient<0 then
  if compo[i-1].coefficient=-1 then t:='[-]' else
  t:='['+floattostr(abs(compo[i-1].coefficient))+'-]';
   if compo[i-1].coefficient>0 then
  if compo[i-1].coefficient=1 then t:='[+]' else
  t:='['+floattostr(abs(compo[i-1].coefficient))+'+]';
  end;
  formulebrute:=s+t;
  result:=true;
  end;
    end;

  function CompositionAtomiqueDeFormuleBruteExacte(formulebrute:string;
   var compo:array_composeurs_atomiques):boolean;
 var riri:string;  i,j:integer;   essai:extended;   coco:composeur_atomique;
 label 111,444;
 begin
  CompositionAtomiqueDeFormuleBruteExacte:=true;
      setlength(compo,0);
      if formulebrute='' then begin
      CompositionAtomiqueDeFormuleBruteExacte:=false;
          exit;
     end;

    i:=1;

   111:

    if  not( (formulebrute[i] in ['A'..'Z'])
    or (formulebrute[i]='[')) then begin
     CompositionAtomiqueDeFormuleBruteExacte:=false;
     setlength(compo,0);
     exit;
     end;



    if  ((formulebrute[i] in ['A'..'Z']) and (i=length(formulebrute))) then
     begin
    if Donne_Numero_Atomique(formulebrute[i])=0 then begin
     CompositionAtomiqueDeFormuleBruteExacte:=false;
     setlength(compo,0);
     exit;
     end;
     coco.coefficient:=1;
     coco.numero_atomique:=Donne_Numero_Atomique(formulebrute[i]);
     ajoute_xfois_composeur_atomique_a_composition_atomique(1,compo,coco);
     goto 444;
     end;


       if  ((formulebrute[i] in ['A'..'Z']) and (i+1=length(formulebrute)) and
      (formulebrute[i+1] in ['a'..'z']) ) then
     begin
    if Donne_Numero_Atomique(formulebrute[i]+formulebrute[i+1])=0 then begin
    CompositionAtomiqueDeFormuleBruteExacte:=false;
     setlength(compo,0);
     exit;
     end;
     coco.coefficient:=1;
     coco.numero_atomique:=Donne_Numero_Atomique(formulebrute[i]+formulebrute[i+1]);
     ajoute_xfois_composeur_atomique_a_composition_atomique(1,compo,coco);
     goto 444;
     end;


     if  ((formulebrute[i] in ['A'..'Z']) and ((formulebrute[i+1] in ['A'..'Z'])
     or (formulebrute[i+1]='['))) then
     begin
    if Donne_Numero_Atomique(formulebrute[i])=0 then begin
     CompositionAtomiqueDeFormuleBruteExacte:=false;
     setlength(compo,0);
     exit;
     end;
      coco.coefficient:=1;
     coco.numero_atomique:=Donne_Numero_Atomique(formulebrute[i]);
     ajoute_xfois_composeur_atomique_a_composition_atomique(1,compo,coco);
     inc(i);
     goto 111;
     end;


      if  ((formulebrute[i] in ['A'..'Z']) and (formulebrute[i+1] in ['a'..'z']) and
      ( (formulebrute[i+2] in ['A'..'Z']) or (formulebrute[i+2]='['))) then
     begin
    if Donne_Numero_Atomique(formulebrute[i]+formulebrute[i+1])=0 then begin
     CompositionAtomiqueDeFormuleBruteExacte:=false;
     setlength(compo,0);
     exit;
     end;
      coco.coefficient:=1;
     coco.numero_atomique:=Donne_Numero_Atomique(formulebrute[i]+formulebrute[i+1]);
     ajoute_xfois_composeur_atomique_a_composition_atomique(1,compo,coco);
     inc(i,2);
     goto 111;
     end;


      if  ((formulebrute[i] in ['A'..'Z']) and (formulebrute[i+1] in ['a'..'z']) and
     not( (formulebrute[i+2] in ['A'..'Z']) or (formulebrute[i+2] in ['0'..'9'])
     or (formulebrute[i+2]='[')) ) then
     begin
       CompositionAtomiqueDeFormuleBruteExacte:=false;
     setlength(compo,0);
     exit;
     end;

     if  ((formulebrute[i] in ['A'..'Z']) and not(
     (formulebrute[i+1] in ['a'..'z']) or (formulebrute[i+1] in ['0'..'9'])
     or (formulebrute[i+1]='['))) then
     begin
     CompositionAtomiqueDeFormuleBruteExacte:=false;
     setlength(compo,0);
     exit;
     end;


     {indication de la charge: doit etre de la forme:
     [-], [2-], [+], [2+], etc...et doit etre placee a la fin}
     if formulebrute[i]='[' then begin
     if formulebrute[length(formulebrute)]<>']' then begin
      CompositionAtomiqueDeFormuleBruteExacte:=false;
     setlength(compo,0);
     exit;
     end;
     {cas d'une charge negative}
     if formulebrute[length(formulebrute)-1]='-' then begin
     if length(formulebrute)=i+2 then begin
     {charge du type [-]}
     coco.coefficient:=-1;
     coco.numero_atomique:=-1;
     ajoute_xfois_composeur_atomique_a_composition_atomique(1,compo,coco);
     goto 444;
     end;
     {charge du type [n-]}
     riri:=copy(formulebrute,i+1,length(formulebrute)-i-2);
     try
     strtoint(riri);
     except
      CompositionAtomiqueDeFormuleBruteExacte:=false;
     setlength(compo,0);
     exit;
     end;
      coco.coefficient:=-strtoint(riri);
     coco.numero_atomique:=-1;
     ajoute_xfois_composeur_atomique_a_composition_atomique(1,compo,coco);
     goto 444;
     end;


     {cas d'une charge positive}
     if formulebrute[length(formulebrute)-1]='+' then begin
     if length(formulebrute)=i+2 then begin
     {charge du type [-]}
     coco.coefficient:=1;
     coco.numero_atomique:=-1;
     ajoute_xfois_composeur_atomique_a_composition_atomique(1,compo,coco);
     goto 444;
     end;
     {charge du type [n+]}
     riri:=copy(formulebrute,i+1,length(formulebrute)-i-2);
     try
     strtoint(riri);
     except
      CompositionAtomiqueDeFormuleBruteExacte:=false;
     setlength(compo,0);
     exit;
     end;
      coco.coefficient:=strtoint(riri);
     coco.numero_atomique:=-1;
     ajoute_xfois_composeur_atomique_a_composition_atomique(1,compo,coco);
     goto 444;
     end;
    end;
    {fin analyze charge}

     {cas ou le nom de l'element fait 1 seul caractere}
     if  ((formulebrute[i] in ['A'..'Z']) and (formulebrute[i+1] in ['0'..'9'])) then
     begin
    if Donne_Numero_Atomique(formulebrute[i])=0 then begin
    CompositionAtomiqueDeFormuleBruteExacte:=false;
     setlength(compo,0);
     exit;
     end;
     {element existant, on cherche le coefficient}
     {si la chaine finit juste apres:}
     if (i+1=length(formulebrute))then begin
     if (strtofloat(formulebrute[i+1])>0)  then begin
     coco.coefficient:=strtofloat(formulebrute[i+1]);
     coco.numero_atomique:=Donne_Numero_Atomique(formulebrute[i]);
     ajoute_xfois_composeur_atomique_a_composition_atomique(1,compo,coco);
     end;
     goto 444;
     end;
     j:=1;
     while((i+1+j<=length(formulebrute)) and not ((formulebrute[i+1+j] in ['A'..'Z'])
      or (formulebrute[i+j+1]='[')))
     do inc(j);
     try
      essai:=strtofloat(copy(formulebrute,i+1,j));
      except
     CompositionAtomiqueDeFormuleBruteExacte:=false;
       setlength(compo,0);
     exit
     end;
     if essai>0 then begin
     coco.coefficient:=essai;
     coco.numero_atomique:=Donne_Numero_Atomique(formulebrute[i]);
     ajoute_xfois_composeur_atomique_a_composition_atomique(1,compo,coco);
     end;
       i:=i+j+1;
       if i>length(formulebrute) then goto 444;
     goto 111;
      end;

      {cas ou le nom de l'element fait 2 caracteres}
     if  ((formulebrute[i] in ['A'..'Z']) and (formulebrute[i+2] in ['0'..'9'])
      and (formulebrute[i+1] in ['a'..'z'])) then
     begin
    if Donne_Numero_Atomique(formulebrute[i]+formulebrute[i+1])=0 then begin
     CompositionAtomiqueDeFormuleBruteExacte:=false;
     setlength(compo,0);
     exit;
     end;
     {element existant, on cherche le coefficient}
     {si la chaine finit juste apres:}
     if i+2=length(formulebrute) then begin
     if strtofloat(formulebrute[i+2])>0 then begin
     coco.coefficient:=strtofloat(formulebrute[i+2]);
     coco.numero_atomique:=Donne_Numero_Atomique(formulebrute[i]+formulebrute[i+1]);
     ajoute_xfois_composeur_atomique_a_composition_atomique(1,compo,coco);
     end;
     goto 444;
     end;
     j:=1;
     while((i+2+j<=length(formulebrute)) and not(
     (formulebrute[i+2+j] in ['A'..'Z']) or (formulebrute[i+2+j]='[')))
     do inc(j);
     try
      essai:=strtofloat(copy(formulebrute,i+2,j));
      except
      CompositionAtomiqueDeFormuleBruteExacte:=false;
       setlength(compo,0);
     exit
     end;
     if essai>0 then begin
      coco.coefficient:=essai;
     coco.numero_atomique:=Donne_Numero_Atomique(formulebrute[i]+formulebrute[i+1]);
     ajoute_xfois_composeur_atomique_a_composition_atomique(1,compo,coco);
      end;
       i:=i+j+2;
      if i>length(formulebrute) then goto 444;
     goto 111;
      end;




    444: TrieArrayComposeurAtomique(compo);
    end;



    procedure ajoute_xfois_composeur_atomique_a_composition_atomique(x:extended;
var compo:array_composeurs_atomiques; com:composeur_atomique);
   var i:integer;   label 110;
begin
for i:=1 to length(compo) do
if compo[i-1].numero_atomique=com.numero_atomique then begin
compo[i-1].coefficient:=compo[i-1].coefficient+com.coefficient*x;
if compo[i-1].coefficient=0 then goto 110; exit; end;
setlength(compo,length(compo)+1);
compo[length(compo)-1].coefficient:=com.coefficient*x;
compo[length(compo)-1].numero_atomique:=com.numero_atomique;
exit;
{cas ou un element disparait de la composition}
110:
if i=length(compo) then begin
setlength(compo, length(compo)-1);
exit;
end else begin
compo[i-1].coefficient:=compo[length(compo)-1].coefficient;
compo[i-1].numero_atomique:=compo[length(compo)-1].numero_atomique;
setlength(compo, length(compo)-1);
 end;
end;

procedure ajoute_xfois_composition_atomique_a_composition_atomique
(x:extended; var somme:array_composeurs_atomiques; terme:array_composeurs_atomiques);
{somme contient le 1er terme de la somme en entree, et la somme en sortie;
terme est le second terme de la somme}
var i:integer;
begin
for i:=1 to length(terme) do
ajoute_xfois_composeur_atomique_a_composition_atomique(x,somme,terme[i-1]);
end;




function Donne_Numero_Atomique(s:string):integer;
var i:integer;
begin
for i:=1 to  nombre_atomes_classification do
if s=tableau_periodique[i-1].symbole then begin
 Donne_Numero_Atomique:=i;
 exit;
 end;
 Donne_Numero_Atomique:=0;
 end;


procedure trouve_tous_les_elements(liste:tstrings;exclus:tstringlist);
var i,j,k:longint;  nini:integer;
nombre_reactifs,nombre_produits:integer;
nouveau_trouve,tous_reactifs_presents,tous_produits_presents,a_exclure:boolean;
label 999,888;

begin
for i:=1 to nombre_elements_base do elements_base_presents[i-1]:=false;
for i:=1 to nombre_elements_gazeux do elements_gazeux_presents[i-1]:=false;
for i:=1 to nombre_elements_aqueux do elements_aqueux_presents[i-1]:=false;
for i:=1 to nombre_elements_mineraux do elements_solides_presents[i-1]:=false;
for i:=1 to nombre_elements_organiques do elements_organiques_presents[i-1]:=false;
{il y a au moins toujours H2O, H+ et OH-}
 elements_base_presents[indice_element_base('H2O')-1]:=true;
 elements_base_presents[indice_element_base('H[+]')-1]:=true;
{on inclue ceux fournis}
 if liste.Count>0 then for i:=1 to liste.Count do begin
 j:=indice_element_base(liste.Strings[i-1]);
 if j<>0 then begin
 elements_base_presents[j-1]:=true;
 goto 888; end;

 {j:=indice_element_gazeux(liste.Strings[i-1]);
 if j<>0 then begin
 elements_gazeux_presents[j-1]:=true;
 goto 888; end;     }

 j:=indice_element_aqueux(liste.Strings[i-1]);
 if j<>0 then begin
 elements_aqueux_presents[j-1]:=true;
 goto 888; end;

 j:=indice_element_mineral(liste.Strings[i-1]);
 if j<>0 then begin
 elements_solides_presents[j-1]:=true;
 goto 888; end;

 j:=indice_element_organique(liste.Strings[i-1]);
 if j<>0 then begin
 elements_organiques_presents[j-1]:=true;
 goto 888; end;

 888: end;

  {recherche des nouveaux elements presents par balayage}

 repeat
  nouveau_trouve:=false;

  if not(blocage_redox) then
  for i:=1 to nombre_elements_aqueux do begin
  tous_reactifs_presents:=elements_aqueux_presents[i-1];
  tous_produits_presents:=true;
  for j:=1 to tableau_elements_aqueux[i-1].nombre_composants do begin
  if tableau_elements_aqueux[i-1].composition[j-1].coefficient<0 then
  case tableau_elements_aqueux[i-1].composition[j-1].nature of
  debase:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_base_presents[tableau_elements_aqueux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
  aqueux:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_aqueux_presents[tableau_elements_aqueux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   gaz:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_gazeux_presents[tableau_elements_aqueux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   solide:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_solides_presents[tableau_elements_aqueux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   organique:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_organiques_presents[tableau_elements_aqueux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   end; { du case}
   if tableau_elements_aqueux[i-1].composition[j-1].coefficient>0 then
  case tableau_elements_aqueux[i-1].composition[j-1].nature of
  debase:  tous_produits_presents:=(tous_produits_presents AND
   elements_base_presents[tableau_elements_aqueux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
  aqueux:  tous_produits_presents:=(tous_produits_presents AND
   elements_aqueux_presents[tableau_elements_aqueux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   gaz:  tous_produits_presents:=(tous_produits_presents AND
   elements_gazeux_presents[tableau_elements_aqueux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   solide:  tous_produits_presents:=(tous_produits_presents AND
   elements_solides_presents[tableau_elements_aqueux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   organique:  tous_produits_presents:=(tous_produits_presents AND
   elements_organiques_presents[tableau_elements_aqueux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   end; { du case}
   end; {de la boucle en j}
    if (tous_reactifs_presents and not(tous_produits_presents)) then begin
    a_exclure:=false;
    for j:=1 to  tableau_elements_aqueux[i-1].nombre_composants do
     if tableau_elements_aqueux[i-1].composition[j-1].coefficient>0 then
     a_exclure:=a_exclure or ((exclus.find(tableau_elements_aqueux[i-1].composition[j-1].element,nini)));
     end;
    if (tous_reactifs_presents and not(tous_produits_presents) and not(a_exclure)) then  begin
   for j:=1 to tableau_elements_aqueux[i-1].nombre_composants do
  if tableau_elements_aqueux[i-1].composition[j-1].coefficient>0 then
  case tableau_elements_aqueux[i-1].composition[j-1].nature of
  debase: elements_base_presents[tableau_elements_aqueux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
aqueux: elements_aqueux_presents[tableau_elements_aqueux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
gaz:  elements_gazeux_presents[tableau_elements_aqueux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
solide: elements_solides_presents[tableau_elements_aqueux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
organique: elements_organiques_presents[tableau_elements_aqueux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
end;
      nouveau_trouve:=true;
      goto 999;
      end;
 if (not(tous_reactifs_presents) and (tous_produits_presents)) then begin
  a_exclure:=false;
    for j:=1 to  tableau_elements_aqueux[i-1].nombre_composants do
     if tableau_elements_aqueux[i-1].composition[j-1].coefficient<0 then
     a_exclure:=a_exclure or ((exclus.find(tableau_elements_aqueux[i-1].composition[j-1].element,nini)));
     end;

 if (not(tous_reactifs_presents) and (tous_produits_presents) and  not(a_exclure)) then  begin
   for j:=1 to tableau_elements_aqueux[i-1].nombre_composants do
  if tableau_elements_aqueux[i-1].composition[j-1].coefficient<0 then
 case tableau_elements_aqueux[i-1].composition[j-1].nature of
  debase: elements_base_presents[tableau_elements_aqueux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
aqueux: elements_aqueux_presents[tableau_elements_aqueux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
gaz:  elements_gazeux_presents[tableau_elements_aqueux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
solide: elements_solides_presents[tableau_elements_aqueux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
organique: elements_organiques_presents[tableau_elements_aqueux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
end;
elements_aqueux_presents[i-1]:=true;
      nouveau_trouve:=true;
      goto 999;
      end;
          end; {de la boucle en i des elements aqueux}



       {boucle sur les gazeux}
if not (blocage_gaz) then
for i:=1 to nombre_elements_gazeux do begin
  tous_reactifs_presents:=elements_gazeux_presents[i-1];
  tous_produits_presents:=true;
  for j:=1 to tableau_elements_gazeux[i-1].nombre_composants do begin
  if tableau_elements_gazeux[i-1].composition[j-1].coefficient<0 then
  case tableau_elements_gazeux[i-1].composition[j-1].nature of
  debase:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_base_presents[tableau_elements_gazeux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
  aqueux:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_aqueux_presents[tableau_elements_gazeux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   gaz:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_gazeux_presents[tableau_elements_gazeux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   solide:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_solides_presents[tableau_elements_gazeux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   organique:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_organiques_presents[tableau_elements_gazeux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   end; { du case}
   if tableau_elements_gazeux[i-1].composition[j-1].coefficient>0 then
  case tableau_elements_gazeux[i-1].composition[j-1].nature of
  debase:  tous_produits_presents:=(tous_produits_presents AND
   elements_base_presents[tableau_elements_gazeux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
  aqueux:  tous_produits_presents:=(tous_produits_presents AND
   elements_aqueux_presents[tableau_elements_gazeux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   gaz:  tous_produits_presents:=(tous_produits_presents AND
   elements_gazeux_presents[tableau_elements_gazeux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   solide:  tous_produits_presents:=(tous_produits_presents AND
   elements_solides_presents[tableau_elements_gazeux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   organique:  tous_produits_presents:=(tous_produits_presents AND
   elements_organiques_presents[tableau_elements_gazeux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   end; { du case}
   end; {de la boucle en j}
    if (tous_reactifs_presents and not(tous_produits_presents)) then begin
     a_exclure:=false;
    for j:=1 to  tableau_elements_gazeux[i-1].nombre_composants do
     if tableau_elements_gazeux[i-1].composition[j-1].coefficient>0 then
     a_exclure:=a_exclure or ((exclus.find(tableau_elements_gazeux[i-1].composition[j-1].element,nini)));
     end;

 if (tous_reactifs_presents and not(tous_produits_presents) and not(a_exclure)) then  begin
   for j:=1 to tableau_elements_gazeux[i-1].nombre_composants do
  if tableau_elements_gazeux[i-1].composition[j-1].coefficient>0 then
 case tableau_elements_gazeux[i-1].composition[j-1].nature of
  debase: elements_base_presents[tableau_elements_gazeux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
aqueux: elements_aqueux_presents[tableau_elements_gazeux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
gaz:  elements_gazeux_presents[tableau_elements_gazeux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
solide: elements_solides_presents[tableau_elements_gazeux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
organique: elements_organiques_presents[tableau_elements_gazeux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
end;
      nouveau_trouve:=true;
      goto 999;
      end;
 if (not(tous_reactifs_presents) and (tous_produits_presents)) then begin
 a_exclure:=false;
    for j:=1 to  tableau_elements_gazeux[i-1].nombre_composants do
     if tableau_elements_gazeux[i-1].composition[j-1].coefficient<0 then
     a_exclure:=a_exclure or ((exclus.find(tableau_elements_gazeux[i-1].composition[j-1].element,nini)));
     end;
    if (not(tous_reactifs_presents) and (tous_produits_presents) and not(a_exclure)) then  begin
   for j:=1 to tableau_elements_gazeux[i-1].nombre_composants do
  if tableau_elements_gazeux[i-1].composition[j-1].coefficient<0 then
case tableau_elements_gazeux[i-1].composition[j-1].nature of
  debase: elements_base_presents[tableau_elements_gazeux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
aqueux: elements_aqueux_presents[tableau_elements_gazeux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
gaz:  elements_gazeux_presents[tableau_elements_gazeux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
solide: elements_solides_presents[tableau_elements_gazeux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
organique: elements_organiques_presents[tableau_elements_gazeux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
end;
elements_gazeux_presents[i-1]:=true;
      nouveau_trouve:=true;
      goto 999;
      end;
          end; {de la boucle en i des elements gazeux}





 {boucle sur les solides}
 if not(blocage_solide) then
for i:=1 to nombre_elements_mineraux do begin
  tous_reactifs_presents:=elements_solides_presents[i-1];
  tous_produits_presents:=true;
  for j:=1 to tableau_elements_mineraux[i-1].nombre_composants do begin
  if tableau_elements_mineraux[i-1].composition[j-1].coefficient<0 then
  case tableau_elements_mineraux[i-1].composition[j-1].nature of
  debase:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_base_presents[tableau_elements_mineraux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
  aqueux:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_aqueux_presents[tableau_elements_mineraux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   gaz:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_gazeux_presents[tableau_elements_mineraux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   solide:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_solides_presents[tableau_elements_mineraux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   organique:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_organiques_presents[tableau_elements_mineraux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   end; { du case}
   if tableau_elements_mineraux[i-1].composition[j-1].coefficient>0 then
  case tableau_elements_mineraux[i-1].composition[j-1].nature of
  debase:  tous_produits_presents:=(tous_produits_presents AND
   elements_base_presents[tableau_elements_mineraux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
  aqueux:  tous_produits_presents:=(tous_produits_presents AND
   elements_aqueux_presents[tableau_elements_mineraux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   gaz:  tous_produits_presents:=(tous_produits_presents AND
   elements_gazeux_presents[tableau_elements_mineraux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   solide:  tous_produits_presents:=(tous_produits_presents AND
   elements_solides_presents[tableau_elements_mineraux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   organique:  tous_produits_presents:=(tous_produits_presents AND
   elements_organiques_presents[tableau_elements_mineraux[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   end; { du case}
   end; {de la boucle en j}
    if (tous_reactifs_presents and not(tous_produits_presents)) then begin
    a_exclure:=false;
    for j:=1 to  tableau_elements_mineraux[i-1].nombre_composants do
     if tableau_elements_mineraux[i-1].composition[j-1].coefficient>0 then
     a_exclure:=a_exclure or ((exclus.find(tableau_elements_mineraux[i-1].composition[j-1].element,nini)));
     end;
   if (tous_reactifs_presents and not(tous_produits_presents)and not(a_exclure)) then  begin
   for j:=1 to tableau_elements_mineraux[i-1].nombre_composants do
  if tableau_elements_mineraux[i-1].composition[j-1].coefficient>0 then
 case tableau_elements_mineraux[i-1].composition[j-1].nature of
  debase: elements_base_presents[tableau_elements_mineraux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
aqueux: elements_aqueux_presents[tableau_elements_mineraux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
gaz:  elements_gazeux_presents[tableau_elements_mineraux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
solide: elements_solides_presents[tableau_elements_mineraux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
organique: elements_organiques_presents[tableau_elements_mineraux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
end;
      nouveau_trouve:=true;
      goto 999;
      end;
 if (not(tous_reactifs_presents) and (tous_produits_presents)) then begin
 a_exclure:=false;
    for j:=1 to  tableau_elements_mineraux[i-1].nombre_composants do
     if tableau_elements_mineraux[i-1].composition[j-1].coefficient<0 then
     a_exclure:=a_exclure or ((exclus.find(tableau_elements_mineraux[i-1].composition[j-1].element,nini)));
     end;
   if (not(tous_reactifs_presents) and (tous_produits_presents) and not(a_exclure)) then  begin
   for j:=1 to tableau_elements_mineraux[i-1].nombre_composants do
  if tableau_elements_mineraux[i-1].composition[j-1].coefficient<0 then
case tableau_elements_mineraux[i-1].composition[j-1].nature of
  debase: elements_base_presents[tableau_elements_mineraux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
aqueux: elements_aqueux_presents[tableau_elements_mineraux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
gaz:  elements_gazeux_presents[tableau_elements_mineraux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
solide: elements_solides_presents[tableau_elements_mineraux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
organique: elements_organiques_presents[tableau_elements_mineraux[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
end;
elements_solides_presents[i-1]:=true;
      nouveau_trouve:=true;
      goto 999;
      end;
          end; {de la boucle en i des elements solides}




{boucle sur les organiques}
if not(blocage_organique) then
for i:=1 to nombre_elements_organiques do begin
  tous_reactifs_presents:=elements_organiques_presents[i-1];
  tous_produits_presents:=true;
  for j:=1 to tableau_elements_organiques[i-1].nombre_composants do begin
  if tableau_elements_organiques[i-1].composition[j-1].coefficient<0 then
  case tableau_elements_organiques[i-1].composition[j-1].nature of
  debase:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_base_presents[tableau_elements_organiques[i-1].composition[j-1].
   indice_dans_sa_base-1]);
  aqueux:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_aqueux_presents[tableau_elements_organiques[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   gaz:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_gazeux_presents[tableau_elements_organiques[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   solide:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_solides_presents[tableau_elements_organiques[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   organique:  tous_reactifs_presents:=(tous_reactifs_presents AND
   elements_organiques_presents[tableau_elements_organiques[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   end; { du case}
   if tableau_elements_organiques[i-1].composition[j-1].coefficient>0 then
  case tableau_elements_organiques[i-1].composition[j-1].nature of
  debase:  tous_produits_presents:=(tous_produits_presents AND
   elements_base_presents[tableau_elements_organiques[i-1].composition[j-1].
   indice_dans_sa_base-1]);
  aqueux:  tous_produits_presents:=(tous_produits_presents AND
   elements_aqueux_presents[tableau_elements_organiques[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   gaz:  tous_produits_presents:=(tous_produits_presents AND
   elements_gazeux_presents[tableau_elements_organiques[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   solide:  tous_produits_presents:=(tous_produits_presents AND
   elements_solides_presents[tableau_elements_organiques[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   organique:  tous_produits_presents:=(tous_produits_presents AND
   elements_organiques_presents[tableau_elements_organiques[i-1].composition[j-1].
   indice_dans_sa_base-1]);
   end; { du case}
   end; {de la boucle en j}
    if (tous_reactifs_presents and not(tous_produits_presents)) then begin
    a_exclure:=false;
    for j:=1 to  tableau_elements_organiques[i-1].nombre_composants do
     if tableau_elements_organiques[i-1].composition[j-1].coefficient>0 then
     a_exclure:=a_exclure or ((exclus.find(tableau_elements_organiques[i-1].composition[j-1].element,nini)));
     end;

 if (tous_reactifs_presents and not(tous_produits_presents) and not(a_exclure)) then  begin
   for j:=1 to tableau_elements_organiques[i-1].nombre_composants do
  if tableau_elements_organiques[i-1].composition[j-1].coefficient>0 then
 case tableau_elements_organiques[i-1].composition[j-1].nature of
  debase: elements_base_presents[tableau_elements_organiques[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
aqueux: elements_aqueux_presents[tableau_elements_organiques[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
gaz:  elements_gazeux_presents[tableau_elements_organiques[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
solide: elements_solides_presents[tableau_elements_organiques[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
organique: elements_organiques_presents[tableau_elements_organiques[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
end;
      nouveau_trouve:=true;
      goto 999;
      end;
 if (not(tous_reactifs_presents) and (tous_produits_presents)) then begin
  a_exclure:=false;
    for j:=1 to  tableau_elements_organiques[i-1].nombre_composants do
     if tableau_elements_organiques[i-1].composition[j-1].coefficient<0 then
     a_exclure:=a_exclure or ((exclus.find(tableau_elements_organiques[i-1].composition[j-1].element,nini)));
     end;
   if (not(tous_reactifs_presents) and (tous_produits_presents) and not(a_exclure)) then begin
   for j:=1 to tableau_elements_organiques[i-1].nombre_composants do
  if tableau_elements_organiques[i-1].composition[j-1].coefficient<0 then
case tableau_elements_organiques[i-1].composition[j-1].nature of
  debase: elements_base_presents[tableau_elements_organiques[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
aqueux: elements_aqueux_presents[tableau_elements_organiques[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
gaz:  elements_gazeux_presents[tableau_elements_organiques[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
solide: elements_solides_presents[tableau_elements_organiques[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
organique: elements_organiques_presents[tableau_elements_organiques[i-1].composition[j-1].
indice_dans_sa_base-1]:=true;
end;
elements_organiques_presents[i-1]:=true;
      nouveau_trouve:=true;
      goto 999;
      end;
          end; {de la boucle en i des elements organiques}



   999:
 until not(nouveau_trouve);


end;



function indice_element_base(s:string):longint;
var i:longint;
begin
if s='' then begin
 indice_element_base:=0;
 exit;
 end;

i:=0;
while(
((s<>tableau_elements_base[i].identifiant))
and
(i<nombre_elements_base-1)) do
inc(i);
if ((i<nombre_elements_base-1) or
(tableau_elements_base[nombre_elements_base-1].identifiant=s))
 then indice_element_base:=i+1 else
indice_element_base:=0;
end;

function indice_element_gazeux(s:string):longint;
var i:longint;
begin
if s='' then begin
 indice_element_gazeux:=0;
 exit;
 end;
i:=0;
while(
(s<>tableau_elements_gazeux[i].identifiant) and
 (s<>tableau_elements_gazeux[i].formule)
and
(i<nombre_elements_gazeux-1)) do
inc(i);
if ((i<nombre_elements_gazeux-1) or
(tableau_elements_gazeux[nombre_elements_gazeux-1].identifiant=s) or
(tableau_elements_gazeux[nombre_elements_gazeux-1].formule=s))
then indice_element_gazeux:=i+1 else
indice_element_gazeux:=0;
end;

function indice_element_aqueux(s:string):longint;
var i:longint;
begin
if s='' then begin
 indice_element_aqueux:=0;
 exit;
 end;
i:=0;

while(
(s<>tableau_elements_aqueux[i].identifiant)
and
 (s<>tableau_elements_aqueux[i].formule)
and
(i<nombre_elements_aqueux-1)) do
inc(i);
if ((i<nombre_elements_aqueux-1) or
(tableau_elements_aqueux[nombre_elements_aqueux-1].identifiant=s) or
(tableau_elements_aqueux[nombre_elements_aqueux-1].formule=s))
 then indice_element_aqueux:=i+1 else
indice_element_aqueux:=0;
end;

function indice_element_mineral(s:string):longint;
var i:longint;
begin
if s='' then begin
 indice_element_mineral:=0;
 exit;
 end;
i:=0;
while(
(s<>tableau_elements_mineraux[i].identifiant)
and
 (s<>tableau_elements_mineraux[i].formule)
and
(i<nombre_elements_mineraux-1)) do
inc(i);
if ((i<nombre_elements_mineraux-1) or
(tableau_elements_mineraux[nombre_elements_mineraux-1].identifiant=s) or
(tableau_elements_mineraux[nombre_elements_mineraux-1].formule=s))
 then indice_element_mineral:=i+1 else
indice_element_mineral:=0;
end;

function indice_element_organique(s:string):longint;
var i:longint;
begin
if s='' then begin
 indice_element_organique:=0;
 exit;
 end;
i:=0;
while(
(s<>tableau_elements_organiques[i].identifiant)
and
 (s<>tableau_elements_organiques[i].formule)
and
(i<nombre_elements_organiques-1)) do
inc(i);
if ((i<nombre_elements_organiques-1) or
(tableau_elements_organiques[nombre_elements_organiques-1].identifiant=s) or
(tableau_elements_organiques[nombre_elements_organiques-1].formule=s))
 then indice_element_organique:=i+1 else
indice_element_organique:=0;
end;






procedure lecture_base;
var f:textfile;
s,s1,s2,s3,s4,s11,s12,s000:string;
i,j,k,compteur:longint; tous_identifies,yaduo2:boolean;  toto:TCharEncStream; liste_lignes_fichier_base:tstringlist;
label 145,156,167,189,1234,2345,3456,5678;

  procedure myreadln(var s:string);
  begin
  s:=liste_lignes_fichier_base[compteur];
  inc(compteur);
  end;
   procedure myreadln1(var i:integer);
  begin
  i:=strtoint(liste_lignes_fichier_base[compteur]);
  inc(compteur);
  end;
    procedure myreadln2(var x:extended);
  begin
  x:=strtofloat(liste_lignes_fichier_base[compteur]);
  inc(compteur);
  end;

begin

 {<modif version 1.10}
{lecture de la base des atomes}
if not(fileexistsutf8(repertoire_executable+'atomes.ato')) then begin
application.messagebox('Fichier des atomes non trouvé...','Hélas !',mb_ok);
halt;
end;
assignfile(f,utf8tosys(repertoire_executable+'atomes.ato'));
reset(f);
  {modif version 1.10>}
while not(eof(f)) do begin
 readln(f,j);
 tableau_periodique[j-1].numero_atomique:=j;
 readln(f,tableau_periodique[j-1].symbole);
  readln(f,tableau_periodique[j-1].nom);
  end;
  closefile(f);
  {fin lecture base atomes}

nombre_elements_base:=-1;
nombre_elements_gazeux:=-1;
nombre_elements_aqueux:=-1;
nombre_elements_mineraux:=-1;
nombre_elements_organiques:=-1;
nombre_elements_organiques_acide:=0;
nombre_elements_organiques_aminoacide:=0;
nombre_elements_organiques_alc:=0;
nombre_elements_organiques_alcool:=0;
nombre_elements_organiques_benzene:=0;
nombre_elements_organiques_amid_amin:=0;
nombre_elements_organiques_complexe:=0;
nombre_elements_organiques_aldehyd_cetone:=0;
nb_cations_simples:=0;
nb_anions_simples:=0;
nb_complexes:=0;   nb_ions:=0; nb_molecules:=0;
nb_ab:=0;



{<modif version 1.10}
{lecture de la base des especes}
if not(fileexistsutf8(nom_base)) then begin
application.messagebox('Fichier de la base non trouvé...','Hélas !',mb_ok);
halt;
end;



toto:=TCharEncStream.create;
     try
       toto.LoadFromFile(utf8tosys(nom_base));
      except
    application.MessageBox(pchar('Impossible de charger '+nom_base),
    'Hélas...',mb_ok);
    exit;
  end;

      liste_lignes_fichier_base:=tstringlist.Create;
      liste_lignes_fichier_base.Text:=toto.UTF8Text;
      toto.Free;


      compteur:=0;


//assignfile(f,repertoire_executable+'base.equ');
//reset(f);
  {modif version 1.10>}


//reset(f);
repeat  myreadln(s); until (pos('<Version>',s)<>0);
myreadln1(version);
repeat  myreadln(s); until (pos('<Date>',s)<>0);
myreadln(date);
repeat  myreadln(s); until (pos('<Base>',s)<>0);
myreadln(s11); {doit contenir <Element>}


while(pos('</Base>',s11)=0) do begin
myreadln(s12); {doit contenir <Identifiant>}
myreadln(s2); {doit contenir l'identifiant}
myreadln(s12); {doit contenir </Identifiant>}
myreadln(s12); {doit contenir <Typegenerique>}
myreadln(s4); {doit contenir le type generique}
myreadln(s12); {doit contenir </Typegenerique>}



  if s4='de_base' then begin

    inc(nombre_elements_base);
    if  nombre_elements_base>=length(tableau_elements_base) then
    setlength(tableau_elements_base,length(tableau_elements_base)+1);
 tableau_elements_base[nombre_elements_base].identifiant:=s2;
 myreadln(s);
   if pos('<Synonyme>',s)<> 0 then  begin
 myreadln(s);
  tableau_elements_base[nombre_elements_base].synonyme:=s;
  myreadln(s);
  myreadln(s); end else
  tableau_elements_base[nombre_elements_base].synonyme:='';
 tableau_elements_base[nombre_elements_base].st:=non_defini;
  if pos('<Soustype>',s)<>0 then begin
  myreadln(s);
  if s='complexe' then  tableau_elements_base[nombre_elements_base].st:=complexe_i;
  if s='acide' then  tableau_elements_base[nombre_elements_base].st:=acide_i;
  if s='cation_simple' then  tableau_elements_base[nombre_elements_base].st:=cation_simple;
  if s='anion_simple' then  tableau_elements_base[nombre_elements_base].st:=anion_simple;
  if s='ion' then  tableau_elements_base[nombre_elements_base].st:=ion;
  if s='molecule' then  tableau_elements_base[nombre_elements_base].st:=molecule;
  myreadln(s);   {s doit contenir </Soustype>}
  myreadln(s);
  end;

 if pos('<Charge>',s)<>0 then begin
 myreadln1(tableau_elements_base[nombre_elements_base].charge);
 myreadln(s); {doit contenir </Charge>}
 myreadln(s); end else
   tableau_elements_base[nombre_elements_base].charge:=0;

    if pos('<Conductivite>',s)<>0 then begin
     myreadln2(tableau_elements_base[nombre_elements_base].conductivite);
 myreadln(s); {doit contenir </Conductivite>}
 myreadln(s); end else
   tableau_elements_base[nombre_elements_base].conductivite:=0;

   tableau_elements_base[nombre_elements_base].mu0_25:=0;
   tableau_elements_base[nombre_elements_base].nombre_composants:=0;

 if ((pos('<Atomes constitutifs>',s)<>0) or
 (pos('<Formulebrute>',s)<>0)) then begin
   tableau_elements_base[nombre_elements_base].nombre_composants:=0;
  setlength(tableau_elements_base[nombre_elements_base].composition_atomique,
  tableau_elements_base[nombre_elements_base].nombre_composants);
  myreadln(s);
 repeat
 inc(tableau_elements_base[nombre_elements_base].nombre_composants);
  setlength(tableau_elements_base[nombre_elements_base].composition_atomique,
  tableau_elements_base[nombre_elements_base].nombre_composants);
    tableau_elements_base[nombre_elements_base].composition_atomique[
     tableau_elements_base[nombre_elements_base].nombre_composants-1].coefficient:=
     strtofloat(s);
     myreadln(s);
 tableau_elements_base[nombre_elements_base].composition_atomique[
     tableau_elements_base[nombre_elements_base].nombre_composants-1].numero_atomique:=
     Donne_Numero_Atomique(s);
  if tableau_elements_base[nombre_elements_base].nombre_composants=1 then
     tableau_elements_base[nombre_elements_base].representant_de:=s;
     myreadln(s);
 until ((pos('</Atomes constitutifs>',s)<>0) or
 (pos('</Formulebrute>',s)<>0));
 myreadln(s);
      end;

   if pos('<Massemolaire>',s)<>0 then begin
 myreadln2(tableau_elements_base[nombre_elements_base].masse_molaire);
   myreadln(s); {doit contenir </Massemolaire>}
   myreadln(s);
   end;

   if pos('<Representant de l''element>',s)<>0 then begin
   if tableau_elements_base[nombre_elements_base].nombre_composants=0 then  begin
    tableau_elements_base[nombre_elements_base].nombre_composants:=1;
  setlength(tableau_elements_base[nombre_elements_base].composition_atomique,
  tableau_elements_base[nombre_elements_base].nombre_composants);
  tableau_elements_base[nombre_elements_base].composition_atomique[
     tableau_elements_base[nombre_elements_base].nombre_composants-1].coefficient:=1;
 myreadln(s);
 tableau_elements_base[nombre_elements_base].representant_de:=s;
 tableau_elements_base[nombre_elements_base].composition_atomique[
     tableau_elements_base[nombre_elements_base].nombre_composants-1].numero_atomique:=
     Donne_Numero_Atomique(s);
     end else
     myreadln(s);
  myreadln(s); {doit contenir </Representant de l'element>}
      myreadln(s); {doit contenir 'rayon'}
      end;

    if pos('<Rayon>',s)<>0 then begin
   myreadln2(tableau_elements_base[nombre_elements_base].rayon);
       myreadln(s); {doit contenir </Rayon>}
       myreadln(s);
        end else
  tableau_elements_base[nombre_elements_base].rayon:=0;



if  tableau_elements_base[nombre_elements_base].st=cation_simple  then begin
inc(nb_cations_simples);
if  nb_cations_simples>=length(tableau_cations_simples) then
setlength(tableau_cations_simples,length(tableau_cations_simples)+10);
 tableau_cations_simples[nb_cations_simples-1].identifiant:=
  tableau_elements_base[nombre_elements_base].identifiant;
    end;

 if  tableau_elements_base[nombre_elements_base].st=anion_simple then begin
 inc(nb_anions_simples);
if  nb_anions_simples>=length(tableau_anions_simples) then
setlength(tableau_anions_simples,length(tableau_anions_simples)+10);
 tableau_anions_simples[nb_anions_simples-1].identifiant:=
  tableau_elements_base[nombre_elements_base].identifiant;
                     end;


                      if  tableau_elements_base[nombre_elements_base].st=ion then begin
 inc(nb_ions);
if  nb_ions>=length(tableau_ions) then
setlength(tableau_ions,length(tableau_ions)+10);
 tableau_ions[nb_ions-1].identifiant:=
  tableau_elements_base[nombre_elements_base].identifiant;
                     end;


                      if  tableau_elements_base[nombre_elements_base].st=molecule then begin
 inc(nb_molecules);
if  nb_molecules>=length(tableau_molecules) then
setlength(tableau_molecules,length(tableau_molecules)+10);
 tableau_molecules[nb_molecules-1].identifiant:=
  tableau_elements_base[nombre_elements_base].identifiant;
                     end;

             if  tableau_elements_base[nombre_elements_base].st=acide_i then begin
 inc(nb_ab);
if  nb_ab>=length(tableau_ab) then
setlength(tableau_ab,length(tableau_ab)+10);
 tableau_ab[nb_ab-1].identifiant:=
  tableau_elements_base[nombre_elements_base].identifiant;
                             end;

  if tableau_elements_base[nombre_elements_base].charge<>0 then begin
inc(tableau_elements_base[nombre_elements_base].nombre_composants);
  setlength(tableau_elements_base[nombre_elements_base].composition_atomique,
  tableau_elements_base[nombre_elements_base].nombre_composants);
    tableau_elements_base[nombre_elements_base].composition_atomique[
     tableau_elements_base[nombre_elements_base].nombre_composants-1].coefficient:=
    tableau_elements_base[nombre_elements_base].charge;
  tableau_elements_base[nombre_elements_base].composition_atomique[
tableau_elements_base[nombre_elements_base].nombre_composants-1].numero_atomique:=
    -1;
end;
 end;





 if s4='gazeux' then begin
         inc(nombre_elements_gazeux);
      if  nombre_elements_gazeux>=length(tableau_elements_gazeux) then
    setlength(tableau_elements_gazeux,length(tableau_elements_gazeux)+10);
 tableau_elements_gazeux[nombre_elements_gazeux].identifiant:=s2;
 myreadln(s);
  if pos('<Synonyme>',s)<> 0 then  begin
 myreadln(s);
  tableau_elements_gazeux[nombre_elements_gazeux].synonyme:=s;
  myreadln(s);
  myreadln(s); end else
  tableau_elements_gazeux[nombre_elements_gazeux].synonyme:='';
 if pos('<Formule brute>',s)<>0 then begin
  myreadln(tableau_elements_gazeux[nombre_elements_gazeux].formule);
    myreadln(s); {doit contenir  </Formule brute> }
  end else
  tableau_elements_gazeux[nombre_elements_gazeux].formule:='';

   {doit contenir "composition"}
tableau_elements_gazeux[nombre_elements_gazeux].nombre_composants:=0;

if pos('<Composition>',s)<>0 then begin
myreadln(s);
tableau_elements_gazeux[nombre_elements_gazeux].identifie:=false;
while pos('</Composition>',s)=0 do begin
inc(tableau_elements_gazeux[nombre_elements_gazeux].nombre_composants);
setlength(tableau_elements_gazeux[nombre_elements_gazeux].composition,
tableau_elements_gazeux[nombre_elements_gazeux].nombre_composants);
tableau_elements_gazeux[nombre_elements_gazeux].composition[
tableau_elements_gazeux[nombre_elements_gazeux].nombre_composants-1].
coefficient:=strtofloat(s);
myreadln(tableau_elements_gazeux[nombre_elements_gazeux].composition[
tableau_elements_gazeux[nombre_elements_gazeux].nombre_composants-1].
element);
myreadln(s);
end;
 end;


myreadln(s); {doit contenir <Thermo>}
myreadln(s);  {doit contenir <Log K>}
if pos('<Log K>',s)<>0 then begin
myreadln(s);
while ((pos('</Log K>',s)=0) and (s<>'')) do begin
myreadln(s1);
if s1='25' then
tableau_elements_gazeux[nombre_elements_gazeux].logk_25:=
strtofloat(s);
myreadln(s);
end;
myreadln(s);
 end;


{s doit contenir "enthalpy"}
if pos('<Enthalpie>',s)<>0 then begin
myreadln2(tableau_elements_gazeux[nombre_elements_gazeux].enthalpie);
 tableau_elements_gazeux[nombre_elements_gazeux].enthalpie_connue:=true;
 myreadln(s); {doit contenir </Enthalpie>}
    myreadln(s);  {doit contenir </Thermo>}
end else  begin
 tableau_elements_gazeux[nombre_elements_gazeux].enthalpie:=0;
 tableau_elements_gazeux[nombre_elements_gazeux].enthalpie_connue:=false;
 end;



     myreadln(s);  {doit contenir </Element>}
    end;



    if s4='aqueux' then begin
    inc(nombre_elements_aqueux);
      if  nombre_elements_aqueux>=length(tableau_elements_aqueux) then
    setlength(tableau_elements_aqueux,length(tableau_elements_aqueux)+10);
 tableau_elements_aqueux[nombre_elements_aqueux].identifiant:=s2;
 myreadln(s);
  if pos('<Synonyme>',s)<> 0 then  begin
 myreadln(s);
  tableau_elements_aqueux[nombre_elements_aqueux].synonyme:=s;
  myreadln(s);
  myreadln(s); end else
  tableau_elements_aqueux[nombre_elements_aqueux].synonyme:='';
  tableau_elements_aqueux[nombre_elements_aqueux].st:=non_defini;
  if pos('<Soustype>',s)<>0 then begin
  myreadln(s);
  if s='complexe' then  tableau_elements_aqueux[nombre_elements_aqueux].st:=complexe_i;
  if s='acide' then  tableau_elements_aqueux[nombre_elements_aqueux].st:=acide_i;
  if s='cation_simple' then  tableau_elements_aqueux[nombre_elements_aqueux].st:=cation_simple;
  if s='anion_simple' then  tableau_elements_aqueux[nombre_elements_aqueux].st:=anion_simple;
   if s='ion' then
  tableau_elements_aqueux[nombre_elements_aqueux].st:=ion;
  if s='molecule' then  tableau_elements_aqueux[nombre_elements_aqueux].st:=molecule;
  myreadln(s);  {contient </Soustype>}
  myreadln(s);
  end;

 if pos('<Charge>',s)<>0 then begin
  myreadln1(tableau_elements_aqueux[nombre_elements_aqueux].charge);
  myreadln(s);   {</Charge>}
  myreadln(s);
  end else
  tableau_elements_aqueux[nombre_elements_aqueux].charge:=0;

   if pos('<Conductivite>',s)<>0 then begin
  myreadln2(tableau_elements_aqueux[nombre_elements_aqueux].conductivite);
  myreadln(s); {</Conductivite>}
  myreadln(s);
  end else
  tableau_elements_aqueux[nombre_elements_aqueux].conductivite:=0;

 if pos('<Formulebrute>',s)<>0 then begin
  myreadln(tableau_elements_aqueux[nombre_elements_aqueux].formule);
  myreadln(s); {</Formulebrute>}
  myreadln(s);
  end else
  tableau_elements_aqueux[nombre_elements_aqueux].formule:='';


   if  (tableau_elements_aqueux[nombre_elements_aqueux].st=acide_i) then begin
 inc(nb_ab);
if  nb_ab>=length(tableau_ab) then
setlength(tableau_ab,length(tableau_ab)+10);
 tableau_ab[nb_ab-1].identifiant:=
  tableau_elements_aqueux[nombre_elements_aqueux].identifiant;
     tableau_ab[nb_ab-1].formule :=
  tableau_elements_aqueux[nombre_elements_aqueux].formule;
           end;

           if ( (tableau_elements_aqueux[nombre_elements_aqueux].st=non_defini) or
           (tableau_elements_aqueux[nombre_elements_aqueux].st=complexe_i)) then begin
 inc(nb_complexes);
if  nb_complexes>=length(tableau_complexes) then
setlength(tableau_complexes,length(tableau_complexes)+10);
 tableau_complexes[nb_complexes-1].identifiant:=
  tableau_elements_aqueux[nombre_elements_aqueux].identifiant;
     tableau_complexes[nb_complexes-1].formule :=
  tableau_elements_aqueux[nombre_elements_aqueux].formule;
                    end;


if  tableau_elements_aqueux[nombre_elements_aqueux].st=cation_simple then begin
 inc(nb_cations_simples);
if  nb_cations_simples>=length(tableau_cations_simples) then
setlength(tableau_cations_simples,length(tableau_cations_simples)+10);
 tableau_cations_simples[nb_cations_simples-1].identifiant:=
  tableau_elements_aqueux[nombre_elements_aqueux].identifiant;
     tableau_cations_simples[nb_cations_simples-1].formule :=
  tableau_elements_aqueux[nombre_elements_aqueux].formule;
  end;


 if   tableau_elements_aqueux[nombre_elements_aqueux].st=anion_simple then begin
 inc(nb_anions_simples);
if  nb_anions_simples>=length(tableau_anions_simples) then
setlength(tableau_anions_simples,length(tableau_anions_simples)+10);
 tableau_anions_simples[nb_anions_simples-1].identifiant:=
  tableau_elements_aqueux[nombre_elements_aqueux].identifiant;
   tableau_anions_simples[nb_anions_simples-1].formule :=
  tableau_elements_aqueux[nombre_elements_aqueux].formule;
            end;


            if   tableau_elements_aqueux[nombre_elements_aqueux].st=ion then begin
 inc(nb_ions);
if  nb_ions>=length(tableau_ions) then
setlength(tableau_ions,length(tableau_ions)+10);
 tableau_ions[nb_ions-1].identifiant:=
  tableau_elements_aqueux[nombre_elements_aqueux].identifiant;
   tableau_ions[nb_ions-1].formule :=
  tableau_elements_aqueux[nombre_elements_aqueux].formule;
            end;




  if pos('<Rayon>',s)<>0 then begin
  myreadln2(tableau_elements_aqueux[nombre_elements_aqueux].rayon);
  myreadln(s);  {</Rayon>}
  myreadln(s);
  end else
  tableau_elements_aqueux[nombre_elements_aqueux].rayon:=0;

   tableau_elements_aqueux[nombre_elements_aqueux].identifie:=false;

   if pos('<Composition>',s)<>0 then begin
   {doit contenir "composition"}
tableau_elements_aqueux[nombre_elements_aqueux].nombre_composants:=0;
myreadln(s);
while pos('</Composition>',s)=0 do begin
inc(tableau_elements_aqueux[nombre_elements_aqueux].nombre_composants);
setlength(tableau_elements_aqueux[nombre_elements_aqueux].composition,
tableau_elements_aqueux[nombre_elements_aqueux].nombre_composants);
tableau_elements_aqueux[nombre_elements_aqueux].composition[
tableau_elements_aqueux[nombre_elements_aqueux].nombre_composants-1].
coefficient:=strtofloat(s);
myreadln(tableau_elements_aqueux[nombre_elements_aqueux].composition[
tableau_elements_aqueux[nombre_elements_aqueux].nombre_composants-1].
element);
myreadln(s);
end;
myreadln(s); end;

if pos('<Thermo>',s)<>0 then begin
myreadln(s); {doit contenir "logK="}
if pos('<Log K>',s)<>0 then begin
myreadln(s);
while ((pos('</Log K>',s)=0) and (s<>'')) do begin
myreadln(s1);
if s1='25' then
tableau_elements_aqueux[nombre_elements_aqueux].logk_25:=
strtofloat(s);
myreadln(s);
end;
myreadln(s);
end;
{s doit contenir "enthalpy"}
if pos('<Enthalpie>',s)<>0 then begin
myreadln2(tableau_elements_aqueux[nombre_elements_aqueux].enthalpie);
 tableau_elements_aqueux[nombre_elements_aqueux].enthalpie_connue:=true;
  myreadln(s); {</Enthalpie>}
  myreadln(s); {doit contenir </Thermo>}
end else  begin
 tableau_elements_aqueux[nombre_elements_aqueux].enthalpie:=0;
 tableau_elements_aqueux[nombre_elements_aqueux].enthalpie_connue:=false;
 end;

end; {de thermo}


    myreadln(s);   {</Element>}
    end;



        if s4='mineral' then begin

    inc(nombre_elements_mineraux);
      if  nombre_elements_mineraux>=length(tableau_elements_mineraux) then
    setlength(tableau_elements_mineraux,length(tableau_elements_mineraux)+10);
tableau_elements_mineraux[nombre_elements_mineraux].identifiant:=s2;
  myreadln(s);
   if pos('<Synonyme>',s)<> 0 then  begin
 myreadln(s);
  tableau_elements_mineraux[nombre_elements_mineraux].synonyme:=s;
  myreadln(s);
  myreadln(s); end else
  tableau_elements_mineraux[nombre_elements_mineraux].synonyme:='';
 if pos('<Formulebrute>',s)<>0 then begin
  myreadln(tableau_elements_mineraux[nombre_elements_mineraux].formule);
  myreadln(s);  {</Formulebrute>}
  myreadln(s);
  end else
  tableau_elements_mineraux[nombre_elements_mineraux].formule:='';

  if pos('<Massevolumique>',s)<>0 then begin
 myreadln2(tableau_elements_mineraux[nombre_elements_mineraux].masse_volumique);
   myreadln(s); {doit contenir </Massevolumique>}
   myreadln(s); {<Composition>}
   end;

tableau_elements_mineraux[nombre_elements_mineraux].nombre_composants:=0;
if pos('<Composition>',s)<>0 then begin
tableau_elements_mineraux[nombre_elements_mineraux].identifie:=false;
myreadln(s);
while pos('</Composition>',s)=0 do begin
inc(tableau_elements_mineraux[nombre_elements_mineraux].nombre_composants);
setlength(tableau_elements_mineraux[nombre_elements_mineraux].composition,
tableau_elements_mineraux[nombre_elements_mineraux].nombre_composants);
tableau_elements_mineraux[nombre_elements_mineraux].composition[
tableau_elements_mineraux[nombre_elements_mineraux].nombre_composants-1].
coefficient:=strtofloat(s);
myreadln(tableau_elements_mineraux[nombre_elements_mineraux].composition[
tableau_elements_mineraux[nombre_elements_mineraux].nombre_composants-1].
element);
myreadln(s);
end;
myreadln(s);
end;

if pos('<Thermo>',s)<>0 then begin
myreadln(s); {doit contenir "logK="}
if pos('<Log K>',s)<>0 then begin
myreadln(s);
while ((pos('</Log K>',s)=0) and (s<>'')) do begin
myreadln(s1);
if s1='25' then
tableau_elements_mineraux[nombre_elements_mineraux].logk_25:=
strtofloat(s);
myreadln(s);
end;
myreadln(s);
end; { de log k }
{s doit contenir "enthalpy"}
if pos('<Enthalpie>',s)<>0 then begin
myreadln2(tableau_elements_mineraux[nombre_elements_mineraux].enthalpie);
 tableau_elements_mineraux[nombre_elements_mineraux].enthalpie_connue:=true;
  myreadln(s); {</Enthalpie>}
  myreadln(s); {doit contenir </Thermo>}
end else  begin
 tableau_elements_mineraux[nombre_elements_mineraux].enthalpie:=0;
 tableau_elements_mineraux[nombre_elements_mineraux].enthalpie_connue:=false;
 end;

end; {de thermo}


    myreadln(s);   {</Element>}
    end;


    if s4='organique' then begin

    inc(nombre_elements_organiques);
      if  nombre_elements_organiques>=length(tableau_elements_organiques) then
    setlength(tableau_elements_organiques,length(tableau_elements_organiques)+10);
tableau_elements_organiques[nombre_elements_organiques].identifiant:=s2;

 myreadln(s);
 if pos('<Synonyme>',s)<> 0 then  begin
 myreadln(s);
  tableau_elements_organiques[nombre_elements_organiques].synonyme:=s;
  myreadln(s);
  myreadln(s); end else
  tableau_elements_organiques[nombre_elements_organiques].synonyme:='';



 if pos('<Genre>',s)<>0 then begin
 myreadln(s2);
if s2='acide' then
tableau_elements_organiques[nombre_elements_organiques].genre:=acide;
if s2='aminoacide' then
tableau_elements_organiques[nombre_elements_organiques].genre:=aminoacide;
if s2='amid_amin' then
tableau_elements_organiques[nombre_elements_organiques].genre:=amid_amin;
if s2='alcool' then
tableau_elements_organiques[nombre_elements_organiques].genre:=alcool;
if s2='alc' then
tableau_elements_organiques[nombre_elements_organiques].genre:=alc;
if s2='benzene' then
 tableau_elements_organiques[nombre_elements_organiques].genre:=benzene;
 if s2='aldehyd_cetone' then
 tableau_elements_organiques[nombre_elements_organiques].genre:=aldehyd_cetone;
  if s2='complexe' then
 tableau_elements_organiques[nombre_elements_organiques].genre:=complexe;
myreadln(s);
myreadln(s);

    end else
    tableau_elements_organiques[nombre_elements_organiques].genre:=complexe;

    case tableau_elements_organiques[nombre_elements_organiques].genre of
    acide: inc(nombre_elements_organiques_acide);
     aminoacide: inc(nombre_elements_organiques_aminoacide);
     alc: inc(nombre_elements_organiques_alc);
     alcool: inc(nombre_elements_organiques_alcool);
    benzene: inc(nombre_elements_organiques_benzene);
     complexe: inc(nombre_elements_organiques_complexe);
     amid_amin: inc(nombre_elements_organiques_amid_amin);
     aldehyd_cetone: inc(nombre_elements_organiques_aldehyd_cetone);
     end;







 if pos('<Charge>',s)<>0 then begin
  myreadln1(tableau_elements_organiques[nombre_elements_organiques].charge);
  myreadln(s);
  myreadln(s);
  end else
  tableau_elements_organiques[nombre_elements_organiques].charge:=0;

  if pos('<Conductivite>',s)<>0 then begin
  myreadln2(tableau_elements_organiques[nombre_elements_organiques].conductivite);
  myreadln(s);
  myreadln(s);
  end else
  tableau_elements_organiques[nombre_elements_organiques].conductivite:=0;

 if pos('<Formulebrute>',s)<>0 then begin
  myreadln(tableau_elements_organiques[nombre_elements_organiques].formule);
  myreadln(s);
  myreadln(s);
  end else
  tableau_elements_organiques[nombre_elements_organiques].formule:='';

  if pos('<Rayon>',s)<>0 then begin
  myreadln2(tableau_elements_organiques[nombre_elements_organiques].rayon);
  myreadln(s);
  myreadln(s);
  end else
  tableau_elements_organiques[nombre_elements_organiques].rayon:=0;

  if pos('<Composition>',s)<>0 then begin
  tableau_elements_organiques[nombre_elements_organiques].identifie:=false;
tableau_elements_organiques[nombre_elements_organiques].nombre_composants:=0;
myreadln(s);   yaduo2:=false;
while pos('</Composition>',s)=0 do begin
inc(tableau_elements_organiques[nombre_elements_organiques].nombre_composants);
setlength(tableau_elements_organiques[nombre_elements_organiques].composition,
tableau_elements_organiques[nombre_elements_organiques].nombre_composants);
tableau_elements_organiques[nombre_elements_organiques].composition[
tableau_elements_organiques[nombre_elements_organiques].nombre_composants-1].
coefficient:=strtofloat(s);
myreadln(tableau_elements_organiques[nombre_elements_organiques].composition[
tableau_elements_organiques[nombre_elements_organiques].nombre_composants-1].
element);
yaduo2:=yaduo2 or (tableau_elements_organiques[nombre_elements_organiques].composition[
tableau_elements_organiques[nombre_elements_organiques].nombre_composants-1].
element='O2(aq)');
myreadln(s);
end;
myreadln(s);
end;
      if pos('<Thermo>',s)<>0 then begin
myreadln(s); {doit contenir "logK="}
if pos('<Log K>',s)<>0 then begin
myreadln(s);
while ((pos('</Log K>',s)=0) and (s<>'')) do begin
myreadln(s1);
if s1='25' then
tableau_elements_organiques[nombre_elements_organiques].logk_25:=
strtofloat(s);
myreadln(s);
end;
myreadln(s);
end;
{s doit contenir "enthalpy"}
if pos('<Enthalpie>',s)<>0 then begin
myreadln2(tableau_elements_organiques[nombre_elements_organiques].enthalpie);
 tableau_elements_organiques[nombre_elements_organiques].enthalpie_connue:=true;
   myreadln(s); {</Enthalpie>}
   myreadln(s); {doit contenir </Thermo>}
end else  begin
 tableau_elements_organiques[nombre_elements_organiques].enthalpie:=0;
 tableau_elements_organiques[nombre_elements_organiques].enthalpie_connue:=false;
 end;

end; {de thermo}


    myreadln(s);   {</Element>}
    end;


    myreadln(s11);
    end;

       // closefile(f);
       liste_lignes_fichier_base.Free;
        inc(nombre_elements_base);
inc(nombre_elements_gazeux);
inc(nombre_elements_aqueux);
inc(nombre_elements_mineraux);
inc(nombre_elements_organiques);

{base lue en entier; maintenant, il faut determiner la nature et
la place des elements composants}
 for i:=1 to nombre_elements_gazeux do
 for j:=1 to tableau_elements_gazeux[i-1].nombre_composants do begin
 k:=indice_element_base(tableau_elements_gazeux[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_gazeux[i-1].composition[j-1].nature:=debase;
 tableau_elements_gazeux[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 145;
 end;
{ k:=indice_element_gazeux(tableau_elements_gazeux[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_gazeux[i-1].composition[j-1].nature:=gaz;
 tableau_elements_gazeux[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 145;
 end; }
 k:=indice_element_aqueux(tableau_elements_gazeux[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_gazeux[i-1].composition[j-1].nature:=aqueux;
 tableau_elements_gazeux[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 145;
 end;
 k:=indice_element_mineral(tableau_elements_gazeux[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_gazeux[i-1].composition[j-1].nature:=solide;
 tableau_elements_gazeux[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 145;
 end;
 k:=indice_element_organique(tableau_elements_gazeux[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_gazeux[i-1].composition[j-1].nature:=organique;
 tableau_elements_gazeux[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 145;
 end;

application.messagebox('element non trouve','attention',mb_ok);
       145:
      end;



       for i:=1 to nombre_elements_aqueux do
 for j:=1 to tableau_elements_aqueux[i-1].nombre_composants do begin
 k:=indice_element_base(tableau_elements_aqueux[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_aqueux[i-1].composition[j-1].nature:=debase;
 tableau_elements_aqueux[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 156;
 end;
 {k:=indice_element_gazeux(tableau_elements_aqueux[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_aqueux[i-1].composition[j-1].nature:=gaz;
 tableau_elements_aqueux[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 156;
 end; }
 k:=indice_element_aqueux(tableau_elements_aqueux[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_aqueux[i-1].composition[j-1].nature:=aqueux;
 tableau_elements_aqueux[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 156;
 end;
 k:=indice_element_mineral(tableau_elements_aqueux[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_aqueux[i-1].composition[j-1].nature:=solide;
 tableau_elements_aqueux[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 156;
 end;
 k:=indice_element_organique(tableau_elements_aqueux[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_aqueux[i-1].composition[j-1].nature:=organique;
 tableau_elements_aqueux[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 156;
 end;

application.messagebox('element non trouve','attention',mb_ok);
       156:
      end;




          for i:=1 to nombre_elements_mineraux do
 for j:=1 to tableau_elements_mineraux[i-1].nombre_composants do begin
 k:=indice_element_base(tableau_elements_mineraux[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_mineraux[i-1].composition[j-1].nature:=debase;
 tableau_elements_mineraux[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 167;
 end;
 {k:=indice_element_gazeux(tableau_elements_mineraux[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_mineraux[i-1].composition[j-1].nature:=gaz;
 tableau_elements_mineraux[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 167;
 end;  }
 k:=indice_element_aqueux(tableau_elements_mineraux[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_mineraux[i-1].composition[j-1].nature:=aqueux;
 tableau_elements_mineraux[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 167;
 end;
 k:=indice_element_mineral(tableau_elements_mineraux[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_mineraux[i-1].composition[j-1].nature:=solide;
 tableau_elements_mineraux[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 167;
 end;
 k:=indice_element_organique(tableau_elements_mineraux[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_mineraux[i-1].composition[j-1].nature:=organique;
 tableau_elements_mineraux[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 167;
 end;

application.messagebox('element non trouve','attention',mb_ok);
       167:
      end;


         for i:=1 to nombre_elements_organiques do
 for j:=1 to tableau_elements_organiques[i-1].nombre_composants do begin
 k:=indice_element_base(tableau_elements_organiques[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_organiques[i-1].composition[j-1].nature:=debase;
 tableau_elements_organiques[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 189;
 end;
 {k:=indice_element_gazeux(tableau_elements_organiques[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_organiques[i-1].composition[j-1].nature:=gaz;
 tableau_elements_organiques[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 189;
 end; }
 k:=indice_element_aqueux(tableau_elements_organiques[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_organiques[i-1].composition[j-1].nature:=aqueux;
 tableau_elements_organiques[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 189;
 end;
 k:=indice_element_mineral(tableau_elements_organiques[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_organiques[i-1].composition[j-1].nature:=solide;
 tableau_elements_organiques[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 189;
 end;
 k:=indice_element_organique(tableau_elements_organiques[i-1].composition[j-1].element);
 if k<>0 then begin
 tableau_elements_organiques[i-1].composition[j-1].nature:=organique;
 tableau_elements_organiques[i-1].composition[j-1].indice_dans_sa_base:=k;
 goto 189;
 end;

application.messagebox('element non trouve','attention',mb_ok);
       189:
      end;


      {identificaton des dependances, calcul des masses molaires et potentiels chimiques}

      repeat
tous_identifies:=true;

{les gaz}
for i:=1 to nombre_elements_gazeux do
if tableau_elements_gazeux[i-1].identifie=false then begin
tableau_elements_gazeux[i-1].identifie:=true;
tableau_elements_gazeux[i-1].masse_molaire:=0;
tableau_elements_gazeux[i-1].mu0_25:=-constante_gaz_parfaits*298.15*ln(10)*
tableau_elements_gazeux[i-1].logk_25;
setlength(tableau_elements_gazeux[i-1].composition_atomique,0);
for j:=1 to tableau_elements_gazeux[i-1].nombre_composants do begin

if tableau_elements_gazeux[i-1].composition[j-1].nature=debase then begin
tableau_elements_gazeux[i-1].masse_molaire:=
tableau_elements_gazeux[i-1].masse_molaire+
tableau_elements_gazeux[i-1].composition[j-1].coefficient*
tableau_elements_base[tableau_elements_gazeux[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_gazeux[i-1].mu0_25:=
tableau_elements_gazeux[i-1].mu0_25+
tableau_elements_gazeux[i-1].composition[j-1].coefficient*
 tableau_elements_base[tableau_elements_gazeux[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_gazeux[i-1].composition[j-1].coefficient,
  tableau_elements_gazeux[i-1].composition_atomique,
 tableau_elements_base[tableau_elements_gazeux[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 1234;
end;
if tableau_elements_gazeux[i-1].composition[j-1].nature=gaz then
if tableau_elements_gazeux[tableau_elements_gazeux[i-1].composition[j-1]
.indice_dans_sa_base-1].identifie=true then
begin
tableau_elements_gazeux[i-1].masse_molaire:=
tableau_elements_gazeux[i-1].masse_molaire+
tableau_elements_gazeux[i-1].composition[j-1].coefficient*
tableau_elements_gazeux[tableau_elements_gazeux[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_gazeux[i-1].mu0_25:=
tableau_elements_gazeux[i-1].mu0_25+
tableau_elements_gazeux[i-1].composition[j-1].coefficient*
 tableau_elements_gazeux[tableau_elements_gazeux[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_gazeux[i-1].composition[j-1].coefficient,
  tableau_elements_gazeux[i-1].composition_atomique,
 tableau_elements_gazeux[tableau_elements_gazeux[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 1234;
end;

if tableau_elements_gazeux[i-1].composition[j-1].nature=aqueux then
if tableau_elements_aqueux[tableau_elements_gazeux[i-1].composition[j-1]
.indice_dans_sa_base-1].identifie=true then
begin
tableau_elements_gazeux[i-1].masse_molaire:=
tableau_elements_gazeux[i-1].masse_molaire+
tableau_elements_gazeux[i-1].composition[j-1].coefficient*
tableau_elements_aqueux[tableau_elements_gazeux[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_gazeux[i-1].mu0_25:=
tableau_elements_gazeux[i-1].mu0_25+
tableau_elements_gazeux[i-1].composition[j-1].coefficient*
 tableau_elements_aqueux[tableau_elements_gazeux[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_gazeux[i-1].composition[j-1].coefficient,
  tableau_elements_gazeux[i-1].composition_atomique,
 tableau_elements_aqueux[tableau_elements_gazeux[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 1234;
end;

if tableau_elements_gazeux[i-1].composition[j-1].nature=solide then
if tableau_elements_mineraux[tableau_elements_gazeux[i-1].composition[j-1]
.indice_dans_sa_base-1].identifie=true then
begin
tableau_elements_gazeux[i-1].masse_molaire:=
tableau_elements_gazeux[i-1].masse_molaire+
tableau_elements_gazeux[i-1].composition[j-1].coefficient*
tableau_elements_mineraux[tableau_elements_gazeux[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_gazeux[i-1].mu0_25:=
tableau_elements_gazeux[i-1].mu0_25+
tableau_elements_gazeux[i-1].composition[j-1].coefficient*
 tableau_elements_mineraux[tableau_elements_gazeux[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_gazeux[i-1].composition[j-1].coefficient,
  tableau_elements_gazeux[i-1].composition_atomique,
 tableau_elements_mineraux[tableau_elements_gazeux[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 1234;
end;

if tableau_elements_gazeux[i-1].composition[j-1].nature=organique then
if tableau_elements_organiques[tableau_elements_gazeux[i-1].composition[j-1]
.indice_dans_sa_base-1].identifie=true then
begin
tableau_elements_gazeux[i-1].masse_molaire:=
tableau_elements_gazeux[i-1].masse_molaire+
tableau_elements_gazeux[i-1].composition[j-1].coefficient*
tableau_elements_organiques[tableau_elements_gazeux[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_gazeux[i-1].mu0_25:=
tableau_elements_gazeux[i-1].mu0_25+
tableau_elements_gazeux[i-1].composition[j-1].coefficient*
 tableau_elements_organiques[tableau_elements_gazeux[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_gazeux[i-1].composition[j-1].coefficient,
  tableau_elements_gazeux[i-1].composition_atomique,
 tableau_elements_organiques[tableau_elements_gazeux[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 1234;
end;

tableau_elements_gazeux[i-1].identifie:=false;
tous_identifies:=false;
1234:

end;   end;



{les aqueux}
for i:=1 to nombre_elements_aqueux do
if tableau_elements_aqueux[i-1].identifie=false then begin
tableau_elements_aqueux[i-1].identifie:=true;
tableau_elements_aqueux[i-1].masse_molaire:=0;
tableau_elements_aqueux[i-1].mu0_25:=-constante_gaz_parfaits*298.15*ln(10)*
tableau_elements_aqueux[i-1].logk_25;
 setlength(tableau_elements_aqueux[i-1].composition_atomique,0);


for j:=1 to tableau_elements_aqueux[i-1].nombre_composants do begin

if tableau_elements_aqueux[i-1].composition[j-1].nature=debase then begin
tableau_elements_aqueux[i-1].masse_molaire:=
tableau_elements_aqueux[i-1].masse_molaire+
tableau_elements_aqueux[i-1].composition[j-1].coefficient*
tableau_elements_base[tableau_elements_aqueux[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_aqueux[i-1].mu0_25:=
tableau_elements_aqueux[i-1].mu0_25+
tableau_elements_aqueux[i-1].composition[j-1].coefficient*
 tableau_elements_base[tableau_elements_aqueux[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_aqueux[i-1].composition[j-1].coefficient,
  tableau_elements_aqueux[i-1].composition_atomique,
 tableau_elements_base[tableau_elements_aqueux[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 2345;
end;
if tableau_elements_aqueux[i-1].composition[j-1].nature=gaz then
if tableau_elements_gazeux[tableau_elements_aqueux[i-1].composition[j-1]
.indice_dans_sa_base-1].identifie=true then
begin
tableau_elements_aqueux[i-1].masse_molaire:=
tableau_elements_aqueux[i-1].masse_molaire+
tableau_elements_aqueux[i-1].composition[j-1].coefficient*
tableau_elements_gazeux[tableau_elements_aqueux[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_aqueux[i-1].mu0_25:=
tableau_elements_aqueux[i-1].mu0_25+
tableau_elements_aqueux[i-1].composition[j-1].coefficient*
 tableau_elements_gazeux[tableau_elements_aqueux[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_aqueux[i-1].composition[j-1].coefficient,
  tableau_elements_aqueux[i-1].composition_atomique,
 tableau_elements_gazeux[tableau_elements_aqueux[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 2345;
end;

if tableau_elements_aqueux[i-1].composition[j-1].nature=aqueux then
if tableau_elements_aqueux[tableau_elements_aqueux[i-1].composition[j-1]
.indice_dans_sa_base-1].identifie=true then
begin
tableau_elements_aqueux[i-1].masse_molaire:=
tableau_elements_aqueux[i-1].masse_molaire+
tableau_elements_aqueux[i-1].composition[j-1].coefficient*
tableau_elements_aqueux[tableau_elements_aqueux[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_aqueux[i-1].mu0_25:=
tableau_elements_aqueux[i-1].mu0_25+
tableau_elements_aqueux[i-1].composition[j-1].coefficient*
 tableau_elements_aqueux[tableau_elements_aqueux[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_aqueux[i-1].composition[j-1].coefficient,
  tableau_elements_aqueux[i-1].composition_atomique,
 tableau_elements_aqueux[tableau_elements_aqueux[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 2345;
end;

if tableau_elements_aqueux[i-1].composition[j-1].nature=solide then
if tableau_elements_mineraux[tableau_elements_aqueux[i-1].composition[j-1]
.indice_dans_sa_base-1].identifie=true then
begin
tableau_elements_aqueux[i-1].masse_molaire:=
tableau_elements_aqueux[i-1].masse_molaire+
tableau_elements_aqueux[i-1].composition[j-1].coefficient*
tableau_elements_mineraux[tableau_elements_aqueux[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_aqueux[i-1].mu0_25:=
tableau_elements_aqueux[i-1].mu0_25+
tableau_elements_aqueux[i-1].composition[j-1].coefficient*
 tableau_elements_mineraux[tableau_elements_aqueux[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_aqueux[i-1].composition[j-1].coefficient,
  tableau_elements_aqueux[i-1].composition_atomique,
 tableau_elements_mineraux[tableau_elements_aqueux[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 2345;
end;

if tableau_elements_aqueux[i-1].composition[j-1].nature=organique then
if tableau_elements_organiques[tableau_elements_aqueux[i-1].composition[j-1]
.indice_dans_sa_base-1].identifie=true then
begin
tableau_elements_aqueux[i-1].masse_molaire:=
tableau_elements_aqueux[i-1].masse_molaire+
tableau_elements_aqueux[i-1].composition[j-1].coefficient*
tableau_elements_organiques[tableau_elements_aqueux[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_aqueux[i-1].mu0_25:=
tableau_elements_aqueux[i-1].mu0_25+
tableau_elements_aqueux[i-1].composition[j-1].coefficient*
 tableau_elements_organiques[tableau_elements_aqueux[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_aqueux[i-1].composition[j-1].coefficient,
  tableau_elements_aqueux[i-1].composition_atomique,
 tableau_elements_organiques[tableau_elements_aqueux[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 2345;
end;

tableau_elements_aqueux[i-1].identifie:=false;
tous_identifies:=false;
2345:
end;   end;




{les solides}
for i:=1 to nombre_elements_mineraux do
if tableau_elements_mineraux[i-1].identifie=false then begin
tableau_elements_mineraux[i-1].identifie:=true;
tableau_elements_mineraux[i-1].masse_molaire:=0;
tableau_elements_mineraux[i-1].mu0_25:=-constante_gaz_parfaits*298.15*ln(10)*
tableau_elements_mineraux[i-1].logk_25;
setlength(tableau_elements_mineraux[i-1].composition_atomique,0);

for j:=1 to tableau_elements_mineraux[i-1].nombre_composants do begin

if tableau_elements_mineraux[i-1].composition[j-1].nature=debase then begin
tableau_elements_mineraux[i-1].masse_molaire:=
tableau_elements_mineraux[i-1].masse_molaire+
tableau_elements_mineraux[i-1].composition[j-1].coefficient*
tableau_elements_base[tableau_elements_mineraux[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_mineraux[i-1].mu0_25:=
tableau_elements_mineraux[i-1].mu0_25+
tableau_elements_mineraux[i-1].composition[j-1].coefficient*
 tableau_elements_base[tableau_elements_mineraux[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_mineraux[i-1].composition[j-1].coefficient,
  tableau_elements_mineraux[i-1].composition_atomique,
 tableau_elements_base[tableau_elements_mineraux[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 3456;
end;
if tableau_elements_mineraux[i-1].composition[j-1].nature=gaz then
if tableau_elements_gazeux[tableau_elements_mineraux[i-1].composition[j-1]
.indice_dans_sa_base-1].identifie=true then
begin
tableau_elements_mineraux[i-1].masse_molaire:=
tableau_elements_mineraux[i-1].masse_molaire+
tableau_elements_mineraux[i-1].composition[j-1].coefficient*
tableau_elements_gazeux[tableau_elements_mineraux[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_mineraux[i-1].mu0_25:=
tableau_elements_mineraux[i-1].mu0_25+
tableau_elements_mineraux[i-1].composition[j-1].coefficient*
 tableau_elements_gazeux[tableau_elements_mineraux[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_mineraux[i-1].composition[j-1].coefficient,
  tableau_elements_mineraux[i-1].composition_atomique,
 tableau_elements_gazeux[tableau_elements_mineraux[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 3456;
end;

if tableau_elements_mineraux[i-1].composition[j-1].nature=aqueux then
if tableau_elements_aqueux[tableau_elements_mineraux[i-1].composition[j-1]
.indice_dans_sa_base-1].identifie=true then
begin
tableau_elements_mineraux[i-1].masse_molaire:=
tableau_elements_mineraux[i-1].masse_molaire+
tableau_elements_mineraux[i-1].composition[j-1].coefficient*
tableau_elements_aqueux[tableau_elements_mineraux[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_mineraux[i-1].mu0_25:=
tableau_elements_mineraux[i-1].mu0_25+
tableau_elements_mineraux[i-1].composition[j-1].coefficient*
 tableau_elements_aqueux[tableau_elements_mineraux[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_mineraux[i-1].composition[j-1].coefficient,
  tableau_elements_mineraux[i-1].composition_atomique,
 tableau_elements_aqueux[tableau_elements_mineraux[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 3456;
end;

if tableau_elements_mineraux[i-1].composition[j-1].nature=solide then
if tableau_elements_mineraux[tableau_elements_mineraux[i-1].composition[j-1]
.indice_dans_sa_base-1].identifie=true then
begin
tableau_elements_mineraux[i-1].masse_molaire:=
tableau_elements_mineraux[i-1].masse_molaire+
tableau_elements_mineraux[i-1].composition[j-1].coefficient*
tableau_elements_mineraux[tableau_elements_mineraux[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_mineraux[i-1].mu0_25:=
tableau_elements_mineraux[i-1].mu0_25+
tableau_elements_mineraux[i-1].composition[j-1].coefficient*
 tableau_elements_mineraux[tableau_elements_mineraux[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_mineraux[i-1].composition[j-1].coefficient,
  tableau_elements_mineraux[i-1].composition_atomique,
 tableau_elements_mineraux[tableau_elements_mineraux[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 3456;
end;

if tableau_elements_mineraux[i-1].composition[j-1].nature=organique then
if tableau_elements_organiques[tableau_elements_mineraux[i-1].composition[j-1]
.indice_dans_sa_base-1].identifie=true then
begin
tableau_elements_mineraux[i-1].masse_molaire:=
tableau_elements_mineraux[i-1].masse_molaire+
tableau_elements_mineraux[i-1].composition[j-1].coefficient*
tableau_elements_organiques[tableau_elements_mineraux[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_mineraux[i-1].mu0_25:=
tableau_elements_mineraux[i-1].mu0_25+
tableau_elements_mineraux[i-1].composition[j-1].coefficient*
 tableau_elements_organiques[tableau_elements_mineraux[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_mineraux[i-1].composition[j-1].coefficient,
  tableau_elements_mineraux[i-1].composition_atomique,
 tableau_elements_organiques[tableau_elements_mineraux[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 3456;
end;

tableau_elements_mineraux[i-1].identifie:=false;
tous_identifies:=false;
3456:
end;   end;




{les organiques}
for i:=1 to nombre_elements_organiques do
if tableau_elements_organiques[i-1].identifie=false then begin
tableau_elements_organiques[i-1].identifie:=true;
tableau_elements_organiques[i-1].masse_molaire:=0;
tableau_elements_organiques[i-1].mu0_25:=-constante_gaz_parfaits*298.15*ln(10)*
tableau_elements_organiques[i-1].logk_25;
setlength(tableau_elements_organiques[i-1].composition_atomique,0);
for j:=1 to tableau_elements_organiques[i-1].nombre_composants do begin

if tableau_elements_organiques[i-1].composition[j-1].nature=debase then begin
tableau_elements_organiques[i-1].masse_molaire:=
tableau_elements_organiques[i-1].masse_molaire+
tableau_elements_organiques[i-1].composition[j-1].coefficient*
tableau_elements_base[tableau_elements_organiques[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_organiques[i-1].mu0_25:=
tableau_elements_organiques[i-1].mu0_25+
tableau_elements_organiques[i-1].composition[j-1].coefficient*
 tableau_elements_base[tableau_elements_organiques[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_organiques[i-1].composition[j-1].coefficient,
  tableau_elements_organiques[i-1].composition_atomique,
 tableau_elements_base[tableau_elements_organiques[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 5678;
end;
if tableau_elements_organiques[i-1].composition[j-1].nature=gaz then
if tableau_elements_gazeux[tableau_elements_organiques[i-1].composition[j-1]
.indice_dans_sa_base-1].identifie=true then
begin
tableau_elements_organiques[i-1].masse_molaire:=
tableau_elements_organiques[i-1].masse_molaire+
tableau_elements_organiques[i-1].composition[j-1].coefficient*
tableau_elements_gazeux[tableau_elements_organiques[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_organiques[i-1].mu0_25:=
tableau_elements_organiques[i-1].mu0_25+
tableau_elements_organiques[i-1].composition[j-1].coefficient*
 tableau_elements_gazeux[tableau_elements_organiques[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_organiques[i-1].composition[j-1].coefficient,
  tableau_elements_organiques[i-1].composition_atomique,
 tableau_elements_gazeux[tableau_elements_organiques[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 5678;
end;

if tableau_elements_organiques[i-1].composition[j-1].nature=aqueux then
if tableau_elements_aqueux[tableau_elements_organiques[i-1].composition[j-1]
.indice_dans_sa_base-1].identifie=true then
begin
tableau_elements_organiques[i-1].masse_molaire:=
tableau_elements_organiques[i-1].masse_molaire+
tableau_elements_organiques[i-1].composition[j-1].coefficient*
tableau_elements_aqueux[tableau_elements_organiques[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_organiques[i-1].mu0_25:=
tableau_elements_organiques[i-1].mu0_25+
tableau_elements_organiques[i-1].composition[j-1].coefficient*
 tableau_elements_aqueux[tableau_elements_organiques[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_organiques[i-1].composition[j-1].coefficient,
  tableau_elements_organiques[i-1].composition_atomique,
 tableau_elements_aqueux[tableau_elements_organiques[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 5678;
end;

if tableau_elements_organiques[i-1].composition[j-1].nature=solide then
if tableau_elements_mineraux[tableau_elements_organiques[i-1].composition[j-1]
.indice_dans_sa_base-1].identifie=true then
begin
tableau_elements_organiques[i-1].masse_molaire:=
tableau_elements_organiques[i-1].masse_molaire+
tableau_elements_organiques[i-1].composition[j-1].coefficient*
tableau_elements_mineraux[tableau_elements_organiques[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_organiques[i-1].mu0_25:=
tableau_elements_organiques[i-1].mu0_25+
tableau_elements_organiques[i-1].composition[j-1].coefficient*
 tableau_elements_mineraux[tableau_elements_organiques[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_organiques[i-1].composition[j-1].coefficient,
  tableau_elements_organiques[i-1].composition_atomique,
 tableau_elements_mineraux[tableau_elements_organiques[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 5678;
end;

if tableau_elements_organiques[i-1].composition[j-1].nature=organique then
if tableau_elements_organiques[tableau_elements_organiques[i-1].composition[j-1]
.indice_dans_sa_base-1].identifie=true then
begin
tableau_elements_organiques[i-1].masse_molaire:=
tableau_elements_organiques[i-1].masse_molaire+
tableau_elements_organiques[i-1].composition[j-1].coefficient*
tableau_elements_organiques[tableau_elements_organiques[i-1].
composition[j-1].indice_dans_sa_base-1].masse_molaire;
tableau_elements_organiques[i-1].mu0_25:=
tableau_elements_organiques[i-1].mu0_25+
tableau_elements_organiques[i-1].composition[j-1].coefficient*
 tableau_elements_organiques[tableau_elements_organiques[i-1].
composition[j-1].indice_dans_sa_base-1].mu0_25;
ajoute_xfois_composition_atomique_a_composition_atomique
(tableau_elements_organiques[i-1].composition[j-1].coefficient,
  tableau_elements_organiques[i-1].composition_atomique,
 tableau_elements_organiques[tableau_elements_organiques[i-1].
composition[j-1].indice_dans_sa_base-1].composition_atomique);
goto 5678;
end;

tableau_elements_organiques[i-1].identifie:=false;
tous_identifies:=false;
5678:
end;   end;

until tous_identifies=true;

for i:=1 to nombre_elements_base do  begin
TrieArrayComposeurAtomique(tableau_elements_base[i-1].composition_atomique);
tableau_elements_base[i-1].nombre_composants:=
length(tableau_elements_base[i-1].composition_atomique);
end;

for i:=1 to nombre_elements_gazeux do  begin
TrieArrayComposeurAtomique(tableau_elements_gazeux[i-1].composition_atomique);
tableau_elements_gazeux[i-1].nombre_composants_atomiques:=
length(tableau_elements_gazeux[i-1].composition_atomique);
end;
for i:=1 to nombre_elements_aqueux do    begin
TrieArrayComposeurAtomique(tableau_elements_aqueux[i-1].composition_atomique);
tableau_elements_aqueux[i-1].nombre_composants_atomiques:=
length(tableau_elements_aqueux[i-1].composition_atomique);
end;
for i:=1 to nombre_elements_mineraux do  begin
TrieArrayComposeurAtomique(tableau_elements_mineraux[i-1].composition_atomique);
tableau_elements_mineraux[i-1].nombre_composants_atomiques:=
length(tableau_elements_mineraux[i-1].composition_atomique);
end;
for i:=1 to nombre_elements_organiques do   begin
TrieArrayComposeurAtomique(tableau_elements_organiques[i-1].composition_atomique);
tableau_elements_organiques[i-1].nombre_composants_atomiques:=
length(tableau_elements_organiques[i-1].composition_atomique);
                             end;

setlength(elements_base_presents,length(tableau_elements_base));
setlength(elements_gazeux_presents,length(tableau_elements_gazeux));
setlength(elements_aqueux_presents,length(tableau_elements_aqueux));
setlength(elements_solides_presents,length(tableau_elements_mineraux));
setlength(elements_organiques_presents,length(tableau_elements_organiques));
 {on complete les tableaux destines a une partie de l'affichage}
for i:=1 to nb_ab do
case   donnenaturereactif(tableau_ab[i-1].identifiant,k) of
debase: begin
tableau_ab[i-1].masse_molaire:=tableau_elements_base[k-1].masse_molaire;
tableau_ab[i-1].synonyme:=tableau_elements_base[k-1].synonyme;
tableau_ab[i-1].conductivite:=tableau_elements_base[k-1].conductivite;
tableau_ab[i-1].charge:=tableau_elements_base[k-1].charge;
end;
aqueux: begin
tableau_ab[i-1].masse_molaire:=tableau_elements_aqueux[k-1].masse_molaire;
tableau_ab[i-1].synonyme:=tableau_elements_aqueux[k-1].synonyme;
tableau_ab[i-1].conductivite:=tableau_elements_aqueux[k-1].conductivite;
tableau_ab[i-1].charge:=tableau_elements_aqueux[k-1].charge;
end;
end;
for i:=1 to nb_anions_simples do
case   donnenaturereactif(tableau_anions_simples[i-1].identifiant,k) of
debase: begin
tableau_anions_simples[i-1].masse_molaire:=tableau_elements_base[k-1].masse_molaire;
tableau_anions_simples[i-1].synonyme:=tableau_elements_base[k-1].synonyme;
tableau_anions_simples[i-1].conductivite:=tableau_elements_base[k-1].conductivite;
tableau_anions_simples[i-1].charge:=tableau_elements_base[k-1].charge;
end;
aqueux: begin
tableau_anions_simples[i-1].masse_molaire:=tableau_elements_aqueux[k-1].masse_molaire;
tableau_anions_simples[i-1].synonyme:=tableau_elements_aqueux[k-1].synonyme;
tableau_anions_simples[i-1].conductivite:=tableau_elements_aqueux[k-1].conductivite;
tableau_anions_simples[i-1].charge:=tableau_elements_aqueux[k-1].charge;
end;
end;
for i:=1 to nb_cations_simples do
case   donnenaturereactif(tableau_cations_simples[i-1].identifiant,k) of
debase: begin
tableau_cations_simples[i-1].masse_molaire:=tableau_elements_base[k-1].masse_molaire;
tableau_cations_simples[i-1].synonyme:=tableau_elements_base[k-1].synonyme;
tableau_cations_simples[i-1].conductivite:=tableau_elements_base[k-1].conductivite;
tableau_cations_simples[i-1].charge:=tableau_elements_base[k-1].charge;
end;
aqueux: begin
tableau_cations_simples[i-1].masse_molaire:=tableau_elements_aqueux[k-1].masse_molaire;
tableau_cations_simples[i-1].synonyme:=tableau_elements_aqueux[k-1].synonyme;
tableau_cations_simples[i-1].conductivite:=tableau_elements_aqueux[k-1].conductivite;
tableau_cations_simples[i-1].charge:=tableau_elements_aqueux[k-1].charge;
end;
end;
for i:=1 to nb_complexes do
case   donnenaturereactif(tableau_complexes[i-1].identifiant,k) of
debase: begin
tableau_complexes[i-1].masse_molaire:=tableau_elements_base[k-1].masse_molaire;
tableau_complexes[i-1].synonyme:=tableau_elements_base[k-1].synonyme;
tableau_complexes[i-1].conductivite:=tableau_elements_base[k-1].conductivite;
tableau_complexes[i-1].charge:=tableau_elements_base[k-1].charge;
end;
aqueux: begin
tableau_complexes[i-1].masse_molaire:=tableau_elements_aqueux[k-1].masse_molaire;
tableau_complexes[i-1].synonyme:=tableau_elements_aqueux[k-1].synonyme;
tableau_complexes[i-1].conductivite:=tableau_elements_aqueux[k-1].conductivite;
tableau_complexes[i-1].charge:=tableau_elements_aqueux[k-1].charge;
end;
end;
for i:=1 to nb_ions do
case   donnenaturereactif(tableau_ions[i-1].identifiant,k) of
debase: begin
tableau_ions[i-1].masse_molaire:=tableau_elements_base[k-1].masse_molaire;
tableau_ions[i-1].synonyme:=tableau_elements_base[k-1].synonyme;
tableau_ions[i-1].conductivite:=tableau_elements_base[k-1].conductivite;
tableau_ions[i-1].charge:=tableau_elements_base[k-1].charge;
end;
aqueux: begin
tableau_ions[i-1].masse_molaire:=tableau_elements_aqueux[k-1].masse_molaire;
tableau_ions[i-1].synonyme:=tableau_elements_aqueux[k-1].synonyme;
tableau_ions[i-1].conductivite:=tableau_elements_aqueux[k-1].conductivite;
tableau_ions[i-1].charge:=tableau_elements_aqueux[k-1].charge;
end;
end;
for i:=1 to nb_molecules do
case   donnenaturereactif(tableau_molecules[i-1].identifiant,k) of
debase: begin
tableau_molecules[i-1].masse_molaire:=tableau_elements_base[k-1].masse_molaire;
tableau_molecules[i-1].synonyme:=tableau_elements_base[k-1].synonyme;
tableau_molecules[i-1].conductivite:=tableau_elements_base[k-1].conductivite;
tableau_molecules[i-1].charge:=tableau_elements_base[k-1].charge;
end;
aqueux: begin
tableau_molecules[i-1].masse_molaire:=tableau_elements_aqueux[k-1].masse_molaire;
tableau_molecules[i-1].synonyme:=tableau_elements_aqueux[k-1].synonyme;
tableau_molecules[i-1].conductivite:=tableau_elements_aqueux[k-1].conductivite;
tableau_molecules[i-1].charge:=tableau_elements_aqueux[k-1].charge;
end;
end;


 end;













procedure reecrit_liste_lignes_base_dapres_tableaux;
var i,j,k,popo_debut,popo_fin:integer;  l1:tstringlist; TempStream : TMemoryStream;
begin
 l1:=tstringlist.Create;
  TempStream := TMemoryStream.Create;
  liste_lignes_base.SaveToStream(TempStream);
  TempStream.Position := 0;
  l1.LoadFromStream( TempStream);
      TempStream.Free;
   liste_lignes_base.Clear;
  liste_lignes_base.add('<Version>');
inc(version);
liste_lignes_base.Add(inttostr(version));
liste_lignes_base.add('</Version>');
liste_lignes_base.add('<Date>');
liste_lignes_base.add(DateTimeToStr(Now));
liste_lignes_base.add('</Date>');
liste_lignes_base.add('<Base>');

for k:=1 to nombre_elements_base do begin
     i:=0;
repeat
inc(i);
until ((i=l1.Count) or ((l1[i]=tableau_elements_base[k-1].identifiant) and
 (l1[i-1]='<Identifiant>')));
 if i=l1.Count then begin
 exit;
 end;
 popo_debut:=i-2;
  repeat inc(i); until l1[i]='</Element>';
  popo_fin:=i;

  for i:=popo_debut to popo_fin do
 liste_lignes_base.add(l1[i]);
end;

for k:=1 to nombre_elements_aqueux do begin
     i:=0;
repeat
inc(i);
until ((i=l1.Count) or ((l1[i]=tableau_elements_aqueux[k-1].identifiant) and
 (l1[i-1]='<Identifiant>')));
 if i=l1.Count then begin
 exit;
 end;
 popo_debut:=i-2;
  repeat inc(i); until l1[i]='</Element>';
  popo_fin:=i;

  for i:=popo_debut to popo_fin do
 liste_lignes_base.add(l1[i]);
end;

for k:=1 to nombre_elements_mineraux do begin
     i:=0;
repeat
inc(i);
until ((i=l1.Count) or ((l1[i]=tableau_elements_mineraux[k-1].identifiant) and
 (l1[i-1]='<Identifiant>')));
 if i=l1.Count then begin
 exit;
 end;
 popo_debut:=i-2;
  repeat inc(i); until l1[i]='</Element>';
  popo_fin:=i;

  for i:=popo_debut to popo_fin do
 liste_lignes_base.add(l1[i]);
end;

for k:=1 to nombre_elements_organiques do begin
     i:=0;
repeat
inc(i);
until ((i=l1.Count) or ((l1[i]=tableau_elements_organiques[k-1].identifiant) and
 (l1[i-1]='<Identifiant>')));
 if i=l1.Count then begin
 exit;
 end;
 popo_debut:=i-2;
  repeat inc(i); until l1[i]='</Element>';
  popo_fin:=i;

  for i:=popo_debut to popo_fin do
 liste_lignes_base.add(l1[i]);
end;
liste_lignes_base.add('</Base>');
l1.Free;
end;





initialization
  {$I modif_1.lrs}
  repertoire_executable:=AppendPathDelim(extractfilepath(Application.ExeName));
end.

